﻿;================================================================================================================================================================================
; Copy the icon into memory while deleting the original image copied from
;================================================================================================================================================================================

; Procedure.i GetIconHandle(ImageConstant.i)
;   ;------------------------------------------------------------------------------------------------
;   ; Copy the icon, delete the original. Don't use if you are using form icon handles!!
;   ;------------------------------------------------------------------------------------------------
;   ; ProcedureReturn CopyImage_(ImageID(ImageConstant.i), #IMAGE_ICON, 48, 48, #LR_COPYDELETEORG)   ;  1, 8
;   ;------------------------------------------------------------------------------------------------
;   ; Copy the icon to be used, leave the original intact
;   ;------------------------------------------------------------------------------------------------
;   ProcedureReturn CopyImage_(ImageID(ImageConstant.i), #IMAGE_ICON, 48, 48, 0)                  ; 1, 8
;   ;------------------------------------------------------------------------------------------------
;   ; 
;   ;------------------------------------------------------------------------------------------------
; EndProcedure

;================================================================================================================================================================================
; Copy the icon into memory while deleting the original image copied from. RASHAD's modification
;================================================================================================================================================================================

Procedure.i GetIconHandle(ImageConstant.i)

  ;------------------------------------------------------------------------------------------------
  ; RASHAD's version of the GetIconHandle routine
  ;------------------------------------------------------------------------------------------------
  
  iinf.ICONINFO
  
  iinf\fIcon    = 1

  iinf\hbmMask  = ImageID(ImageConstant)
  
  iinf\hbmColor = ImageID(ImageConstant)
  
  IconHandle0.i = CreateIconIndirect_(iinf)
  
  ;------------------------------------------------------------------------------------------------
  ; Copy the icon to be used, leave the original intact, Larger images in tooltip
  ;------------------------------------------------------------------------------------------------
  
  ;CopyImage_(IconHandle0.i, #IMAGE_ICON, 48, 48, 0)                  ; 1, 8
  
  ;------------------------------------------------------------------------------------------------
  ; Copy the icon to be used, leave the original intact. Smaller images in tooltip
  ;------------------------------------------------------------------------------------------------

  ProcedureReturn CopyImage_(IconHandle0.i, #IMAGE_ICON, 32, 32, 0)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure
; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 19
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP