﻿;==============================================================================================================================================================================
; Setup the search box cue text for stringgadgets and comboboxes
;==============================================================================================================================================================================

Procedure SetSearchCue(CueText.s, StringGadget.i, ComboGadget.i = 0)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If ComboGadget.i <> 0

    CurrentField.s = "Search " + GetGadgetText(ComboGadget.i)
    
  ElseIf ComboGadget.i = 0
    
    CurrentField.s  = CueText.s
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(StringGadget.i), #EM_SETLIMITTEXT, 67, 0)
  
  SendMessage_(GadgetID(StringGadget.i), #EM_SETCUEBANNER,  1,  CurrentField.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP