﻿;==============================================================================================================================================================================
; Window snap, strikeoutfont and more
;==============================================================================================================================================================================

Procedure WindowCallback(WindowID, Message, wParam, lParam)
 
  ;------------------------------------------------------------------------------------------------
  ; Netmaestro's windowsnap code
  ;------------------------------------------------------------------------------------------------

  Static snapped1, snapped2, snapped3, snapped4
 
  ;------------------------------------------------------------------------------------------------
  ; Sparkie's strikeout section
  ;------------------------------------------------------------------------------------------------
 
  Static oldFont
 
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------

  ReturnValue = #PB_ProcessPureBasicEvents
 
  ;------------------------------------------------------------------------------------------------
  ; RASHAD's background colour support
  ;------------------------------------------------------------------------------------------------

  Select Message

    ;----------------------------------------------------------------------------------------------
    ; Turn strikeout off and on as needed
    ;----------------------------------------------------------------------------------------------
   
    Case #WM_NOTIFY
     
      ;--------------------------------------------------------------------------------------------
      ; RASHAD. Added for custom search routine in keyboard shortcuts listicongadget
      ;--------------------------------------------------------------------------------------------
     
      ;       *lvCD.NMLVCUSTOMDRAW = lParam
      ;      
      ;       If IsGadget(#Gadget_Shortcuts_Shortcuts) And *lvCD\nmcd\hdr\hwndFrom = GadgetID(#Gadget_Shortcuts_Shortcuts) And *lvCD\nmcd\hdr\code = #NM_CUSTOMDRAW
      ;        
      ;         ReturnValue = ShortcutsCallback(WindowID, Message, wParam, lParam)
      ;        
      ;       EndIf
     
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
     
      *nmhdr.NMHDR = lParam
     
      *lvCD.NMLVCUSTOMDRAW = lParam
     
      If *lvCD\nmcd\hdr\hwndFrom = GadgetID(#Gadget_Mystuff_Itemlist) And *lvCD\nmcd\hdr\code = #NM_CUSTOMDRAW
       
        Select *lvCD\nmcd\dwDrawStage
           
          Case #CDDS_PREPAINT
           
            result = #CDRF_NOTIFYITEMDRAW
           
          Case #CDDS_ITEMPREPAINT
           
            result = #CDRF_NOTIFYSUBITEMDRAW;
           
          Case #CDDS_ITEMPREPAINT | #CDDS_SUBITEM
           
            thisRow = *lvCD\nmcd\dwItemSpec
           
            thisCol = *lvCD\iSubItem
           
            on_off = GetGadgetItemData(#Gadget_Mystuff_Itemlist, thisRow)
           
            If thisCol = 0 And on_off   ;****** For Column 1 ***** you can change 1 to 0 - 2
             
              SelectObject_(*lvCD\nmcd\hdc, FontID(#FontStrikeoutYes))
             
              result = #CDRF_NEWFONT; | #CDRF_DODEFAULT
             
            Else
             
              SelectObject_(*lvCD\nmcd\hdc, FontID(#FontStrikeoutNo))
             
              result = #CDRF_NEWFONT   
             
            EndIf
           
        EndSelect
       
      EndIf
     
    ;----------------------------------------------------------------------------------------------
    ; RASHAD code to help colour static controls not supported by pb natively
    ;----------------------------------------------------------------------------------------------
   
;     Case #WM_CTLCOLORSTATIC
;    
;       Select GetProp_(lParam, "PB_ID")
;      
;         Case #Gadget_Data_cbFavourite, #Gadget_Data_cbSelected
;          
;           ReturnValue = Program\BackgroundColour
;          
;         Case #Gadget_Find_oSortAcending,  #Gadget_Find_oSortDescending, #Gadget_Find_cbQueryReturnLimit
;          
;           ReturnValue = Program\BackgroundColour
;          
;         Case #Gadget_Find_sQueryReturnLimit,  #Gadget_Find_cbCheckEnter,  #Gadget_Find_oCheckOr,  #Gadget_Find_oCheckAnd
;          
;           ReturnValue = Program\BackgroundColour
;          
;         Case #Gadget_Setup_cbDeleteAfterImport,  #Gadget_Setup_cbFixTitleCaseImport,  #Gadget_Setup_cbShowImportCounter,  #Gadget_Setup_cbQueryReturnLimit,  #Gadget_Setup_sQueryReturnSize,  #Gadget_Setup_cbCleanBadCharacters
;          
;           ReturnValue = Program\BackgroundColour
;          
;       EndSelect

      ;--------------------------------------------------------------------------------------------
      ; Netmaestro's windowsnap code
      ;--------------------------------------------------------------------------------------------
     
    Case #WM_MOVING
     
      If Option\Snapformtoborders = #True
       
        *view.RECT = lparam
       
        curwidth  = *view\right - *view\left
       
        curheight = *view\bottom - *view\top
       
        If AutoSnap                                                                         ;  AutoSnap Section
         
          If *view\left < SnapD
           
            If Not Snapped1
             
              *view\left = 0
             
              *view\right = curwidth
             
              snapped1 = #True
             
              ReturnValue = #True
             
            EndIf
           
          Else
           
            snapped1 = #False
           
          EndIf
         
          If *view\top < SnapD
           
            If Not Snapped2
             
              *view\top = 0
             
              *view\bottom = curheight
             
              snapped2 = #True
             
              ReturnValue = #True
             
            EndIf
           
          Else
           
            snapped2 = #False
           
          EndIf
         
          If *view\right > screenw - SnapD
           
            If Not Snapped3
             
              *view\left  = ScreenW - curwidth
             
              *view\right = screenW
             
              snapped3 = #True
             
              ReturnValue = #True
             
            EndIf
           
          Else
           
            snapped3 = #False
           
          EndIf     
         
          If *view\bottom > screenH - SnapD
           
            If Not Snapped4
             
              *view\top = screenH - curheight
             
              *view\bottom = screenH
             
              snapped4 = #True
             
              ReturnValue = #True
             
            EndIf
           
          Else
           
            snapped4 = #False
           
          EndIf     
         
        EndIf
       
        If *view\top < 0                                                                    ;  Inside Desktop Section
         
          *view\top = 0
         
          *view\bottom = curheight
         
        EndIf
       
        If *view\left < 0
         
          *view\left = 0
         
          *view\right = curwidth
         
        EndIf
       
        If *view\right > screenW
         
          *view\right = screenW
         
          *view\left = *view\right - curwidth
         
        EndIf
       
        If *view\bottom > screenH
         
          *view\bottom = screenH
         
          *view\top = *view\bottom - curheight
         
        EndIf
       
        MoveWindow_(WindowID, *view\left, *view\top, *view\right - *view\left, *view\bottom - *view\top, #True)
       
        ReturnValue = #True
       
      EndIf

  EndSelect
 
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
 
  ProcedureReturn ReturnValue
 
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
 
EndProcedure
; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 237
; FirstLine = 232
; Folding = -
; EnableXP
; CompileSourceDirectory