﻿;================================================================================================================================================================================
; Fill a combobox gadget from a linked list, SQLite version
;================================================================================================================================================================================

Procedure FillCombo(Gadget.i, DatabaseQuery.s, ColumnIcon.i = #False)
  
;   If Not IsGadget(Gadget.i)
;     Debug DatabaseQuery.s
;     ProcedureReturn
;   EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ClearGadgetItems(Gadget.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
    
    While NextDatabaseRow(Program\DatabaseHandle)
      
      Combostring.s = ReplaceString(GetDatabaseString(Program\DatabaseHandle, 0), "''", "'", 1, 1)
      
      If Combostring.s <> #EmptyString
        
        If ColumnIcon.i <> #False
          
          AddGadgetItem(Gadget.i, #AtTheEndOfTheList, Combostring.s, ImageID(ColumnIcon.i))
          
        Else
          
          AddGadgetItem(Gadget.i, #AtTheEndOfTheList, Combostring.s)
          
        EndIf
        
      EndIf
      
    Wend
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 5
; FirstLine = 5
; Folding = -
; EnableXP