﻿;================================================================================================================================================================================
; Find the last record number in the database, not necessarily the last record though due to deletions (fang)
;================================================================================================================================================================================

Procedure.s LastRecord(TableField.s, TableName.s)

  ;------------------------------------------------------------------------------------------------
  ; Always create long winded queries for readability
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s = "SELECT MAX(" + TableField.s + ") AS LASTREC FROM " + TableName.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, QueryString.s) <> #DatabaseQueryFail

    While NextDatabaseRow(Program\DatabaseHandle)
    
      LastRecord.s = GetDatabaseString(Program\DatabaseHandle,  0)
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ProcedureReturn LastRecord.s
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------

  Else
    
    SetInfoBarArea("Headings",  "Error", "Failed to get the last record inserted: " + DatabaseError(), #PB_Compiler_Procedure)
    
  EndIf  

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 42
; FirstLine = 12
; Folding = -
; EnableXP