﻿;================================================================================================================================================================================
; Alias the search type text to SQLite operators
;================================================================================================================================================================================

Procedure.s SetSearchQuery(SearchOperator.s, SearchString.s)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  Select SearchOperator.s

    Case "Equal to"                 : QueryString.s = " = '"      + SearchString.s + "'"

    Case "Does not equal"           : QueryString.s = " <> '"     + SearchString.s + "'"

    Case "Greater than"             : QueryString.s = " > '"      + SearchString.s + "'"

    Case "Greater than or equal to" : QueryString.s = " >= '"     + SearchString.s + "'"

    Case "Less than"                : QueryString.s = " < '"      + SearchString.s + "'"

    Case "Less than or equal to"    : QueryString.s = " <= '"     + SearchString.s + "'"

    Case "Starts with"              : QueryString.s = " LIKE '"   + SearchString.s + "%'"

    Case "Ends with"                : QueryString.s = " LIKE '%"  + SearchString.s + "'"

    Case "Sounds like"              : QueryString.s = " LIKE '%"  + SearchString.s + "%'"

  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  ProcedureReturn QueryString.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 1
; FirstLine = 3
; Folding = -
; EnableXP