﻿;==============================================================================================================================================================================
; Universal, recursive search engine used by many functions
;==============================================================================================================================================================================

Procedure ImportMyDocuments()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SearchDirectory.s = PathRequester("Import documents", "D:\Process to home inventory")
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If SearchDirectory.s  <> #EmptyString
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Numberofitems.i = CountGadgetItems(#Gadget_Mystuff_Itemlist)  - 1
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    NewList FoundDirectories.s()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If SearchDirectory.s <> #EmptyString
      
      If Right(SearchDirectory.s, 1) = "\"
        
        SearchDirectory.s = Left(SearchDirectory.s, Len(SearchDirectory.s) - 1)
        
      EndIf
      
      AddElement(FoundDirectories.s())
      
      FoundDirectories.s() = SearchDirectory.s
      
      IndexLevel.i = 0
      
      Repeat
        
        SelectElement(FoundDirectories.s(), IndexLevel.i)
        
        If ExamineDirectory(0, FoundDirectories.s(), "*.*")
          
          Path.s = FoundDirectories.s() + "\"
          
          While NextDirectoryEntry(0)
            
            Filename.s = DirectoryEntryName(0)
            
            Select DirectoryEntryType(0)
                
              Case #PB_DirectoryEntry_File
                
                If Filename.s <> "Thumbs.db"
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  MyStuff\Itemname.s        = RepQuote(Trim(StringField(GetFilePart(Filename.s), 2, " - ")))
                  
                  MyStuff\Supplier.s        = RepQuote(Trim(StringField(GetFilePart(Filename.s), 1, " - ")))
                  
                  MyStuff\Manufacturer.s    = #EmptyString
                  
                  MyStuff\Modelnumber.s     = #EmptyString
                  
                  MyStuff\Serialnumber.s    = #EmptyString
                  
                  MyStuff\Barcode.s         = #EmptyString
                  
                  MyStuff\Boughton.s        = #EmptyString
                  
                  MyStuff\Working.s         = #EmptyString
                  
                  MyStuff\Whopaid.s         = #EmptyString
                  
                  MyStuff\Ownername.s       = #EmptyString
                  
                  MyStuff\Location.s        = #EmptyString
                  
                  MyStuff\Condition.s       = #EmptyString
                  
                  MyStuff\Category.s        = RepQuote(Trim(StringField(Path.s, 3, "\")))
                  
                  MyStuff\Importance.i      = 0
                  
                  MyStuff\Loanedto.s        = #EmptyString
                  
                  MyStuff\Comments.s        = #EmptyString
                  
                  MyStuff\Itempicture.s     = #EmptyString
                  
                  MyStuff\Itemdocument.s    = #EmptyString
                  
                  MyStuff\Cost.s            = #EmptyString
                  
                  MyStuff\Tax.s             = #EmptyString
                  
                  MyStuff\Delivery.s        = #EmptyString
                  
                  MyStuff\Resale.s          = #EmptyString
                  
                  MyStuff\Paidby.s          = #EmptyString
                  
                  MyStuff\Warrantyperiod.s  = #EmptyString
                  
                  MyStuff\Warrantyword.s    = #EmptyString
                  
                  MyStuff\Warrantyactive.s  = #EmptyString
                  
                  MyStuff\Warrantyextra.s   = #EmptyString
                  
                  MyStuff\Insured.s         = #EmptyString
                  
                  MyStuff\Insuredamount.s   = #EmptyString
                  
                  MyStuff\Insuredon.s       = #EmptyString
                  
                  MyStuff\Insurername.s     = #EmptyString
                  
                  MyStuff\Policynumber.s    = #EmptyString
                  
                  MyStuff\Contactnumber.s   = #EmptyString
                  
                  MyStuff\Contactname.s     = #EmptyString
                  
                  MyStuff\Contactdepartment = #EmptyString
                  
                  MyStuff\Deleted.s         = "0"
                  
                  MyStuff\Favourite.s       = "0"
                  
                  MyStuff\Locked.s          = "0"
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  DatabaseInsert.s  = "INSERT INTO Mystuff("
                  
                  DatabaseInsert.s  + "Itemname, "
                  
                  DatabaseInsert.s  + "Supplier, "
                  
                  DatabaseInsert.s  + "Manufacturer, "
                  
                  DatabaseInsert.s  + "Modelnumber, "
                  
                  DatabaseInsert.s  + "Serialnumber, "
                  
                  DatabaseInsert.s  + "Barcode, "
                  
                  DatabaseInsert.s  + "Boughton, "
                  
                  DatabaseInsert.s  + "Working, "
                  
                  DatabaseInsert.s  + "Whopaid, "
                  
                  DatabaseInsert.s  + "Ownername, "
                  
                  DatabaseInsert.s  + "Location, "
                  
                  DatabaseInsert.s  + "Condition, "
                  
                  DatabaseInsert.s  + "Category, "
                  
                  DatabaseInsert.s  + "Importance, "
                  
                  DatabaseInsert.s  + "Loanedto, "
                  
                  DatabaseInsert.s  + "Comments, "
                  
                  DatabaseInsert.s  + "Itempicture, "
                  
                 ;DatabaseInsert.s  + "Itemdocument, "
                  
                  DatabaseInsert.s  + "Cost, "
                  
                  DatabaseInsert.s  + "Tax, "
                  
                  DatabaseInsert.s  + "Delivery, "
                  
                  DatabaseInsert.s  + "Resale, "
                  
                  DatabaseInsert.s  + "Paidby, "
                  
                  DatabaseInsert.s  + "Warrantyperiod, "
                  
                  DatabaseInsert.s  + "Warrantyword, "
                  
                  DatabaseInsert.s  + "Warrantyactive, "
                  
                  DatabaseInsert.s  + "Warrantyextra, "
                  
                  DatabaseInsert.s  + "Insured, "
                  
                  DatabaseInsert.s  + "Insuredamount, "
                  
                  DatabaseInsert.s  + "Insuredon, "
                  
                  DatabaseInsert.s  + "Insurername, "
                  
                  DatabaseInsert.s  + "Policynumber, "
                  
                  DatabaseInsert.s  + "Contactnumber, "
                  
                  DatabaseInsert.s  + "Contactname, "
                  
                  DatabaseInsert.s  + "Contacdepartment, "
                  
                  DatabaseInsert.s  + "Deleted, "
                  
                  DatabaseInsert.s  + "Favourite, "
                  
                  DatabaseInsert.s  + "Locked) "
                  
                  DatabaseInsert.s  + "VALUES("
                  
                  DatabaseInsert.s  + "'" + MyStuff\Itemname.s          + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Supplier.s          + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Manufacturer.s      + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Modelnumber.s       + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Serialnumber.s      + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Barcode.s           + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Boughton.s          + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Working.s           + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Whopaid.s           + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Ownername.s         + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Location.s          + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Condition.s         + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Category.s          + "', "
                  
                  DatabaseInsert.s  + ""  + MyStuff\Importance           + ", "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Loanedto.s          + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Comments.s          + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Itempicture.s       + "', "
                  
                 ;DatabaseInsert.s  + "'" + MyStuff\Itemdocument.s      + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Cost.s              + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Tax.s               + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Delivery.s          + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Resale.s            + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Paidby.s            + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Warrantyperiod.s    + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Warrantyword.s      + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Warrantyactive.s    + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Warrantyextra.s     + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Insured.s           + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Insuredamount.s     + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Insuredon.s         + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Insurername.s       + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Policynumber.s      + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Contactnumber.s     + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Contactname.s       + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Contactdepartment.s + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Deleted.s           + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Favourite.s         + "', "
                  
                  DatabaseInsert.s  + "'" + MyStuff\Locked.s            + "')"
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  If DatabaseUpdate(Program\DatabaseHandle, DatabaseInsert.s) <> #DatabaseUpdateFail
                    
                    ;------------------------------------------------------------------------------
                    ; Get the new record number if any
                    ;------------------------------------------------------------------------------
                    
                    MyStuff\Mystuffid.s = DatabaseLastInsertRowId()
                    
                    ;------------------------------------------------------------------------------
                    ; Proceed if we got a new record number
                    ;------------------------------------------------------------------------------
                    
                    If Len(MyStuff\Mystuffid.s)
                      
                      ;----------------------------------------------------------------------------
                      ; 
                      ;----------------------------------------------------------------------------
                      
                      SetInfoBarArea("Headings", "Info",  "Saved: " + KillQuote(MyStuff\Itemname.s), #PB_Compiler_Procedure)
                      
                      ;----------------------------------------------------------------------------
                      ; 
                      ;----------------------------------------------------------------------------
                      
                      If Option\Messageaftersave = #True
                        
                        MessageRequester("Saved new stuff", "Saved: " + KillQuote(MyStuff\Itemname.s) + " to your stuff.", #PB_MessageRequester_Ok)
                        
                      EndIf
                      
                      ;----------------------------------------------------------------------------
                      ; Now we try to copy the new Document to the local program directory
                      ;----------------------------------------------------------------------------
                      
                      If Len(Path.s + Filename.s) <>  #FileIsEmpty
                        
                        If FileSize(Path.s + Filename.s)  <> #NoDocumentFound
                          
                          If CopyFile(Path.s + Filename.s, Program\DocumentDirectory  + Filename.s) <> #FileNotCopied
                            
                            DatabaseUpdate.s = "UPDATE Mystuff "
                            
                            DatabaseUpdate.s + "SET ItemDocument = '"    + Filename.s     + "' "
                            
                            DatabaseUpdate.s + "WHERE Mystuffid = '"       + MyStuff\Mystuffid.s  + "'"
                            
                            If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
                              
                              If DeleteFile(Path.s + Filename.s)  <>  #NoFileDeleted
                                
                                SetInfoBarArea("Headings", "Info", "Original Document file has been deleted from the source directory.", #PB_Compiler_Procedure)
                                
                              Else
                                
                                SetInfoBarArea("Headings", "Error", "Original Document file has not been deleted from the source directory.", #PB_Compiler_Procedure)
                                
                              EndIf
                              
                              SetInfoBarArea("Headings", "Info", "Original Document path has been updated to reflect the new local Document path.", #PB_Compiler_Procedure)
                              
                            Else
                              
                              SetInfoBarArea("Headings", "Error", "Could not update the existing Document name to reflect the local Document name path.", #PB_Compiler_Procedure)
                              
                            EndIf
                            
                          Else
                            
                            SetInfoBarArea("Headings", "Error", "Could not copy the original Document to the local program directory.", #PB_Compiler_Procedure)
                            
                          EndIf
                          
                        Else
                          
                          SetInfoBarArea("Headings", "Error", "This Picture does not seem to exist at the selected location.", #PB_Compiler_Procedure)
                          
                        EndIf
                        
                      Else
                        
                        SetInfoBarArea("Headings", "Error", "There is no Document string for this record.", #PB_Compiler_Procedure)
                        
                      EndIf
                      
                      ;----------------------------------------------------------------------------
                      ; 
                      ;----------------------------------------------------------------------------
                      
                      DisplayMystuffString(Numberofitems.i, "Add New Stuff")
                      
                      ;----------------------------------------------------------------------------
                      ; 
                      ;----------------------------------------------------------------------------
                      
                      UpdateLocationItemCount(MyStuff\Location.s)
                      
                      ;----------------------------------------------------------------------------
                      ; 
                      ;----------------------------------------------------------------------------
                      
                      Numberofitems.i + 1
                      
                      ;----------------------------------------------------------------------------
                      ; 
                      ;----------------------------------------------------------------------------
                      
                      MyStuff\Itemname.s          = #EmptyString
                      
                      MyStuff\Supplier.s          = #EmptyString
                      
                      MyStuff\Manufacturer.s      = #EmptyString
                      
                      MyStuff\Modelnumber.s       = #EmptyString
                      
                      MyStuff\Serialnumber.s      = #EmptyString
                      
                      MyStuff\Barcode.s           = #EmptyString
                      
                      MyStuff\Boughton.s          = #EmptyString
                      
                      MyStuff\Working.s           = #EmptyString
                      
                      MyStuff\Whopaid.s           = #EmptyString
                      
                      MyStuff\Ownername.s         = #EmptyString
                      
                      MyStuff\Location.s          = #EmptyString
                      
                      MyStuff\Condition.s         = #EmptyString
                      
                      MyStuff\Category.s          = #EmptyString
                      
                      MyStuff\Importance.i        = 0
                      
                      MyStuff\Loanedto.s          = #EmptyString
                      
                      MyStuff\Comments.s          = #EmptyString
                      
                      MyStuff\Itempicture.s       = #EmptyString
                      
                      MyStuff\Itemdocument.s      = #EmptyString
                      
                      MyStuff\Cost.s              = #EmptyString
                      
                      MyStuff\Tax.s               = #EmptyString
                      
                      MyStuff\Delivery.s          = #EmptyString
                      
                      MyStuff\Resale.s            = #EmptyString
                      
                      MyStuff\Paidby.s            = #EmptyString
                      
                      MyStuff\Warrantyperiod.s    = #EmptyString
                      
                      MyStuff\Warrantyword.s      = #EmptyString
                      
                      MyStuff\Warrantyactive.s    = #EmptyString
                      
                      MyStuff\Warrantyextra.s     = #EmptyString
                      
                      MyStuff\Insured.s           = #EmptyString
                      
                      MyStuff\Insuredamount.s     = #EmptyString
                      
                      MyStuff\Insuredon.s         = #EmptyString
                      
                      MyStuff\Insurername.s       = #EmptyString
                      
                      MyStuff\Policynumber.s      = #EmptyString
                      
                      MyStuff\Contactnumber.s     = #EmptyString
                      
                      MyStuff\Contactname.s       = #EmptyString
                      
                      MyStuff\Contactdepartment.s = #EmptyString
                      
                      MyStuff\Deleted.s           = #EmptyString
                      
                      MyStuff\Favourite.s         = #EmptyString
                      
                      MyStuff\Locked.s            = #EmptyString
                      
                      ;----------------------------------------------------------------------------
                      ; 
                      ;----------------------------------------------------------------------------
                      
                    Else
                      
                      SetInfoBarArea("Headings", "Error",  KillQuote(Mystuff\Itemname) + " could not be saved, no record number: " + DatabaseError(), #PB_Compiler_Procedure)
                      
                    EndIf
                    
                    ;------------------------------------------------------------------------------
                    ; 
                    ;------------------------------------------------------------------------------
                    
                  Else
                    
                    Debug DatabaseError() + " - "  + MyStuff\Itemname.s

                    SetInfoBarArea("Headings", "Error",  KillQuote(Mystuff\Itemname) + " could not be saved, inserting record failed: " + DatabaseError(), #PB_Compiler_Procedure)
                    
                  EndIf
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                EndIf
                
              Case #PB_DirectoryEntry_Directory
                
                Filename.s = DirectoryEntryName(0)
                
                If Filename.s <> ".." And Filename.s <> "."
                  
                  AddElement(FoundDirectories())
                  
                  FoundDirectories() = Path + Filename.s
                  
                EndIf
                
            EndSelect
            
          Wend
          
        EndIf
        
        IndexLevel.i + 1
        
      Until IndexLevel.i > ListSize(FoundDirectories()) -1
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 376
; FirstLine = 340
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP