﻿;==============================================================================================================================================================================
; Format a number with commas in the right place. BasicallyPure
;==============================================================================================================================================================================

Procedure.s FormatNumber(NumberText.s, Position.i = 3)
  
  ;------------------------------------------------------------------------------------------------
  ; inserts ',' into string every 'Position' characters
  ;------------------------------------------------------------------------------------------------
  
  Protected StringLoop.i, StringLength.i, StringOutput.s
  
  Protected Fraction.s =  StringField(NumberText, 2, ".")

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Fraction
     
    NumberText = StringField(NumberText, 1, ".")
     
  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  StringLength = Len(NumberText)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If StringLength > Position

    For StringLoop.i = 1 To StringLength / Position

      StringOutput = "," + Right(NumberText, Position) + StringOutput

      NumberText = Left(NumberText, Len(NumberText)-Position)

    Next StringLoop.i

    NumberText = LTrim(NumberText + StringOutput, ",")

  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Fraction

    NumberText + "." + Fraction 

  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn NumberText

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure
 
; Debug Commatize("2058730928521527819052")
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 70
; FirstLine = 15
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP