﻿;================================================================================================================================================================================
; Format the currency correctly according to the locality
;================================================================================================================================================================================

Procedure.s GetCurrency(CurrencyIn.s)
  
  ;------------------------------------------------------------------------------------------------
  ; Get the string length plus the possible number of formatters
  ;------------------------------------------------------------------------------------------------
  
  FormatStringLength.i = Len(CurrencyIn.s) + 10
  
  ;------------------------------------------------------------------------------------------------
  ; Prepare an empty string buffer
  ;------------------------------------------------------------------------------------------------
  
  FormatString.s       = Space(FormatStringLength.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Format the price as currency display
  ;------------------------------------------------------------------------------------------------
  
  ErrorCode.i = GetCurrencyFormat_(0, 0, CurrencyIn.s, 0, @FormatString.s, FormatStringLength.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If ErrorCode.i = 0
    
    FormatString.s = "##Invalid##"
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Return the formatted value to the program
  ;------------------------------------------------------------------------------------------------

  ProcedureReturn FormatString.s
    
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 37
; FirstLine = 1
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP