﻿;==============================================================================================================================================================================
; Get the text of the associated shortcut constant. SROD
;==============================================================================================================================================================================

Procedure.s GetShortcutText(Constant.i)

  ;------------------------------------------------------------------------------------------------
  ; NetMaestro 2009. NetMaestro code modded by Sroddy code  ; Unused  mod$, ctrl$, shift$, alt$
  ;------------------------------------------------------------------------------------------------
 
  Protected KeyLocale, VirtualKey, KeyString.s, ResultString.s

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Constant.i & #PB_Shortcut_Control

    ResultString.s = "Ctrl + "

  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Constant.i & #PB_Shortcut_Shift

    ResultString.s + "Shift + "

  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Constant.i & #PB_Shortcut_Alt

    ResultString.s + "Alt + "

  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  KeyLocale   = GetKeyboardLayout_(GetCurrentThreadId_())

  KeyString.s = Space(100)

  ; Virtual key

  VirtualKey  = MapVirtualKeyEx_(Constant.i & $FF, 0, KeyLocale) << 16

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Constant.i >> 8 & #HOTKEYF_EXT Or (Constant.i & $FF >= #PB_Shortcut_PageUp And Constant.i & $FF <= #PB_Shortcut_Down)

    VirtualKey | (1 << 24) ; Set the extended key bit

  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  GetKeyNameText_(VirtualKey, @KeyString, 100)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ResultString.s + KeyString.s

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If ResultString.s = #EmptyString

    ResultString.s = "NoKeys"

  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn ResultString.s

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 82
; FirstLine = 61
; Folding = -
; EnableXP