﻿;==============================================================================================================================================================================
; Get the current windows title bar height. Useful for form element resizing.
;==============================================================================================================================================================================

Procedure.i GetWindowTitleBarDetails(Window.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected TitleBarHeight.i
  
  Protected pti.TITLEBARINFO
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  WindowHandle.i = WindowID(Window.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If WindowHandle.i
    
    pti.TITLEBARINFO\cbSize = SizeOf(TITLEBARINFO)
    
    GetTitleBarInfo_(WindowHandle.i, pti)
    
    TitleBarHeight.i = pti\rcTitleBar\bottom  - pti\rcTitleBar\top
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn TitleBarHeight.i
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure
; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP