﻿;==============================================================================================================================================================================
; First letter uppercase in a combo box. srod!.
;==============================================================================================================================================================================

Procedure MixedComboCase(Gadget.i)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  Protected cbParent.i, StringOut.s, StringIn.s, Temporary.s, Position.i, StartSelection.i, EndSelection.i
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  StringIn.s = GetGadgetText(Gadget.i)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If StringIn.s = #EmptyString
    
    ProcedureReturn
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  WordFlag.i = 1
  
  cbParent.i = FindWindowEx_(GadgetID(Gadget.i), #Null, "EDIT", #Null)      ; Get the Windows handle of the combobox's edit field.
  
  SendMessage_(cbParent.i, #EM_GETSEL, @StartSelection, @EndSelection)      ; Get the Position of the caret.
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If StartSelection.i <> EndSelection.i
    
    
    ProcedureReturn
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  Repeat
    
    Position.i + 1
    
    StringOut.s = Mid(StringIn.s, Position.i, 1)
    
    If WordFlag.i
      
      Temporary.s + UCase(StringOut.s)
      
    Else
      
      Temporary.s + StringOut.s
      
    EndIf
    
    If StringOut.s = " "
      
      WordFlag.i = 1
      
    Else
      
      WordFlag.i = 0
      
    EndIf
    
  Until Position.i = Len(StringIn.s)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  SetGadgetText(Gadget.i, Temporary.s)
  
  ;------------------------------------------------------------------------------------------------
  ; Return the caret to it's original Position
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(cbParent.i, #EM_SETSEL, EndSelection.i, EndSelection.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 98
; FirstLine = 43
; Folding = -
; EnableXP