﻿;==============================================================================================================================================================================
; Flip a mixed string into all proper case
;==============================================================================================================================================================================

Procedure.s ProperCaseString(StringToBeFlipped.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
    
  Protected.i Index.i
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected.s OutputString.s, TemporaryString.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  For Index.i = 1 To CountString(StringToBeFlipped, " ") + 1
    
    If Index = 1
      
      OutputString.s = #EmptyString
      
    Else
      
      OutputString.s + " "
      
    EndIf
    
    TemporaryString.s = StringField(StringToBeFlipped, Index, " ")
    
    OutputString.s + UCase(Left(TemporaryString.s, 1)) + LCase(Mid(TemporaryString.s, 2))
    
  Next
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn OutputString.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 26
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP