﻿;==============================================================================================================================================================================
; Convert the first character of a string to uppercase
;==============================================================================================================================================================================

Procedure StringFirstUpper(GadgetId.i)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If EventType() = #PB_EventType_Change

    Protected Parent.i, StringOut.s, StringIn.s, Temporary.s, Position.i, StartSelection.i, EndSelection.i

    StringIn.s = GetGadgetText(GadgetId.i)

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If StringIn.s = #EmptyString
    
      ProcedureReturn
      
    EndIf

    ;----------------------------------------------------------------------------------------------
    ; Get the Position.lition of the caret.
    ;----------------------------------------------------------------------------------------------
    
    SendMessage_(GadgetID(GadgetId.i), #EM_GETSEL, @StartSelection, @EndSelection)

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If StartSelection.i <> EndSelection.i
    
      ProcedureReturn
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; Return the caret to it's original Position
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetText(GadgetId.i, UCase(Left(StringIn.s, 1)) + Mid(StringIn.s, 2, Len(StringIn.s) - 1))

    SendMessage_(GadgetID(GadgetId.i), #EM_SETSEL, EndSelection.i, EndSelection.i)

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
  
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 20
; FirstLine = 6
; Folding = -
; EnableXP