﻿;==============================================================================================================================================================================
; Delete an existing location from the location bar
;==============================================================================================================================================================================

Procedure CopyLocation()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected CurrentLine.i, Location.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i      = GetGadgetState(#Gadget_Mystuff_Locations)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Location.s = Trim(StringField(GetGadgetItemText(#Gadget_Mystuff_Locations, CurrentLine.i, #LocationTitleColumn), 1, "("))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Location.s  <> #EmptyString
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Select Location.s
          
        Case "All my stuff", "No titles", "No locations", "Deleted stuff", "Favourite stuff", "Locked stuff"  + 

          "-----------------------"
          
          SetInfoBarArea("Headings",  "Info", "You cannot copy inbuilt locations to the clipboard, makes no sense.", #PB_Compiler_Procedure)
          
        Default
          
          SetClipboardText("Location|" + Location.s)
          
          SetInfoBarArea("Headings",  "Info", "The location has been copied to the system clipboard.", #PB_Compiler_Procedure)
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error", "There is no current location selected to copy", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error", "There is no current line selected by the user.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 81
; FirstLine = 45
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP