﻿;==============================================================================================================================================================================
; Delete an existing location from the location bar
;==============================================================================================================================================================================

Procedure DeleteLocation()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected CurrentLine.i, Location.s, DatabaseUpdate.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i      = GetGadgetState(#Gadget_Mystuff_Locations)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Location.s = Trim(StringField(RepQuote(GetGadgetItemText(#Gadget_Mystuff_Locations, CurrentLine.i, #LocationTitleColumn)), 1, "("))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Location.s  <> #EmptyString
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Select Location.s
          
        Case "All my stuff", "No titles", "No locations", "Deleted stuff", "Favourite stuff", "Locked stuff"  + 

          "-----------------------"
          
          SetInfoBarArea("Headings",  "Info", "You cannot delete inbuilt locations from the list, makes no sense.", #PB_Compiler_Procedure)
          
        Default
          
          ;--------------------------------------------------------------------------------------
          ; 
          ;--------------------------------------------------------------------------------------
          
          DatabaseUpdate.s  = "DELETE * FROM Locations "
          
          DatabaseUpdate.s  + "WHERE Locationid = '"  + Location.s + "'"
          
          ;--------------------------------------------------------------------------------------
          ; 
          ;--------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
            
            ;------------------------------------------------------------------------------------
            ; 
            ;------------------------------------------------------------------------------------
            
            RemoveGadgetItem(#Gadget_Mystuff_Locations, CurrentLine.i)
            
            ;------------------------------------------------------------------------------------
            ; 
            ;------------------------------------------------------------------------------------
            
            SetInfoBarArea("Headings",  "Info", "The changed location was saved to the Locations table.", #PB_Compiler_Procedure)
            
            ;------------------------------------------------------------------------------------
            ; 
            ;------------------------------------------------------------------------------------
            
            Sortlocations()
            
            ;------------------------------------------------------------------------------------
            ; 
            ;------------------------------------------------------------------------------------
            
            DatabaseUpdate.s  = "UPDATE Mystuff"
            
            DatabaseUpdate.s  + "SET Location = ''"
            
            DatabaseUpdate.s  + "WHERE Locationid = "  + Location.s
            
            ;------------------------------------------------------------------------------------
            ; 
            ;------------------------------------------------------------------------------------
            
            If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
              
              SetInfoBarArea("Headings",  "Info", "The changed location was updated in Mystuff.", #PB_Compiler_Procedure)
              
            Else
              
              SetInfoBarArea("Headings",  "Error", "The changed location could not be updated in Mystuff: " + DatabaseError(), #PB_Compiler_Procedure)
              
            EndIf
            
            ;------------------------------------------------------------------------------------
            ; 
            ;------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings",  "Error", "The changed location could not be saved to Locations: " + DatabaseError(), #PB_Compiler_Procedure)
            
          EndIf
          
          ;--------------------------------------------------------------------------------------
          ; 
          ;--------------------------------------------------------------------------------------
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error", "There is no current location on that line selected to be edited.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error", "There is no current line selected by the user.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 39
; FirstLine = 3
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP