﻿;==============================================================================================================================================================================
; Load all the locations into the location bar
;==============================================================================================================================================================================

Procedure Getlocations()

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected Locationid.s, Location.s, Itemcount.s

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  AddGadgetItem(#Gadget_Mystuff_Locations, #AtTheEndOfTheList, "All my stuff"             + #LF$ + #EmptyString  + #LF$ + #EmptyString, ImageID(#Image_Location_Allmystuff))
  
  AddGadgetItem(#Gadget_Mystuff_Locations, #AtTheEndOfTheList, "No titles"                + #LF$ + #EmptyString  + #LF$ + #EmptyString, ImageID(#Image_Location_Notitlenames))
  
  AddGadgetItem(#Gadget_Mystuff_Locations, #AtTheEndOfTheList, "No locations"             + #LF$ + #EmptyString  + #LF$ + #EmptyString, ImageID(#Image_Location_Nolocations))
  
  AddGadgetItem(#Gadget_Mystuff_Locations, #AtTheEndOfTheList, "Deleted stuff"            + #LF$ + #EmptyString  + #LF$ + #EmptyString, ImageID(#Image_Location_Deletedstuff))
  
  AddGadgetItem(#Gadget_Mystuff_Locations, #AtTheEndOfTheList, "Favourite stuff"          + #LF$ + #EmptyString  + #LF$ + #EmptyString, ImageID(#Image_Location_Favouritestuff))
  
  AddGadgetItem(#Gadget_Mystuff_Locations, #AtTheEndOfTheList, "Locked stuff"             + #LF$ + #EmptyString  + #LF$ + #EmptyString, ImageID(#Image_Location_Lockedstuff))
  
  AddGadgetItem(#Gadget_Mystuff_Locations, #AtTheEndOfTheList, "Loaned stuff"             + #LF$ + #EmptyString  + #LF$ + #EmptyString, ImageID(#Image_Location_Loanedstuff))
  
  AddGadgetItem(#Gadget_Mystuff_Locations, #AtTheEndOfTheList, "-----------------------"  + #LF$ + #EmptyString  + #LF$ + #EmptyString)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  For ColumnSet.i = 0 To 6
    
    SetGadgetItemColor(#Gadget_Mystuff_Locations, ColumnSet.i, #PB_Gadget_FrontColor, $000080, #LocationTitleColumn)
    
  Next ColumnSet.i
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  DatabaseQuery.s = "SELECT * FROM Locations "
  
  DatabaseQuery.s + "ORDER BY Location"
  
  If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
    
    While NextDatabaseRow(Program\DatabaseHandle) ;<> #NoItems
      
      Location.s    = KillQuote(GetDatabaseString(Program\DatabaseHandle, 0))   ;   : Debug Location.s
      
      Iconname.s    = KillQuote(GetDatabaseString(Program\DatabaseHandle, 1))   ;   : Debug Iconname.s
      
      Itemcount.s   =           GetDatabaseString(Program\DatabaseHandle, 2)    ;   : Debug Itemcount.s
      
      Locationid.s  =           GetDatabaseString(Program\DatabaseHandle, 3)    ;   : Debug Locationid.s
      
      ;--------------------------------------------------------------------------------------------
      ; Load the user chosen icons to be selected for locations
      ;--------------------------------------------------------------------------------------------
      
      If Iconname.s <> #Emptystring
        
        If FileSize(Program\IconsDirectory  + Iconname.s) <> #FileDoesNotExist
          
          IconHandle.i = LoadImage(#PB_Any, Program\IconsDirectory  + Iconname.s)
          
          If IconHandle.i <> #NoPictureLoaded
          
            AddGadgetItem(#Gadget_Mystuff_Locations, #AtTheEndOfTheList, Location.s + Space(1)  + "("  + Itemcount.s + ")" + #LF$ + Iconname.s  + #LF$ + Itemcount.s + #LF$ + Locationid.s, ImageID(IconHandle.i))
            
          Else
            
            AddGadgetItem(#Gadget_Mystuff_Locations, #AtTheEndOfTheList, Location.s + Space(1)  + "("  + Itemcount.s + ")" + #LF$ + Iconname.s  + #LF$ + Itemcount.s + #LF$ + Locationid.s, ImageID(#MenuBarIcon_Mystuff_Blank))
          
          EndIf
          
        Else
          
          AddGadgetItem(#Gadget_Mystuff_Locations, #AtTheEndOfTheList, Location.s + Space(1)  + "("  + Itemcount.s + ")" + #LF$ + Iconname.s  + #LF$ + Itemcount.s + #LF$ + Locationid.s, ImageID(#MenuBarIcon_Mystuff_Blank))
          
        EndIf
        
      Else
        
        AddGadgetItem(#Gadget_Mystuff_Locations, #AtTheEndOfTheList, Location.s + Space(1)  + "("  + Itemcount.s + ")" + #LF$ + Iconname.s  + #LF$ + Itemcount.s + #LF$ + Locationid.s, ImageID(#MenuBarIcon_Mystuff_Blank))
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Wend
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
  Else
    
    SetInfoBarArea("Headings",  "Error", "Database query failed or returned no data:  " + DatabaseError(), #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 70
; FirstLine = 77
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP