﻿;==========================================================================================================================================================
; Attach a document to this record
;==========================================================================================================================================================

Procedure AddNewDocument()

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  MyStuffEdit\DocumentAndPath.s = OpenFileRequester("Select file to attach", GetHomeDirectory() + "Documents\", "Doc (*.doc)|*.doc|Text (*.txt)|*.txt|Pdf (*.pdf)|*.pdf|Rtf (*.rtf)|*.rtf|Archive (*.zip (.7z)|*.zip;*.7z|All (*.*)|*.*", 5)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If MyStuffEdit\DocumentAndPath.s <> #EmptyString
    
    If FileSize(MyStuffEdit\DocumentAndPath.s)  <> #FileDoesNotExist
      
      SetGadgetText(#Gadget_Datasheet_Documentname, GetFilePart(MyStuffEdit\DocumentAndPath.s))

    Else
      
      SetInfoBarArea("Headings",  "Error",  "The document requested for this stuff does not exist.", #PB_Compiler_Procedure)
      
    EndIf
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  "There is no current document to load for this stuff.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 10
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP