﻿;==========================================================================================================================================================
; Load a linked Picture for the passed picture name
;==========================================================================================================================================================

Procedure AddNewPicture()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  MyStuffEdit\PictureAndPath.s = OpenFileRequester("Select picture to attach", GetHomeDirectory() + "Pictures\", "Jpeg (*.jpg *.jpeg *.jfif)|*.jpg;*.jpeg;*.jfif|Bitmap (*.bmp)|*.bmp|Targa (*.tga)|*.tga|Tiff (*.tif)|*.tif|Png (*.png)|*.png|All (*.*)|*.*", 5)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If MyStuffEdit\PictureAndPath.s <> #EmptyString
    
    If FileSize(MyStuffEdit\PictureAndPath.s)  <> #FileDoesNotExist
      
      DatasheetPictureId.i = LoadImage(#PB_Any, MyStuffEdit\PictureAndPath.s)
      
      If DatasheetPictureId.i <> #NoPictureHandle
        
        NewImageHandle.i = ResizeImage(DatasheetPictureId.i, #DatasheetPictureWidth, #DatasheetPictureHeight, #PB_Image_Smooth)
        
        If NewImageHandle.i
          
          SetGadgetState(#Gadget_Datasheet_ItemPicture, NewImageHandle.i)
          
          SetGadgetText(#Gadget_Datasheet_Picturename, GetFilePart(MyStuffEdit\PictureAndPath.s))
          
        Else
          
          SetInfoBarArea("Headings",  "Error",  "Could not resize the loaded picture to the picture frame.", #PB_Compiler_Procedure)
          
        EndIf
        
      Else
        
        SetInfoBarArea("Headings",  "Error",  "The Picture requested for this stuff could not be loaded from disk.", #PB_Compiler_Procedure)
        
      EndIf
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "The Picture requested for this stuff does not exist.", #PB_Compiler_Procedure)
      
    EndIf
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  "There is no current Picture to load for this stuff.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 10
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP