﻿;==========================================================================================================================================
; Copy my current stuff to the system clipboard
;==========================================================================================================================================

Procedure CopyOldStuff()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_Mystuff_Itemlist)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i  <>  #NoCurrentLine
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Mystuffid.s = GetGadgetItemText(#Gadget_Mystuff_Itemlist, CurrentLine.i, #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    DatabaseQuery.s = "SELECT * FROM Mystuff "
    
    DatabaseQuery.s + "WHERE Mystuffid = '" + Mystuffid.s + "'"
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Mystuffid.s  <>  #EmptyString
      
      ;--------------------------------------------------------------------------------------------
      ; Fetch the record data for this record
      ;--------------------------------------------------------------------------------------------
      
      If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
        
        While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
          
          CopyString.s + FormatField("Item name",           20) +              GetDatabaseString(Program\DatabaseHandle,  0)
          
          CopyString.s + FormatField("Supplier",            20) +              GetDatabaseString(Program\DatabaseHandle,  1)
          
          CopyString.s + FormatField("Manufacturer",        20) +              GetDatabaseString(Program\DatabaseHandle,  2)
          
          CopyString.s + FormatField("Model number",        20) +              GetDatabaseString(Program\DatabaseHandle,  3)
          
          CopyString.s + FormatField("Serial number",       20) +              GetDatabaseString(Program\DatabaseHandle,  4)
          
          CopyString.s + FormatField("Barcode",             20) +              GetDatabaseString(Program\DatabaseHandle,  5)
          
          CopyString.s + FormatField("Boughton",            20) +      IsoDate(GetDatabaseString(Program\DatabaseHandle,  6), "NormalDate")
          
          CopyString.s + FormatField("Working",             20) +              GetDatabaseString(Program\DatabaseHandle,  7)
          
          CopyString.s + FormatField("Who paid",            20) +              GetDatabaseString(Program\DatabaseHandle,  8)
          
          CopyString.s + FormatField("Owner's name",        20) +              GetDatabaseString(Program\DatabaseHandle,  9)
          
          CopyString.s + FormatField("Location",            20) +              GetDatabaseString(Program\DatabaseHandle, 10)
          
          CopyString.s + FormatField("Condition",           20) +              GetDatabaseString(Program\DatabaseHandle, 11)
          
          CopyString.s + FormatField("Category",            20) +              GetDatabaseString(Program\DatabaseHandle, 12)
          
          CopyString.s + FormatField("Importance",          20) +              GetDatabaseString(Program\DatabaseHandle, 13)
          
          CopyString.s + FormatField("Loanedto",            20) +              GetDatabaseString(Program\DatabaseHandle, 14)
          
          CopyString.s + FormatField("Comments",            20) +              GetDatabaseString(Program\DatabaseHandle, 15)
          
         ;CopyString.s + FormatField("Itemphoto",           20) +              GetDatabaseString(Program\DatabaseHandle, 16)
          
          CopyString.s + FormatField("Itemdocument",        20) +              GetDatabaseString(Program\DatabaseHandle, 17)
          
          CopyString.s + FormatField("Cost",                20) +  GetCurrency(GetDatabaseString(Program\DatabaseHandle, 18))
          
          CopyString.s + FormatField("Tax",                 20) +  GetCurrency(GetDatabaseString(Program\DatabaseHandle, 19))
          
          CopyString.s + FormatField("Delivery",            20) +  GetCurrency(GetDatabaseString(Program\DatabaseHandle, 20))
          
          CopyString.s + FormatField("Othercost",           20) +  GetCurrency(GetDatabaseString(Program\DatabaseHandle, 21))
          
          CopyString.s + FormatField("Resale",              20) +  GetCurrency(GetDatabaseString(Program\DatabaseHandle, 22))
          
          CopyString.s + FormatField("Paid by",             20) +              GetDatabaseString(Program\DatabaseHandle, 23)
          
          CopyString.s + FormatField("Warranty period",     20) +              GetDatabaseString(Program\DatabaseHandle, 24)
          
          CopyString.s + FormatField("Warranty word",       20) +              GetDatabaseString(Program\DatabaseHandle, 25)
          
          CopyString.s + FormatField("Warranty active",     20) +              GetDatabaseString(Program\DatabaseHandle, 26)
          
          CopyString.s + FormatField("Warranty extra",      20) +  GetCurrency(GetDatabaseString(Program\DatabaseHandle, 27))
          
          CopyString.s + FormatField("Insured",             20) +              GetDatabaseString(Program\DatabaseHandle, 28)
          
          CopyString.s + FormatField("Insured amount",      20) +  GetCurrency(GetDatabaseString(Program\DatabaseHandle, 29))
          
          CopyString.s + FormatField("Insured on",          20) +      IsoDate(GetDatabaseString(Program\DatabaseHandle, 30), "NormalDate")
          
          CopyString.s + FormatField("Insurer name",        20) +              GetDatabaseString(Program\DatabaseHandle, 31)
          
          CopyString.s + FormatField("Policy number",       20) +              GetDatabaseString(Program\DatabaseHandle, 32)
          
          CopyString.s + FormatField("Contact number",      20) +              GetDatabaseString(Program\DatabaseHandle, 33)
          
          CopyString.s + FormatField("Contact name",        20) +              GetDatabaseString(Program\DatabaseHandle, 34)
          
          CopyString.s + FormatField("Contact department",  20) +              GetDatabaseString(Program\DatabaseHandle, 35)
          
         ;CopyString.s + FormatField("Deleted",             20) +              GetDatabaseString(Program\DatabaseHandle, 36)
         ;           
         ;CopyString.s + FormatField("Favourite",           20) +              GetDatabaseString(Program\DatabaseHandle, 37)
         ;           
         ;CopyString.s + FormatField("Locked",              20) +              GetDatabaseString(Program\DatabaseHandle, 38)
         ;           
         ;CopyString.s + FormatField("Mystuffid",           20) +              GetDatabaseString(Program\DatabaseHandle, 39)
          
        Wend
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        FinishDatabaseQuery(Program\DatabaseHandle)
        
        ;------------------------------------------------------------------------------------------
        ; Set the data to this form
        ;------------------------------------------------------------------------------------------
        
        SetClipboardText(CopyString.s)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Error", "Database query failed or returned no data:  " + DatabaseError(), #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Nothing more to do folks
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "There is no record number for that item. Should never happen.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  "There is no current item selected for copying.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure
  


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 88
; FirstLine = 79
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP