﻿;==============================================================================================================================================================================
; Permanently delete the current stuff
;==============================================================================================================================================================================

Procedure KillThisStuff()
  
  ;------------------------------------------------------------------------------------------------
  ; Get the currently highlighted line
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_Mystuff_Itemlist)
  
  ;------------------------------------------------------------------------------------------------
  ; Only continue if a line was selected
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; Get the current deleted state
    ;----------------------------------------------------------------------------------------------
    
    ItemName.s      = GetGadgetItemText(#Gadget_Mystuff_Itemlist, CurrentLine.i, #NameofitemColumn)
    
    LockedState.s   = GetGadgetItemText(#Gadget_Mystuff_Itemlist, CurrentLine.i, #LockedColumn)
    
    CurrentRecord.s = GetGadgetItemText(#Gadget_Mystuff_Itemlist, CurrentLine.i, #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If LockedState.s <> "1"
      
      ;--------------------------------------------------------------------------------------------
      ; Proceed if we got a record number
      ;--------------------------------------------------------------------------------------------
      
      If CurrentRecord.s <> #EmptyString
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If MessageRequester("Permanent removal", "Are you sure you want to permanently remove this stuff?.", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If MessageRequester("Last chance bozo", "If this is original stuff, you are so screwed!.", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
            
            ;--------------------------------------------------------------------------------------
            ; Try to delete the selected record from the database
            ;--------------------------------------------------------------------------------------
            
            UpdateString.s  = "DELETE FROM Mystuff "
            
            UpdateString.s  + "WHERE Mystuffid = '" + CurrentRecord.s + "'"
            
            ;--------------------------------------------------------------------------------------
            ; Try to delete the selected record from the database
            ;--------------------------------------------------------------------------------------
            
            If DatabaseUpdate(Program\DatabaseHandle, UpdateString.s) <> #DatabaseUpdateFail
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              RemoveGadgetItem(#Gadget_Mystuff_Itemlist, CurrentLine.i)
              
              SetInfoBarArea("Headings", "Info", "Permanently removed " + ItemName.s, #PB_Compiler_Procedure)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings", "Error", "The database update failed. " + DatabaseError(), #PB_Compiler_Procedure)
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Error", "Nothing to do, user cancelled the operation", #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "Nothing to do, user cancelled the operation", #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Error", "There is no record number for this picture", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Warn", "Cannot kill a locked picture.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "There is no current line selected.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure



; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 108
; FirstLine = 105
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP