﻿;==========================================================================================================================================================
; Save the new or edited stuff
;==========================================================================================================================================================

Procedure SaveMyStuff()
  
  ;------------------------------------------------------------------------------------------------
  ; Gather all the data from the form into the sctructore to be saved
  ;------------------------------------------------------------------------------------------------
 
  Mystuff\Itemname          =            RepQuote(GetGadgetText(#Gadget_Datasheet_ItemName))
  
  Mystuff\Supplier          =            RepQuote(GetGadgetText(#Gadget_Datasheet_Supplier))
  
  Mystuff\Manufacturer      =            RepQuote(GetGadgetText(#Gadget_Datasheet_Manufacturer))
  
  Mystuff\Modelnumber       =            RepQuote(GetGadgetText(#Gadget_Datasheet_ModelNumber))
  
  Mystuff\Serialnumber      =            RepQuote(GetGadgetText(#Gadget_Datasheet_SerialNumber))
  
  Mystuff\Barcode           =                     GetGadgetText(#Gadget_Datasheet_Barcode)
  
  If GetGadgetState(#Gadget_Datasheet_BoughtOn) <> #DateNotActive
    
    Mystuff\Boughton        =             IsoDate(GetGadgetText(#Gadget_Datasheet_BoughtOn), "IsoDate")
    
  EndIf

  Mystuff\Working           =            RepQuote(GetGadgetText(#Gadget_Datasheet_Working))
  
  Mystuff\Whopaid           =            RepQuote(GetGadgetText(#Gadget_Datasheet_WhoPaid))
  
  Mystuff\Ownername         =            RepQuote(GetGadgetText(#Gadget_Datasheet_OwnerName))
  
  Mystuff\Location          =            RepQuote(GetGadgetText(#Gadget_Datasheet_Location))
  
  Mystuff\Condition         =            RepQuote(GetGadgetText(#Gadget_Datasheet_Condition))
  
  Mystuff\Category          =            RepQuote(GetGadgetText(#Gadget_Datasheet_Category))
  
  Mystuff\Importance        =             RatingGadget_GetState(#Gadget_Datasheet_Importance) 

  Mystuff\Loanedto          =            RepQuote(GetGadgetText(#Gadget_Datasheet_Loanedto))
  
  Mystuff\Comments          =            RepQuote(GetGadgetText(#Gadget_Datasheet_Comments))
  
 ;Mystuff\Itempicture       =            RepQuote(GetGadgetText(#Gadget_Datasheet_Picturename))
  
 ;Mystuff\Itemdocument      =            RepQuote(GetGadgetText(#Gadget_Datasheet_Documentname))
  
  Mystuff\Cost              = ClearCurrencyFormat(GetGadgetText(#Gadget_Datasheet_Cost))
  
  Mystuff\Tax               = ClearCurrencyFormat(GetGadgetText(#Gadget_Datasheet_Tax))
  
  Mystuff\Delivery          = ClearCurrencyFormat(GetGadgetText(#Gadget_Datasheet_Delivery))
  
  Mystuff\Othercost         = ClearCurrencyFormat(GetGadgetText(#Gadget_Datasheet_Othercost))
  
  Mystuff\Resale            = ClearCurrencyFormat(GetGadgetText(#Gadget_Datasheet_Resale))
  
  Mystuff\Paidby            =            RepQuote(GetGadgetText(#Gadget_Datasheet_PaidBy))
  
  Mystuff\Warrantyperiod    =            RepQuote(GetGadgetText(#Gadget_Datasheet_WarrantyPeriod))
  
  Mystuff\Warrantyword      =            RepQuote(GetGadgetText(#Gadget_Datasheet_WarrantyWord))
  
  Mystuff\Warrantyactive    =            RepQuote(GetGadgetText(#Gadget_Datasheet_WarrantyActive))
  
  Mystuff\Warrantyextra     = ClearCurrencyFormat(GetGadgetText(#Gadget_Datasheet_WarrantyAmount))
  
  Mystuff\Insured           =            RepQuote(GetGadgetText(#Gadget_Datasheet_Insured))
  
  Mystuff\Insuredamount     = ClearCurrencyFormat(GetGadgetText(#Gadget_Datasheet_InsuredAmount))
  
  If GetGadgetState(#Gadget_Datasheet_InsuredOn) <> #DateNotActive
    
    Mystuff\Insuredon       =             IsoDate(GetGadgetText(#Gadget_Datasheet_InsuredOn),  "IsoDate")
    
  EndIf

  Mystuff\Insurername       =            RepQuote(GetGadgetText(#Gadget_Datasheet_InsurerName))
  
  Mystuff\Policynumber      =            RepQuote(GetGadgetText(#Gadget_Datasheet_PolicyNumber))
  
  Mystuff\Contactnumber     =            RepQuote(GetGadgetText(#Gadget_Datasheet_ContactNumber))
  
  Mystuff\Contactname       =            RepQuote(GetGadgetText(#Gadget_Datasheet_Contactname))
  
  Mystuff\Contactdepartment =            RepQuote(GetGadgetText(#Gadget_Datasheet_Contactdepartment))
  
 ;Mystuff\Deleted           =           ; Toggle function, not changed here
  
 ;Mystuff\Favourite         =           ; Toggle function, not changed here
  
 ;Mystuff\Locked            =           ; Toggle function, not changed here
  
 ;Mystuff\Mystuffid         =  
  
 ;Mystuffedit\NewPictureToSave = 
  
 ;Mystuffedit\NewDocumentToSave = 
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Len(Mystuff\Itemname)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Select  Program\LastWindow
  
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
        
      Case  "Add New Stuff"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        Mystuff\Deleted         = "0"
        
        Mystuff\Favourite       = "0"
        
        Mystuff\Locked          = "0"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        DatabaseInsert.s  = "INSERT INTO Mystuff("
        
        DatabaseInsert.s  + "Itemname, "
        
        DatabaseInsert.s  + "Supplier, "
        
        DatabaseInsert.s  + "Manufacturer, "
        
        DatabaseInsert.s  + "Modelnumber, "
        
        DatabaseInsert.s  + "Serialnumber, "
        
        DatabaseInsert.s  + "Barcode, "
        
        DatabaseInsert.s  + "Boughton, "
        
        DatabaseInsert.s  + "Working, "
        
        DatabaseInsert.s  + "Whopaid, "
        
        DatabaseInsert.s  + "Ownername, "
        
        DatabaseInsert.s  + "Location, "
        
        DatabaseInsert.s  + "Condition, "
        
        DatabaseInsert.s  + "Category, "
        
        DatabaseInsert.s  + "Importance, "
        
        DatabaseInsert.s  + "Loanedto, "
        
        DatabaseInsert.s  + "Comments, "
        
       ;DatabaseInsert.s  + "Itempicture, "
        
       ;DatabaseInsert.s  + "Itemdocument, "
        
        DatabaseInsert.s  + "Cost, "
        
        DatabaseInsert.s  + "Tax, "
        
        DatabaseInsert.s  + "Delivery, "
        
        DatabaseInsert.s  + "Othercost, "
        
        DatabaseInsert.s  + "Resale, "
        
        DatabaseInsert.s  + "Paidby, "
        
        DatabaseInsert.s  + "Warrantyperiod, "
        
        DatabaseInsert.s  + "Warrantyword, "
        
        DatabaseInsert.s  + "Warrantyactive, "
        
        DatabaseInsert.s  + "Warrantyextra, "
        
        DatabaseInsert.s  + "Insured, "
        
        DatabaseInsert.s  + "Insuredamount, "
        
        DatabaseInsert.s  + "Insuredon, "
        
        DatabaseInsert.s  + "Insurername, "
        
        DatabaseInsert.s  + "Policynumber, "
        
        DatabaseInsert.s  + "Contactnumber, "
        
        DatabaseInsert.s  + "Contactname, "
        
        DatabaseInsert.s  + "Contactdepartment, "
        
        DatabaseInsert.s  + "Deleted, "
        
        DatabaseInsert.s  + "Favourite, "
        
        DatabaseInsert.s  + "Locked) "
        
        DatabaseInsert.s  + "VALUES("
        
        DatabaseInsert.s  + "'" + Mystuff\Itemname          + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Supplier          + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Manufacturer      + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Modelnumber       + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Serialnumber      + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Barcode           + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Boughton          + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Working           + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Whopaid           + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Ownername         + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Location          + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Condition         + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Category          + "', "
        
        DatabaseInsert.s  + ""  + Mystuff\Importance        + ", "
        
        DatabaseInsert.s  + "'" + Mystuff\Loanedto          + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Comments          + "', "
        
       ;DatabaseInsert.s  + "'" + Mystuff\Itempicture       + "', "
        
       ;DatabaseInsert.s  + "'" + Mystuff\Itemdocument      + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Cost              + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Tax               + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Delivery          + "', "
        
        DatabaseInset.s   + "'" + Mystuff\Othercost         + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Resale            + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Paidby            + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Warrantyperiod    + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Warrantyword      + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Warrantyactive    + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Warrantyextra     + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Insured           + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Insuredamount     + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Insuredon         + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Insurername       + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Policynumber      + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Contactnumber     + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Contactname       + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Contactdepartment + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Deleted           + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Favourite         + "', "
        
        DatabaseInsert.s  + "'" + Mystuff\Locked            + "')"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, DatabaseInsert.s) <> #DatabaseUpdateFail
          
          ;----------------------------------------------------------------------------------------
          ; Get the new record number if any
          ;----------------------------------------------------------------------------------------
          
          Mystuff\Mystuffid = DatabaseLastInsertRowId()
          
          ;----------------------------------------------------------------------------------------
          ; Proceed if we got a new record number
          ;----------------------------------------------------------------------------------------
          
          If Len(Mystuff\Mystuffid)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            NumberOfItemsInList.i = CountGadgetItems(#Gadget_Mystuff_Itemlist)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            SetInfoBarArea("Headings", "Info",  "Saved: " + KillQuote(Mystuff\Itemname), #PB_Compiler_Procedure)
            
            Program\TotalCost.d + ValD(Mystuff\Cost)
            
            SetInfoBarArea("Total",  #EmptyString, StrD(Program\TotalCost.d, 2), #PB_Compiler_Procedure)
            
            SetInfoBarArea("Recipes",  #EmptyString,  Str(NumberOfItemsInList.i), #PB_Compiler_Procedure)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If Option\Messageaftersave = #True
              
              MessageRequester("Saved new stuff", "Saved: " + KillQuote(Mystuff\Itemname) + " to your stuff.", #PB_MessageRequester_Ok)
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; Now we try to copy the new picture to the local program directory
            ;--------------------------------------------------------------------------------------
            
            If Len(MyStuffEdit\PictureAndPath.s) <>  #FileIsEmpty
              
              If FileSize(MyStuffEdit\PictureAndPath.s)  <> #NoPictureFound
                
                PictureName.s = GetFilePart(MyStuffEdit\PictureAndPath.s)
                
                If CopyFile(MyStuffEdit\PictureAndPath.s, Program\PictureDirectory  + PictureName.s) <> #FileNotCopied
                  
                  DatabaseUpdate.s = "UPDATE Mystuff "
                  
                  DatabaseUpdate.s + "SET Itempicture = '"  + RepQuote(PictureName.s)    + "' "
                  
                  DatabaseUpdate.s + "WHERE Mystuffid = '"  +          Mystuff\Mystuffid + "'"
                  
                  If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
                    
                    SetInfoBarArea("Headings", "Error", "Original picture path has been updated to reflect the new local picture path.", #PB_Compiler_Procedure)
                    
                  Else

                    SetInfoBarArea("Headings", "Error", "Could not update the existing Picture name to reflect the local Picture name path.", #PB_Compiler_Procedure)
                    
                  EndIf
                  
                Else
                  
                  SetInfoBarArea("Headings", "Error", "Could not copy the original picture to the local program directory.", #PB_Compiler_Procedure)
                  
                EndIf
                
              Else
                
                SetInfoBarArea("Headings", "Error", "This Picture does not seem to exist at the selected location.", #PB_Compiler_Procedure)
                
              EndIf
              
            Else
              
              SetInfoBarArea("Headings", "Error", "There is no picture string for this record.", #PB_Compiler_Procedure)
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; Now we try to copy the new Document to the local program directory
            ;--------------------------------------------------------------------------------------
            
            If Len(MyStuffEdit\DocumentAndPath.s) <>  #FileIsEmpty
              
             ; Debug MyStuffEdit\DocumentAndPath.s + ", Length is okay so it isn't empty"
              
              If FileSize(MyStuffEdit\DocumentAndPath.s)  <> #NoDocumentFound
                
               ; Debug MyStuffEdit\DocumentAndPath.s + ", Filesize is okay so it exists"
                
                DocumentName.s = GetFilePart(MyStuffEdit\DocumentAndPath.s)
                
                If CopyFile(MyStuffEdit\DocumentAndPath.s, Program\DocumentDirectory  + DocumentName.s) <> #FileNotCopied
                  
                 ; Debug MyStuffEdit\DocumentAndPath.s + ", File copied okay so it should be in the store"
                  
                  DatabaseUpdate.s = "UPDATE Mystuff "
                  
                  DatabaseUpdate.s + "SET Itemdocument = '" + RepQuote(DocumentName.s)   + "' "
                  
                  DatabaseUpdate.s + "WHERE Mystuffid = '"  +          Mystuff\Mystuffid + "'"
                  
                  If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
                    
                   ; Debug MyStuffEdit\DocumentAndPath.s + ", Database update was okay so database change was made"
                    
                    SetInfoBarArea("Headings", "Info", "Original document has been updated to reflect the new local document", #PB_Compiler_Procedure)
                    
                  Else
                    
                   ; Debug MyStuffEdit\DocumentAndPath.s + ", Database update was NOT okay, it couldn't be changed"
                    
                   ; Debug DatabaseError()
                    
                    SetInfoBarArea("Headings", "Error", "Could not update the existing document name to reflect the local document name path.", #PB_Compiler_Procedure)
                    
                  EndIf
                  
                Else
                  
                  SetInfoBarArea("Headings", "Error", "Could not copy the original document to the local program directory.", #PB_Compiler_Procedure)
                  
                EndIf
                  
              Else
                
                SetInfoBarArea("Headings", "Error", "This document does not seem to exist at the selected location.", #PB_Compiler_Procedure)
                
              EndIf
              
            Else
              
              SetInfoBarArea("Headings", "Error", "There is no document string for this record.", #PB_Compiler_Procedure)
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            DisplayMystuffString(NumberOfItemsInList.i, "Add New Stuff")
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            UpdateLocationItemCount(Mystuff\Location)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Error",  KillQuote(Mystuff\Itemname) + " could not be saved, no record number: " + DatabaseError(), #PB_Compiler_Procedure)

          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else

          SetInfoBarArea("Headings", "Error",  KillQuote(Mystuff\Itemname) + " could not be saved, inserting record failed: " + DatabaseError(), #PB_Compiler_Procedure)

        EndIf
        
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
        
      Case  "Edit Old Stuff"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        DatabaseUpdate.s  = "UPDATE Mystuff SET "
        
        DatabaseUpdate.s  + "Itemname = '"          + Mystuff\Itemname          + "', "
        
        DatabaseUpdate.s  + "Supplier = '"          + Mystuff\Supplier          + "', "
        
        DatabaseUpdate.s  + "Manufacturer = '"      + Mystuff\Manufacturer      + "', "
        
        DatabaseUpdate.s  + "Modelnumber = '"       + Mystuff\Modelnumber       + "', "
        
        DatabaseUpdate.s  + "Serialnumber = '"      + Mystuff\Serialnumber      + "', "
        
        DatabaseUpdate.s  + "Barcode = '"           + Mystuff\Barcode           + "', "
        
        DatabaseUpdate.s  + "Boughton = '"          + Mystuff\Boughton          + "', "
        
        DatabaseUpdate.s  + "Working = '"           + Mystuff\Working           + "', "
        
        DatabaseUpdate.s  + "Whopaid = '"           + Mystuff\Whopaid           + "', "
        
        DatabaseUpdate.s  + "Ownername = '"         + Mystuff\Ownername         + "', "
        
        DatabaseUpdate.s  + "Location = '"          + Mystuff\Location          + "', "
        
        DatabaseUpdate.s  + "Condition = '"         + Mystuff\Condition         + "', "
        
        DatabaseUpdate.s  + "Category = '"          + Mystuff\Category          + "', "
        
        DatabaseUpdate.s  + "Importance = "         + Mystuff\Importance        + ", "
        
        DatabaseUpdate.s  + "Loanedto = '"          + Mystuff\Loanedto          + "', "
        
        DatabaseUpdate.s  + "Comments = '"          + Mystuff\Comments          + "', "
        
       ;DatabaseUpdate.s  + "Itempicture = '"       + Mystuff\Itempicture       + "', "
        
       ;DatabaseUpdate.s  + "Itemdocument = '"      + Mystuff\Itemdocument      + "', "
        
        DatabaseUpdate.s  + "Cost = '"              + Mystuff\Cost              + "', "
        
        DatabaseUpdate.s  + "Tax = '"               + Mystuff\Tax               + "', "
        
        DatabaseUpdate.s  + "Delivery = '"          + Mystuff\Delivery          + "', "
        
        DatabaseUpdate.s  + "Othercost = '"         + Mystuff\Othercost         + "', "
        
        DatabaseUpdate.s  + "Resale = '"            + Mystuff\Resale            + "', "
        
        DatabaseUpdate.s  + "Paidby = '"            + Mystuff\Paidby            + "', "
        
        DatabaseUpdate.s  + "Warrantyperiod = '"    + Mystuff\Warrantyperiod    + "', "
        
        DatabaseUpdate.s  + "Warrantyword = '"      + Mystuff\Warrantyword      + "', "
        
        DatabaseUpdate.s  + "Warrantyactive = '"    + Mystuff\Warrantyactive    + "', "
        
        DatabaseUpdate.s  + "Warrantyextra = '"     + Mystuff\Warrantyextra     + "', "
        
        DatabaseUpdate.s  + "Insured = '"           + Mystuff\Insured           + "', "
        
        DatabaseUpdate.s  + "Insuredamount = '"     + Mystuff\Insuredamount     + "', "
        
        DatabaseUpdate.s  + "Insuredon = '"         + Mystuff\Insuredon         + "', "
        
        DatabaseUpdate.s  + "Insurername = '"       + Mystuff\Insurername       + "', "
        
        DatabaseUpdate.s  + "Policynumber = '"      + Mystuff\Policynumber      + "', "
        
        DatabaseUpdate.s  + "Contactnumber = '"     + Mystuff\Contactnumber     + "', "
        
        DatabaseUpdate.s  + "Contactname = '"       + Mystuff\Contactname       + "', "
        
        DatabaseUpdate.s  + "Contactdepartment = '" + Mystuff\Contactdepartment + "', "
        
        DatabaseUpdate.s  + "Deleted = '"           + Mystuff\Deleted           + "', "
        
        DatabaseUpdate.s  + "Favourite = '"         + Mystuff\Favourite         + "', "
        
        DatabaseUpdate.s  + "Locked = '"            + Mystuff\Locked            + "' "
        
        DatabaseUpdate.s  + "WHERE Mystuffid = '"   + Mystuff\Mystuffid         + "'"
        
        ;----------------------------------------------------------------------------------------
        ; 
        ;----------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <>  #DatabaseUpdateFail
          
          ;--------------------------------------------------------------------------------------
          ; 
          ;--------------------------------------------------------------------------------------
          
          DisplayMystuffString(Mystuffedit\CurrentLine, "Edit Old Stuff")
          
          ;--------------------------------------------------------------------------------------
          ; 
          ;--------------------------------------------------------------------------------------
          
          UpdateLocationItemCount(Mystuff\Location )
          
          ;--------------------------------------------------------------------------------------
          ; Now we try to copy the new picture to the local program directory
          ;--------------------------------------------------------------------------------------
          
          If MyStuffEdit\Oldpicturetokeep <>  GetFilePart(MyStuffEdit\PictureAndPath.s)
            
            If Len(MyStuffEdit\PictureAndPath.s) <>  #FileIsEmpty
              
              If FileSize(MyStuffEdit\PictureAndPath.s)  <> #NoPictureFound
                
                PictureName.s = GetFilePart(MyStuffEdit\PictureAndPath.s)
                
                If CopyFile(MyStuffEdit\PictureAndPath.s, Program\PictureDirectory  + PictureName.s) <> #FileNotCopied
                  
                  DatabaseUpdate.s = "UPDATE Mystuff "
                  
                  DatabaseUpdate.s + "SET ItemPicture = '"  + RepQuote(PictureName.s) + "' "
                  
                  DatabaseUpdate.s + "WHERE Mystuffid = '"  + Mystuff\Mystuffid       + "'"
                  
                  If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
                    
                    SetInfoBarArea("Headings", "Error", "Original picture path has been updated to reflect the new local picture path.", #PB_Compiler_Procedure)
                    
                  Else

                    SetInfoBarArea("Headings", "Error", "Could not update the existing Picture name to reflect the local Picture name path.", #PB_Compiler_Procedure)
                    
                  EndIf
                  
                Else
                  
                  SetInfoBarArea("Headings", "Error", "Could not copy the original picture to the local program directory.", #PB_Compiler_Procedure)
                  
                EndIf
                
              Else
                
                SetInfoBarArea("Headings", "Error", "This Picture does not seem to exist at the selected location.", #PB_Compiler_Procedure)
                
              EndIf
              
            Else
              
              SetInfoBarArea("Headings", "Error", "There is no picture string for this record.", #PB_Compiler_Procedure)
              
            EndIf
            
          Else
            
            SetInfoBarArea("Headings", "Error", "New Picture is the same as the old Picture.", #PB_Compiler_Procedure)
            
          EndIf
          
          ;--------------------------------------------------------------------------------------
          ; Now we try to copy the new Document to the local program directory
          ;--------------------------------------------------------------------------------------
          
          If Len(MyStuffEdit\DocumentAndPath.s) <>  #FileIsEmpty
            
           ; Debug MyStuffEdit\DocumentAndPath.s + ", Length is okay so it isn't empty"
            
            If FileSize(MyStuffEdit\DocumentAndPath.s)  <> #NoDocumentFound
              
             ; Debug MyStuffEdit\DocumentAndPath.s + ", Filesize is okay so it exists"
              
              DocumentName.s = GetFilePart(MyStuffEdit\DocumentAndPath.s)
              
              If CopyFile(MyStuffEdit\DocumentAndPath.s, Program\DocumentDirectory  + DocumentName.s) <> #FileNotCopied
                
               ; Debug MyStuffEdit\DocumentAndPath.s + ", File copied okay so it should be in the store"
                
                DatabaseUpdate.s = "UPDATE Mystuff "
                
                DatabaseUpdate.s + "SET Itemdocument = '" + RepQuote(DocumentName.s)   + "' "
                
                DatabaseUpdate.s + "WHERE Mystuffid = '"  +          Mystuff\Mystuffid + "'"
                
                If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
                  
                 ; Debug MyStuffEdit\DocumentAndPath.s + ", Database update was okay so database change was made"
                  
                  SetInfoBarArea("Headings", "Info", "Original document has been updated to reflect the new local document", #PB_Compiler_Procedure)
                  
                Else
                  
                 ; Debug MyStuffEdit\DocumentAndPath.s + ", Database update was NOT okay, it couldn't be changed"
                  
                 ; Debug DatabaseError()
                  
                  SetInfoBarArea("Headings", "Error", "Could not update the existing document name to reflect the local document name path.", #PB_Compiler_Procedure)
                  
                EndIf
                
              Else
                
                SetInfoBarArea("Headings", "Error", "Could not copy the original document to the local program directory.", #PB_Compiler_Procedure)
                
              EndIf
                
            Else
              
              SetInfoBarArea("Headings", "Error", "This document does not seem to exist at the selected location.", #PB_Compiler_Procedure)
              
            EndIf
            
          Else
            
            SetInfoBarArea("Headings", "Error", "There is no document string for this record.", #PB_Compiler_Procedure)
            
          EndIf
          
          ;--------------------------------------------------------------------------------------
          ; 
          ;--------------------------------------------------------------------------------------
          
          SetInfoBarArea("Headings", "Warn",  "Edited old stuff has been saved.", #PB_Compiler_Procedure)
          
          ;--------------------------------------------------------------------------------------
          ; 
          ;--------------------------------------------------------------------------------------
          
          If Option\Messageaftersave = #True
            
            MessageRequester("Saved edited stuff", "Saved: " + KillQuote(Mystuff\Itemname) + " back to your stuff.", #PB_MessageRequester_Ok)
            
          EndIf
          
          ;--------------------------------------------------------------------------------------
          ; 
          ;--------------------------------------------------------------------------------------
          
        Else

          SetInfoBarArea("Headings", "Warn",  "Cannot save edited stuff as there was a database error:  " + DatabaseError(), #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
    EndSelect
  
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn",  "Nothing to save as the title name for this stuff is empty.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Clear the record structure and the editing temporary variables structure
  ;------------------------------------------------------------------------------------------------
  
  ClearStructure(@Mystuff,      MystuffData)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  CleanDirectory(Program\TemporaryDirectory)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CloseMyWindow(#Window_Datasheet)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 7
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP
; HideErrorLog