﻿;================================================================================================================================================================================
; Read the system preferences file or create it if missing
;================================================================================================================================================================================

Procedure SaveOptionData()
  
  ;------------------------------------------------------------------------------------------------
  ; Retrieve the program options from the database
  ;------------------------------------------------------------------------------------------------
  
  DatabaseUpdate.s = "UPDATE Options "
  
  DatabaseUpdate.s + "SET "
  
  DatabaseUpdate.s + "Snapformtoborders = '"  + Option\Snapformtoborders  + "', "
  
  DatabaseUpdate.s + "Showtitlebarclock = '"  + Option\Showtitlebarclock  + "', "
  
  DatabaseUpdate.s + "Tooltipsonoroff = '"    + Option\Tooltipsonoroff    + "', "
  
  DatabaseUpdate.s + "Stickwindowontop = '"   + Option\Stickwindowontop   + "', "
  
  DatabaseUpdate.s + "Colourbandinlist = '"   + Option\Colourbandinlist   + "', "
  
  DatabaseUpdate.s + "Messageaftersave = '"   + Option\Messageaftersave   + "' "
  
  DatabaseUpdate.s + "WHERE Optionid = 1"
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
    
    ; MessageRequester("Table read error", "Updated option data table in Mystuff database.", #PB_MessageRequester_Ok)

  Else
    
    MessageRequester("Table read error", "Could not update option data table in Mystuff database.", #PB_MessageRequester_Ok)
    
  EndIf

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 34
; FirstLine = 11
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP