;==============================================================================================================================================================================
; Find whole text strings with no splitting
;==============================================================================================================================================================================

Procedure Editor_FindTextn(Gadget.i, TextToFind.s, CaseFlag.i, Direction.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected.i FoundString.i, ExitProc.i
  
  Protected format.CHARFORMAT, Range.CHARRANGE
  
  Static editFind.FINDTEXTEX
  
  Static LastText.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If LastText.s <> TextToFind.s
    
    editFind\chrg\cpMin = 0
    
    LastText.s = TextToFind.s
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  editFind\chrg\cpMax = -1
  
  editFind\lpstrText  = @TextToFind
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Repeat
    
    If CaseFlag.i = #True
      
      FoundString.i = SendMessage_(GadgetID(Gadget.i), #EM_FINDTEXTEX, Direction.i | #FR_MATCHCASE, @editFind)
      
    Else
      
      FoundString.i = SendMessage_(GadgetID(Gadget.i), #EM_FINDTEXTEX, Direction.i, @editFind)
      
    EndIf
    
    If FoundString.i > - 1
      
      SendMessage_(GadgetID(Gadget.i), #EM_SETSEL, FoundString.i, FoundString.i + Len(TextToFind.s))
      
      editFind\chrg\cpMin = FoundString.i + 1
      
      ExitProc.i = #True
      
    Else
      
      If editFind\chrg\cpMin > 0
        
        editFind\chrg\cpMin = 0
        
      Else
        
        ExitProc.i = #True
        
      EndIf
      
    EndIf
  
  Until ExitProc.i

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 54
; FirstLine = 44
; Folding = -
; DisableDebugger
; HideErrorLog