﻿;================================================================================================================================================================================
; Set the selected text background colour
;================================================================================================================================================================================

Procedure Editor_BackgroundColour(GadgetNumber.i, BackgroundColour.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected format.CHARFORMAT2_
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  format\cbSize       = SizeOf(CHARFORMAT2_)
  
  format\dwMask       = #CFM_BACKCOLOR
  
  format\crBackColor  = BackgroundColour.i
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(GadgetNumber.i), #EM_SETCHARFORMAT, #SCF_SELECTION, @format)  
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

; typedef struct _charformat2 {
;   UINT     cbSize;
;   DWORD    dwMask;
;   DWORD    dwEffects;
;   LONG     yHeight;
;   LONG     yOffset;
;   COLORREF crTextColor;
;   BYTE     bCharSet;
;   BYTE     bPitchAndFamily;
;   TCHAR    szFaceName[LF_FACESIZE];
;   WORD     wWeight;
;   SHORT    sSpacing;
;   COLORREF crBackColor;
;   LCID     lcid;
; #if (_RICHEDIT_VER >= 0x0500)
;   union {
;     DWORD dwReserved;
;     DWORD dwCookie;
;   };
; #else 
;   DWORD    dwReserved;
; #endif 
;   SHORT    sStyle;
;   WORD     wKerning;
;   BYTE     bUnderlineType;
;   BYTE     bAnimation;
;   BYTE     bRevAuthor;
; #if (_RICHEDIT_VER >= 0x0800)
;   BYTE     bUnderlineColor;
; #endif 
; } CHARFORMAT2;
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 64
; FirstLine = 18
; Folding = -
; EnableXP