﻿;==============================================================================================================================================================================
; Search for and select text inside an editorgadget. RASHAD
;==============================================================================================================================================================================

Procedure Editor_SearchText(GadgetNumber.i, SearchText.s, Flags.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Possible Flags
  ;------------------------------------------------------------------------------------------------
  
  ; #FT_SEARCH = 1 ; Searching Top to Bottom, not the whole Word and not Case sensitive
  ; #FT_SEARCH_Bottom_to_Top = 0
  ; #FT_WHOLEWORD = 2
  ; #FT_MATCHCASE = 4
  
  ;------------------------------------------------------------------------------------------------
  ; Get CurrentCursor Position
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(GadgetNumber.i), #EM_EXGETSEL, 0, Range.CHARRANGE)
  
  ;------------------------------------------------------------------------------------------------
  ; Flag for search direction
  ;------------------------------------------------------------------------------------------------
  
  Updown.i = Flags.i & 2147483647
  
  ;------------------------------------------------------------------------------------------------
  ; Structurvariable, Type FINDTEXTEX
  ;------------------------------------------------------------------------------------------------
  
  findtext.FINDTEXTEX
  
  ;------------------------------------------------------------------------------------------------
  ; If searchdirection Flag = 1, searching Top to Bottom
  ;------------------------------------------------------------------------------------------------
  
  If Updown.i
    
    findtext\chrg\cpMin = Range\cpMax                       ; Starting by the Current CurserRangeposition (Range cpMax)
    
    findtext\chrg\cpMax = - 1                               ; -1 stands for maximum Bufferlength {equal to Len(GetGadgetText(Gadget_ID))}
    
  Else                                                     ; 
    
    findtext\chrg\cpMin = Range\cpMin                       ; Starting by the Current Cursor Rangeposition (Range cpMin)
    
    findtext\chrg\cpMax = 0                                 ; Beginning of Buffer is the end to search
    
  EndIf                                                    ;
  
  ;------------------------------------------------------------------------------------------------
  ; Simple the Address of the String to search
  ;------------------------------------------------------------------------------------------------
  
  findtext\lpstrText = @SearchText.s
  
  ;------------------------------------------------------------------------------------------------
  ; If the Text is found
  ;------------------------------------------------------------------------------------------------
  
  If SendMessage_(GadgetID(GadgetNumber.i),  #EM_FINDTEXTEX, Flags.i, @findtext) <> -1
    
    SendMessage_(GadgetID(GadgetNumber.i),   #EM_EXSETSEL,   0,       @findtext\chrgText)   ; Select the Text
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

  

; IDE Options = PureBasic 5.31 (Windows - x86)
; Folding = -
; EnableXP