;============================================================================================================================================================
; Hide the program window now
;============================================================================================================================================================

Procedure HideProgramWindow()

  ;------------------------------------------------------------------------------------------------
  ; Minimise the program to the system tray area and set a tool tip
  ;------------------------------------------------------------------------------------------------

  Program\TrayState = #True

  ;------------------------------------------------------------------------------------------------
  ; Hide the window now
  ;------------------------------------------------------------------------------------------------

  HideWindow(#Window_Mystuff, #True)

  ;------------------------------------------------------------------------------------------------
  ; Add the system tray icon now
  ;------------------------------------------------------------------------------------------------

  AddSysTrayIcon(#Systray_Mystuff_Tray, WindowID(#Window_Mystuff), ImageID(#Image_Program_Mystuff))

  ;------------------------------------------------------------------------------------------------
  ; Add a tool tip to the tray
  ;------------------------------------------------------------------------------------------------

  SysTrayIconToolTip(#Systray_Mystuff_Tray, #SystrayNote)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 31
; Folding = -
; EnableXP