;==============================================================================================================================================================================
; Turn tool tips on and off as needed
;==============================================================================================================================================================================

Procedure ToggleToolTips()

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If Option\Tooltipsonoroff = #True
  
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

    Option\Tooltipsonoroff = #False
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    ; ToggleBalloonToolTips(#Window_MyStuff, #False)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    Message.s = "The global form tool tips have now been turned off." 
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

  ElseIf Option\Tooltipsonoroff = #False
  
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

    Option\Tooltipsonoroff = #True
    
    ;----------------------------------------------------------------------------------------------
    ; Load the Tooltipsonoroff for the main window
    ;----------------------------------------------------------------------------------------------
  
    ;ToggleBalloonToolTips(#Window_MyStuff, #True)

    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

    Message.s = "The global form tool tips have now been turned on."
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ForEach ToolTips()
  
    SendMessage_(ToolTips()\pbHandleTip, #TTM_ACTIVATE, Option\Tooltipsonoroff, 0)

  Next
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------

  SetMenuItemState(#MenuBar_MyStuff,  #MenuBar_MyStuff_Tooltipsonoroff,  Option\Tooltipsonoroff)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  SetInfoBarArea("Headings", "Info", Message.s, #PB_Compiler_Procedure)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 66
; FirstLine = 49
; Folding = -
; DisableDebugger
; HideErrorLog