﻿;==============================================================================================================================================================================
; Copyright:    MGB Technical Services, 2016.
; 
; License:      Freeware. Do what you want with it EXCEPT SELL IT which is expressly forbidden, acknowledge the source 
;               please. License for the expat XML parser is in the distribution directory. 'Expat XML parser license.txt'
; 
; Code format:  Purebasic, v5.23x X86 to 5.44x86 source code project.
; 
; Dependancies: None.
; 
; Graphics:     Most graphics came from the Mattahan's BUUF sets
; 
; Thanks:       My wife Susan!!! InfraTec, ElectroChrisso, Rashad, NetMaestro and a cast of thousands
;
; Notes:        I've tried to comment wherever I could but there are just so many hours in the day. The code is 100% finished
;               as far as I am cencerned. I you want more, ask me or code it in yourself, you have the source code.
; 
;               I've tried to overload the options available to users. Menu options are duplicated by keyboard shortcuts.
;
; Addendum:     Before you complain that this program has destroyed something or did something you didn't like, have the 
;               decency and intelligence to actually read through the code and NOT TEST IT on LIVE DATA but copies. It is
;               NOT MY JOB to rescue you from your own laziness or obdurate stupidity. I have slaved my hairy ass off for
;               for this program. You are a coder and presumably know what you are doing.
; 
; Changes:      Error log module and assembly error catcher in case debug doesn't always work properly. It doesn't here.
; 
; 
; Notes:        The error log is rewritten every time you start the program, to the same name as the program name and version.
;               No dated logs as I didn't want tons of temp log files to follow. And it is also flushed to disk every 50
;               entries or at program end to minimise disk writes in case you are running on a USB key.
; 
;               I've tried to minimise database queries for the same reason as well.
;==========================================================================================================================================================
; 
;==========================================================================================================================================================

UseJPEG2000ImageDecoder()                                                                             ; PureBasic native image decoder
UseJPEGImageDecoder()                                                                                 ; PureBasic native image decoder
UseTGAImageDecoder()                                                                                  ; PureBasic native image decoder
UseTIFFImageDecoder()                                                                                 ; PureBasic native image decoder
UsePNGImageDecoder()                                                                                  ; PureBasic native image decoder

;==========================================================================================================================================================
; Used for SQLite database support
;==========================================================================================================================================================

UseSQLiteDatabase()                                                                                   ; Tell compiler we are using SQLite support

;==========================================================================================================================================================
; Find out if there is a working desktop environment
;==========================================================================================================================================================

ExamineDesktops()                                                                                     ; Will be used for toolbar hiding later

;==========================================================================================================================================================
; Don't use this while in the IDE as internal debugger may not work right
;==========================================================================================================================================================

;XIncludeFile "Modules\Generic\_ErrorHandler.pbi"                                                     ; A generic error handler for reporting crashes.

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

;OnErrorCall(@ErrorHandler())                                                                          ; Handle errors properly

;==========================================================================================================================================================
; Standard file created by the visual designer and my own personal files
;==========================================================================================================================================================

XIncludeFile "Mystuff_Constants.pb"                                                                   ; Visual designer generated constants
XIncludeFile "Mystuff_Windows.pb"                                                                     ; Visual designer generated window code
XIncludeFile "Mystuff_MyDeclarations.pb"                                                              ; My procedural declarations
XIncludeFile "Mystuff_MyConstants.pb"                                                                 ; My personal constants
XIncludeFile "Mystuff_MyTwainimport.pb"                                                               ; Harkon's easy TWAIN scanner interface code

;==========================================================================================================================================================
; NetMaestro's mouse hover events code
;==========================================================================================================================================================

XIncludeFile "Modules\ThirdParty\_FB_OwnerDrawComboFonts.pbi"                                         ; Fluid Byte's owner drawn combo box
XIncludeFile "Modules\ThirdParty\_NM_Hover.pbi"                                                       ; NetMaestro's Hover library
XIncludeFile "Modules\ThirdParty\_KM_RatingGadget.pbi"                                                ; Kenmo's rating gadget procedures, data etc
XIncludeFile "Modules\ThirdParty\_NL_SortListIcongadget.pbi"                                          ; Nalor and Dige's sort ListIconGadget rows
XIncludeFile "Modules\ThirdParty\_HK_PurePDF 2_25.pbi"                                                ; Harkon's conversion of ABBKlaus's PDF creation code
XIncludeFile "Modules\ThirdParty\_SR_MenuColourPicker.pbi"                                            ; Srod's popup menu colour picker

;==============================================================================================================================================================================
; Freak, Srod, Sparkie, Richedit handling
;==============================================================================================================================================================================

XIncludeFile "Modules\Rtf\Rtf Tools\_CatchRTF.pbi"                                                    ; Load an RTF text file from datasection and put it into the editorgadget (By Freak I think)
XIncludeFile "Modules\Rtf\Rtf Tools\_CatchRTF_Callback.pbi"                                           ; Callback used by CatchRFT to stream an RTF text file fron datasection and put it into the editorgadget

;==========================================================================================================================================================
; RASHAD
;==========================================================================================================================================================

XIncludeFile "Modules\Rtf\Rashad\_EditorColour.pbi"                                                   ; Colour selected items
XIncludeFile "Modules\Rtf\Rashad\_Clearselections.pbi"                                                ; Clear previous coloured selections
XIncludeFile "Modules\Rtf\Rashad\_SearchAndColour.pbi"                                                ; Search for selected strings

;==========================================================================================================================================================
; Generic modules used by all programs, no dependancies on anything else
;==========================================================================================================================================================

XIncludeFile "Modules\Generic\_AllowOnly.pbi"                                                         ; Prevent certain predefined characters being entered into string gadgets
XIncludeFile "Modules\Generic\_ByteCalc.pbi"                                                          ; AND51's correct file size calculation code
XIncludeFile "Modules\Generic\_ClearCurrencyFormat.pbi"                                               ; Clear the currency formatting characters as they are not stored in the database
XIncludeFile "Modules\Generic\_CleanDirectory.pbi"                                                    ; Clean a directory and all of its files no matter what attribute they have
XIncludeFile "Modules\Generic\_FormatMenu.pbi"                                                        ; Format menu text and shortcut strings to nice length
XIncludeFile "Modules\Generic\_FormatField.pbi"                                                       ; Format the passed string to the correct field length for printing
XIncludeFile "Modules\Generic\_FormatNumber.pbi"                                                      ; Format a number with commas in the right place. BasicallyPure
XIncludeFile "Modules\Generic\_GetCurrency.pbi"                                                       ; Format the currency correctly according to the locality
XIncludeFile "Modules\Generic\_GetShortcutText.pbi"                                                   ; Get the text of the associated shortcut constant
XIncludeFile "Modules\Generic\_GetWindowTitleBarDetails.pbi"                                          ; Get the current windows title bar height
XIncludeFile "Modules\Generic\_LastLine.pbi"                                                          ; Go to the last line of a ListIconGadget
XIncludeFile "Modules\Generic\_MakeSureDirectoryPathExists.pbi"                                       ; Need a unicode aware version of the API directory creator
XIncludeFile "Modules\Generic\_MixedComboCaseEx.pbi"                                                  ; First letter uppercase in a combo box. srod!.
XIncludeFile "Modules\Generic\_MixedStringCase.pbi"                                                   ; First letter uppercase in a string box. srod!
XIncludeFile "Modules\Generic\_ProperCaseString.pbi"                                                  ; Flip a mixed string into all proper case
XIncludeFile "Modules\Generic\_RemoveBorders.pbi"                                                     ; Remove borders from various gadgets
XIncludeFile "Modules\Generic\_StringFirstUpper.pbi"                                                  ; Convert the first character of a string to uppercase
XIncludeFile "Modules\Generic\_TextToXML.pbi"                                                         ; Replace bad characters with XML compatible ones. Thorsten Hoeppner
XIncludeFile "Modules\Generic\_XMLToText.pbi"                                                         ; Strip illegal characters from text strings

;==========================================================================================================================================================
; Custom procedures
;==========================================================================================================================================================

XIncludeFile "Modules\Custom\_BalloonToolTip.pbi"                                                     ; Add balloon tooltips with individual fonts and icons
XIncludeFile "Modules\Custom\_ChangeSearchCue.pbi"                                                    ; Change the search cue text when field names change in combo boxes
XIncludeFile "Modules\Custom\_CloseMyWindow.pbi"                                                      ; Close the window And reset the mutex
XIncludeFile "Modules\Custom\_GetIconHandle.pbi"                                                      ; Copy the icon into memory while deleting the original image copied from
XIncludeFile "Modules\Custom\_IsoDate.pbi"                                                            ; Convert an ISO format date to Australian and back
XIncludeFile "Modules\Custom\_SetDate.pbi"                                                            ; Sort out the date and display it
XIncludeFile "Modules\Custom\_SetInfoBarArea.pbi"                                                     ; Send messages and error reports to the fake status bar area
XIncludeFile "Modules\Custom\_SelectFocusGadget.pbi"                                                  ; Select which gadgets is used when the user presses Return
XIncludeFile "Modules\Custom\_SetHoverIcons.pbi"                                                      ; Set the correct icons to the selected hoverable gadget
XIncludeFile "Modules\Custom\_SetSearchCue.pbi"                                                       ; Setup the search box cue text
XIncludeFile "Modules\Custom\_StatusBarButtonTip.pbi"                                                 ; Set and display button toolbar/menu text in the statusbar
XIncludeFile "Modules\Custom\_TitleBarClock.pbi"                                                      ; Run an asynchronous clock in the window title bar
XIncludeFile "Modules\Custom\_WindowCallback.pbi"                                                     ; Window snap, strikeoutfont and more
XIncludeFile "Modules\Custom\_WriteErrorLog.pbi"                                                      ; Write the error log to disk in the temporary directory
XIncludeFile "Modules\Custom\_WordWrapString.pbi"                                                     ; Wrap a string to a specified boundary

;==========================================================================================================================================================
; Database management
;==========================================================================================================================================================

XIncludeFile "Modules\Database\_CountRecords.pbi"                                                     ; Count the number of records in an SQLite database
XIncludeFile "Modules\Database\_DatabaseLastInsertRowId.pbi"                                          ; Get the ID of the last inserted record
XIncludeFile "Modules\Database\_FillCombo.pbi"                                                        ; Fill a combobox gadget from a linked list, SQLite version
XIncludeFile "Modules\Database\_KillQuote.pbi"                                                        ; Kill double quotes in strings for display purposes
XIncludeFile "Modules\Database\_LastRecord.pbi"                                                       ; Find the last record number in the database, not necessarily the last record though due to deletions (fang)
XIncludeFile "Modules\Database\_OpenSystemDatabase.pbi"                                               ; Open the main system database
XIncludeFile "Modules\Database\_RepQuote.pbi"                                                         ; Uncle Berikco's routine to properly replace single quotes with double for SQL passing
XIncludeFile "Modules\Database\_SetSearchQuery.pbi"                                                   ; Alias the search type text to SQLite operators

;==========================================================================================================================================================
; Local system preferences
;==========================================================================================================================================================

XIncludeFile "Modules\Preferences\_ReadOptionData.pbi"                                                ; Read the options preference file
XIncludeFile "Modules\Preferences\_SaveOptionData.pbi"                                                ; Save the options preference file

;==========================================================================================================================================================
; All program toggles
;==========================================================================================================================================================

XIncludeFile "Modules\Toggles\_ToggleScreenSnap.pbi"                                                  ; Turn border snap on and off as needed
XIncludeFile "Modules\Toggles\_ToggleShowClock.pbi"                                                   ; Turn time updating on in the title bar
XIncludeFile "Modules\Toggles\_ToggleToolTips.pbi"                                                    ; Turn tool tips on and off as needed
XIncludeFile "Modules\Toggles\_ToggleStickyWindow.pbi"                                                ; Turn sticking on top of other windows on or off
XIncludeFile "Modules\Toggles\_ToggleColourBand.pbi"                                                  ; Turn alternate list display banding on or off
XIncludeFile "Modules\Toggles\_ToggleMessageSave.pbi"                                                 ; Turn save messages on of off

;==============================================================================================================================================================================
; Hiding program to the task bar and showing it again
;==============================================================================================================================================================================

XIncludeFile "Modules\Security\_HideProgramWindow.pbi"                                                ; Hide the program window
XIncludeFile "Modules\Security\_ShowProgramWindow.pbi"                                                ; Show the program window

;==========================================================================================================================================================
; File menu procedures
;==========================================================================================================================================================

XIncludeFile "Modules\Files\_Backupmystuff.pbi"                                                       ; Create dated backups of your database
XIncludeFile "Modules\Files\_Deleteallmystuff.pbi"                                                    ; Delete all tables and data in mystuff database
XIncludeFile "Modules\Files\_Vacuummystuff.pbi"                                                       ; Vacuum wasted space in the database from killed entries
XIncludeFile "Modules\Files\_Exportmystuff.pbi"                                                       ; Export all my stuff to the temporary directory
XIncludeFile "Modules\Files\_ImportMyStuff.pbi"                                                       ; Import an XML file of Mystuff entries
XIncludeFile "Modules\Files\_ImportMyStuffNode.pbi"                                                   ; Decode Mystuff node data

;==========================================================================================================================================================
; Location handling
;==========================================================================================================================================================

XIncludeFile "Modules\Locations\_Addlocation.pbi"                           ; Inputrequester          ; Add a new location to the location bar
XIncludeFile "Modules\Locations\_Copylocation.pbi"                                                    ; Copy the current location to the clipboard
XIncludeFile "Modules\Locations\_DeleteLocation.pbi"                                                  ; Delete an existing location from the location bar
XIncludeFile "Modules\Locations\_EditLocation.pbi"                          ; Inputrequester          ; Edit the current location and update the mystuff entries for that location
XIncludeFile "Modules\Locations\_ExportLocations.pbi"                                                 ; Export current locations to a text file on disk
XIncludeFile "Modules\Locations\_ImportLocations.pbi"                       ; ToDo (Save to database) ; Import locations from a text file on disk
XIncludeFile "Modules\Locations\_SaveLocation.pbi"                                                    ; Save the new or edsited location data

XIncludeFile "Modules\Locations\_GetLocations.pbi"                                                    ; Load the standard locations and user defined ones from the database
XIncludeFile "Modules\Locations\_Sortlocations.pbi"                                                   ; Sort the locations alphabetically when saved
XIncludeFile "Modules\Locations\_UpdateLocationItemCount.pbi"                                         ; Update the Location itemcount field each time we add, change or delete locations

;==========================================================================================================================================================
; Handling of my stuff
;==========================================================================================================================================================

XIncludeFile "Modules\Mystuff\_AddNewStuff.pbi"                             ; Window                  ; Add new stuff to my home inventory list
XIncludeFile "Modules\Mystuff\_CopyOldStuff.pbi"                                                      ; Copy my current stuff to the system clipboard
XIncludeFile "Modules\Mystuff\_DeleteOldStuff.pbi"                                                    ; Mark the selected stuff as deleted
XIncludeFile "Modules\Mystuff\_EditOldStuff.pbi"                            ; Window                  ; Edit an older item in my stuff
XIncludeFile "Modules\Mystuff\_KillThisStuff.pbi"                                                     ; Permanently delete the current stuff
XIncludeFile "Modules\Mystuff\_LockThisStuff.pbi"                                                     ; Lock the currently selected stuff
XIncludeFile "Modules\Mystuff\_FavouriteStuff.pbi"                                                    ; Mark this stuff as a favourite
XIncludeFile "Modules\Mystuff\_PrintThisStuff.pbi"                          ; Todo                    ; Print a report of the currently selected stuff
XIncludeFile "Modules\Mystuff\_Pictureofstuff.pbi"                                                    ; Show a bigger version of the stored picture
XIncludeFile "Modules\Mystuff\_SaveMyStuff.pbi"                                                       ; Save the new or edited stuff

;==========================================================================================================================================================
; Add picture from disk
;==========================================================================================================================================================

XIncludeFile "Modules\Mystuff\_AddNewPicture.pbi"                           ; PB requester            ; Add a new Picture to the old or edited record
XIncludeFile "Modules\Mystuff\_ClearOldPicture.pbi"                                                   ; Clear the existing picture from the display and name field
XIncludeFile "Modules\Mystuff\_DeleteOldPicture.pbi"                                                  ; Delete the existing picture from the display, name field and local storage
XIncludeFile "Modules\Mystuff\_LoadOldPicture.pbi"                                                    ; Load a linked Picture for the passed picture name

;==========================================================================================================================================================
; Scan picture from TWAIN source
;==========================================================================================================================================================

XIncludeFile "Modules\Mystuff\_ScanPicture.pbi"                             ; PB requester            ; Scan a Picture into the current record

;==========================================================================================================================================================
; Lookup the model number and manufacturer in your browser
;==========================================================================================================================================================

XIncludeFile "Modules\Mystuff\_LookupModel.pbi"                                                       ; Lookup the model number and manufacturer in your browser

;==========================================================================================================================================================
; Add document from disk
;==========================================================================================================================================================

XIncludeFile "Modules\Mystuff\_AddNewDocument.pbi"                           ; PB requester           ; Load a linked Document for the passed Document name
XIncludeFile "Modules\Mystuff\_ViewDocument.pbi"                             ; Window                 ; View the attached document on top of the data sheet
XIncludeFile "Modules\Mystuff\_RelinkDocument.pbi"                                                    ; Find, copy and relink a lost Document

;==========================================================================================================================================================
; Scan document from TWAIN source
;==========================================================================================================================================================

XIncludeFile "Modules\Mystuff\_ScanDocument.pbi"                            ; Window                  ; Scan a document into the current record
XIncludeFile "Modules\Mystuff\_AquireDocument.pbi"                                                    ; Aquire a document image from the scanner
XIncludeFile "Modules\Mystuff\_ScanNextDocumentPage.pbi"                                              ; Scan the next document page
XIncludeFile "Modules\Mystuff\_SaveScannedDocumentPages.pbi"                                          ; Save the scanned document pages to PDF

;==========================================================================================================================================================
; Display strings in the display gadget, used by all routines
;==========================================================================================================================================================

XIncludeFile "Modules\Mystuff\_DisplayMystuffString.pbi"                                              ; Handle all list display jobs from add, edit, list, import modes etc
XIncludeFile "Modules\Mystuff\_DisplayMystuffDetails.pbi"                                             ; Show the current record on the status bar area

;==========================================================================================================================================================
; Show a matching list of titles for the selected location
;==========================================================================================================================================================

XIncludeFile "Modules\Mystuff\_GetMyStuffForLocation.pbi"                                             ; Show the stuff for the currently selected location

;==========================================================================================================================================================
; Show a matching list of titles for the selected search string
;==========================================================================================================================================================

XIncludeFile "Modules\Mystuff\_SimpleSearch.pbi"                                                      ; Show my stuff for the currently selected location, field and string

;==========================================================================================================================================================
; Help and information
;==========================================================================================================================================================

XIncludeFile "Modules\Information\_Aboutmystuff.pbi"                        ; Window                  ; Mystuff 'About' window
XIncludeFile "Modules\Information\_Keyboardshortcuts.pbi"                   ; Window                  ; Show a list of all the keyboard shortcuts
XIncludeFile "Modules\Information\_Statisticsformystuff.pbi"                ; Window                  ; Show statistics about the current database

;==========================================================================================================================================================
; Miscellaneous
;==========================================================================================================================================================

XIncludeFile "Modules\Database\_OneTimeLocationUpdateCount.pbi"             ; Administrative only     ; One off routine to update the ItemCount field in the Location table from the Location field in the Mystuff table

;==========================================================================================================================================================
; Administrative
;==========================================================================================================================================================

XIncludeFile "Modules\Files\_ImportMyDocuments.pbi"                         ; Administrative only     ; Mass document import from selected directory

;==========================================================================================================================================================
; Main program event handling loop
;==========================================================================================================================================================

If Window_Mystuff()
  
  ;//**********************************************************************************************
  ;// Try to match the message bar colour to everything else
  ;//**********************************************************************************************
  
  SetGadgetColor(#Gadget_Mystuff_Messages, #PB_Gadget_BackColor, $EDEDED)
  
  ;//**********************************************************************************************
  ;// Remove the editorgadget message bar borders
  ;//**********************************************************************************************
  
  RemoveBorders(#Gadget_Mystuff_Messages)
  
  ;//**********************************************************************************************
  ;// Remove vertical and hirozontal scroll bars from the editor message bar
  ;//**********************************************************************************************
  
 ;SendMessage_(GadgetID(#Gadget_Mystuff_Messages),  #EM_LIMITTEXT,           80,  0)
  SendMessage_(GadgetID(#Gadget_Mystuff_Messages),  #EM_SHOWSCROLLBAR, #SB_VERT,  0)
  SendMessage_(GadgetID(#Gadget_Mystuff_Messages),  #EM_SHOWSCROLLBAR, #SB_HORZ,  0)
  
  ;//**********************************************************************************************
  ;// Setup the various semaphores and switches that are not database dependant
  ;//**********************************************************************************************
  
  If Not TWAIN_IsAvailable()
    MessageRequester("Scan functions", "TWAIN scanner interface is not available Scanner will not work.")
  EndIf
  
  ;//**********************************************************************************************
  ;// Setup the various semaphores and switches that are not database dependant
  ;//**********************************************************************************************
  
  ; Set the initial quit state of the program
  
  Program\QuitValue = #False
  
  ; Set the state of certain jobs that only run once
  
  Program\FirstTime = #False
  
  ;//**********************************************************************************************
  ;// Add keyboard shortcuts
  ;//**********************************************************************************************
  
  ;  Files
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Backupmystuff,        #Shortcut_Mystuff_Backupmystuff)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Deleteallmystuff,     #Shortcut_Mystuff_Deleteallmystuff)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Vacuummystuff,        #Shortcut_Mystuff_Vacuummystuff)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Exportmystuff,        #Shortcut_Mystuff_Exportmystuff)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Importmystuff,        #Shortcut_Mystuff_Importmystuff)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Exitmystuff,          #Shortcut_Mystuff_Exitmystuff)
  ; Locations
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Addlocation,          #Shortcut_Mystuff_Addlocation)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Copylocation,         #Shortcut_Mystuff_Copylocation)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Deletelocation,       #Shortcut_Mystuff_Deletelocation)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Editlocation,         #Shortcut_Mystuff_Editlocation)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Exportlocations,      #Shortcut_Mystuff_Exportlocations)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Importlocations,      #Shortcut_Mystuff_Importlocations)
  ; My stuff
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Addnewstuff,          #Shortcut_Mystuff_Addnewstuff)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Copyoldstuff,         #Shortcut_Mystuff_Copyoldstuff)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Deleteoldstuff,       #Shortcut_Mystuff_Deleteoldstuff)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Editoldstuff,         #Shortcut_Mystuff_Editoldstuff)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Killthisstuff,        #Shortcut_Mystuff_Killthisstuff)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Lockthisstuff,        #Shortcut_Mystuff_Lockthisstuff)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Favouritestuff,       #Shortcut_Mystuff_Favouritestuff)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Printthisstuff,       #Shortcut_Mystuff_Printthisstuff)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Pictureofstuff,       #Shortcut_Mystuff_Pictureofstuff)
  ; Search
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_CheckReturn,          #Shortcut_Mystuff_CheckReturn)
  ; Options
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Colourbandinlist,     #Shortcut_Mystuff_Colourbandinlist)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Messageaftersave,     #Shortcut_Mystuff_Messageaftersave)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Stickwindowontop,     #Shortcut_Mystuff_Stickwindowontop)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Showtitlebarclock,    #Shortcut_Mystuff_Showtitlebarclock)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Snapformtoborders,    #Shortcut_Mystuff_Snapformtoborders)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Tooltipsonoroff,      #Shortcut_Mystuff_Tooltipsonoroff)
  
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Lockmystuffwindow,    #Shortcut_Mystuff_Lockmystuffwindow)
  ; Setup
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Setupmystuff,         #Shortcut_Mystuff_Setupmystuff)
  ; Help
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Aboutmystuff,         #Shortcut_Mystuff_Aboutmystuff)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Keyboardshortcuts,    #Shortcut_Mystuff_Keyboardshortcuts)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Showhelp,             #Shortcut_Mystuff_Showhelp)

  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Statisticsformystuff, #Shortcut_Mystuff_Statisticsformystuff)
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_Viewmystufflogfile,   #Shortcut_Mystuff_Viewmystufflogfile)
  ; Administrative
  AddKeyboardShortcut(#Window_MyStuff, #Keys_Mystuff_ImportMyDocuments,    #Shortcut_Mystuff_ImportMyDocuments)
  
  ;//**********************************************************************************************
  ;// Create my main menu
  ;//**********************************************************************************************
  
  If CreateImageMenu(#MenuBar_Mystuff,WindowID(#Window_Mystuff))
    MenuTitle("Files")
    MenuItem(#MenuBar_Mystuff_Backupmystuff,        FormatMenu(#Keystext_Mystuff_Backupmystuff,         GetShortcutText(#Keys_Mystuff_Backupmystuff),         45),  ImageID(#MenuBarIcon_Mystuff_Backupmystuff))
    MenuItem(#MenuBar_Mystuff_Deleteallmystuff,     FormatMenu(#Keystext_Mystuff_Deleteallmystuff,      GetShortcutText(#Keys_Mystuff_Deleteallmystuff),      45),  ImageID(#MenuBarIcon_Mystuff_Deleteallmystuff))
    MenuItem(#MenuBar_Mystuff_Vacuummystuff,        FormatMenu(#Keystext_Mystuff_Vacuummystuff,         GetShortcutText(#Keys_Mystuff_Vacuummystuff),         45),  ImageID(#MenuBarIcon_Mystuff_Vacuummystuff))
    MenuBar()
    MenuItem(#MenuBar_Mystuff_Exportmystuff,        FormatMenu(#Keystext_Mystuff_Exportmystuff,         GetShortcutText(#Keys_Mystuff_Exportmystuff),         45),  ImageID(#MenuBarIcon_Mystuff_Exportmystuff))
    MenuItem(#MenuBar_Mystuff_Importmystuff,        FormatMenu(#Keystext_Mystuff_Importmystuff,         GetShortcutText(#Keys_Mystuff_Importmystuff),         45),  ImageID(#MenuBarIcon_Mystuff_Importmystuff))
    MenuBar()
    MenuItem(#MenuBar_Mystuff_Exitmystuff,          FormatMenu(#Keystext_Mystuff_Exitmystuff,           GetShortcutText(#Keys_Mystuff_Exitmystuff),           45),  ImageID(#MenuBarIcon_Mystuff_Exitmystuff))
    MenuTitle("Locations")
    MenuItem(#MenuBar_Mystuff_Addlocation,          FormatMenu(#Keystext_Mystuff_Addlocation,           GetShortcutText(#Keys_Mystuff_Addlocation),           45),  ImageID(#MenuBarIcon_Mystuff_Addlocation))
    MenuItem(#MenuBar_Mystuff_Copylocation,         FormatMenu(#Keystext_Mystuff_Copylocation,          GetShortcutText(#Keys_Mystuff_Copylocation),          45),  ImageID(#MenuBarIcon_Mystuff_Copylocation))
    MenuItem(#MenuBar_Mystuff_Deletelocation,       FormatMenu(#Keystext_Mystuff_Deletelocation,        GetShortcutText(#Keys_Mystuff_Deletelocation),        45),  ImageID(#MenuBarIcon_Mystuff_Deletelocation))
    MenuItem(#MenuBar_Mystuff_Editlocation,         FormatMenu(#Keystext_Mystuff_Editlocation,          GetShortcutText(#Keys_Mystuff_Editlocation),          45),  ImageID(#MenuBarIcon_Mystuff_Editlocation))
    MenuBar()
    MenuItem(#MenuBar_Mystuff_Exportlocations,      FormatMenu(#Keystext_Mystuff_Exportlocations,       GetShortcutText(#Keys_Mystuff_Exportlocations),       45),  ImageID(#MenuBarIcon_Mystuff_Exportlocations))
    MenuItem(#MenuBar_Mystuff_Importlocations,      FormatMenu(#Keystext_Mystuff_Importlocations,       GetShortcutText(#Keys_Mystuff_Importlocations),       45),  ImageID(#MenuBarIcon_Mystuff_Importlocations))
    MenuTitle("My stuff")
    MenuItem(#MenuBar_Mystuff_Addnewstuff,          FormatMenu(#Keystext_Mystuff_Addnewstuff,           GetShortcutText(#Keys_Mystuff_Addnewstuff),           45),  ImageID(#MenuBarIcon_Mystuff_Addnewstuff))
    MenuItem(#MenuBar_Mystuff_Copyoldstuff,         FormatMenu(#Keystext_Mystuff_Copyoldstuff,          GetShortcutText(#Keys_Mystuff_Copyoldstuff),          45),  ImageID(#MenuBarIcon_Mystuff_Copyoldstuff))
    MenuItem(#MenuBar_Mystuff_Deleteoldstuff,       FormatMenu(#Keystext_Mystuff_Deleteoldstuff,        GetShortcutText(#Keys_Mystuff_Deleteoldstuff),        45),  ImageID(#MenuBarIcon_Mystuff_Deleteoldstuff))
    MenuItem(#MenuBar_Mystuff_Editoldstuff,         FormatMenu(#Keystext_Mystuff_Editoldstuff,          GetShortcutText(#Keys_Mystuff_Editoldstuff),          45),  ImageID(#MenuBarIcon_Mystuff_Editoldstuff))
    MenuItem(#MenuBar_Mystuff_Killthisstuff,        FormatMenu(#Keystext_Mystuff_Killthisstuff,         GetShortcutText(#Keys_Mystuff_Killthisstuff),         45),  ImageID(#MenuBarIcon_Mystuff_Killthisstuff))
    MenuItem(#MenuBar_Mystuff_Lockthisstuff,        FormatMenu(#Keystext_Mystuff_Lockthisstuff,         GetShortcutText(#Keys_Mystuff_Lockthisstuff),         45),  ImageID(#MenuBarIcon_Mystuff_Lockthisstuff))
    MenuItem(#MenuBar_Mystuff_Favouritestuff,       FormatMenu(#Keystext_Mystuff_Favouritestuff,        GetShortcutText(#Keys_Mystuff_Favouritestuff),        45),  ImageID(#MenuBarIcon_Mystuff_Favouritestuff))
    MenuItem(#MenuBar_Mystuff_Printthisstuff,       FormatMenu(#Keystext_Mystuff_Printthisstuff,        GetShortcutText(#Keys_Mystuff_Printthisstuff),        45),  ImageID(#MenuBarIcon_Mystuff_Printthisstuff))
    MenuBar()
    MenuItem(#MenuBar_MyStuff_Pictureofstuff,       FormatMenu(#Keystext_Mystuff_Pictureofstuff,        GetShortcutText(#Keys_Mystuff_Pictureofstuff),        45),  ImageID(#MenuBarIcon_Mystuff_Pictureofstuff))
    MenuTitle("Search")
    MenuItem(#MenuBar_Mystuff_CheckReturn,          FormatMenu(#Keystext_Mystuff_CheckReturn,           GetShortcutText(#Keys_Mystuff_CheckReturn),           45),  ImageID(#MenuBarIcon_Mystuff_Blank))
    MenuTitle("Options")
    MenuItem(#MenuBar_Mystuff_Colourbandinlist,     FormatMenu(#Keystext_Mystuff_Colourbandinlist,      GetShortcutText(#Keys_Mystuff_Colourbandinlist),      40))
    MenuItem(#MenuBar_Mystuff_Messageaftersave,     FormatMenu(#Keystext_Mystuff_Messageaftersave,      GetShortcutText(#Keys_Mystuff_Messageaftersave),      40))
    MenuItem(#MenuBar_Mystuff_Showtitlebarclock,    FormatMenu(#Keystext_Mystuff_Showtitlebarclock,     GetShortcutText(#Keys_Mystuff_Showtitlebarclock),     40))
    MenuItem(#MenuBar_Mystuff_Snapformtoborders,    FormatMenu(#Keystext_Mystuff_Snapformtoborders,     GetShortcutText(#Keys_Mystuff_Snapformtoborders),     40))
    MenuItem(#MenuBar_Mystuff_Stickwindowontop,     FormatMenu(#Keystext_Mystuff_Stickwindowontop,      GetShortcutText(#Keys_Mystuff_Stickwindowontop),      40))
    MenuItem(#MenuBar_Mystuff_Tooltipsonoroff,      FormatMenu(#Keystext_Mystuff_Tooltipsonoroff,       GetShortcutText(#Keys_Mystuff_Tooltipsonoroff),       40))
    MenuBar()
    MenuItem(#MenuBar_Mystuff_Lockmystuffwindow,    FormatMenu(#Keystext_Mystuff_Lockmystuffwindow,     GetShortcutText(#Keys_Mystuff_Lockmystuffwindow),     40))
    MenuTitle("Setup")
    MenuItem(#MenuBar_Mystuff_Setupmystuff,         FormatMenu(#Keystext_Mystuff_Setupmystuff,          GetShortcutText(#Keys_Mystuff_Setupmystuff),          45),  ImageID(#MenuBarIcon_Mystuff_Setupmystuff))
    MenuTitle("Help")
    MenuItem(#MenuBar_Mystuff_Aboutmystuff,         FormatMenu(#Keystext_Mystuff_Aboutmystuff,          GetShortcutText(#Keys_Mystuff_Aboutmystuff),          45),  ImageID(#MenuBarIcon_Mystuff_Aboutmystuff))
    MenuItem(#MenuBar_Mystuff_Keyboardshortcuts,    FormatMenu(#Keystext_Mystuff_Keyboardshortcuts,     GetShortcutText(#Keys_Mystuff_Keyboardshortcuts),     45),  ImageID(#MenuBarIcon_Mystuff_Keyboardshortcuts))
    MenuItem(#MenuBar_Mystuff_Showhelp,             FormatMenu(#Keystext_Mystuff_Showhelp,              GetShortcutText(#Keys_Mystuff_Showhelp),              45),  ImageID(#MenuBarIcon_Mystuff_Showhelp))
    MenuBar()
    MenuItem(#MenuBar_Mystuff_Statisticsformystuff, FormatMenu(#Keystext_Mystuff_Statisticsformystuff,  GetShortcutText(#Keys_Mystuff_Statisticsformystuff),  45),  ImageID(#MenuBarIcon_Mystuff_Statisticsformystuff))
    MenuItem(#MenuBar_Mystuff_Viewmystufflogfile,   FormatMenu(#Keystext_Mystuff_Viewmystufflogfile,    GetShortcutText(#Keys_Mystuff_Viewmystufflogfile),    45),  ImageID(#MenuBarIcon_Mystuff_Viewmystufflogfile))
  Else
    MessageRequester("Main menu", "Could not create main menu, program error, must abort.", #PB_MessageRequester_Ok)
    Program\QuitValue = #True
  EndIf
  
  ;//**********************************************************************************************
  ;// Create the locations bar popup menu
  ;//**********************************************************************************************
    
  If CreatePopupImageMenu(#PopMenuBar_Location,  #PB_Menu_ModernLook)
    MenuItem(#PopMenuBar_Location_Addlocation,      FormatMenu(#Keystext_Mystuff_Addlocation,           GetShortcutText(#Keys_Mystuff_Addlocation),           45),  ImageID(#MenuBarIcon_Mystuff_Addlocation))
    MenuItem(#PopMenuBar_Location_Copylocation,     FormatMenu(#Keystext_Mystuff_Copylocation,          GetShortcutText(#Keys_Mystuff_Copylocation),          45),  ImageID(#MenuBarIcon_Mystuff_Copylocation))
    MenuItem(#PopMenuBar_Location_Deletelocation,   FormatMenu(#Keystext_Mystuff_Deletelocation,        GetShortcutText(#Keys_Mystuff_Deletelocation),        45),  ImageID(#MenuBarIcon_Mystuff_Deletelocation))
    MenuItem(#PopMenuBar_Location_Editlocation,     FormatMenu(#Keystext_Mystuff_Editlocation,          GetShortcutText(#Keys_Mystuff_Editlocation),          45),  ImageID(#MenuBarIcon_Mystuff_Editlocation))
    MenuBar()
    MenuItem(#PopMenuBar_Location_Exportlocations,  FormatMenu(#Keystext_Mystuff_Exportlocations,       GetShortcutText(#Keys_Mystuff_Exportlocations),       45),  ImageID(#MenuBarIcon_Mystuff_Exportlocations))
    MenuItem(#PopMenuBar_Location_Importlocations,  FormatMenu(#Keystext_Mystuff_Importlocations,       GetShortcutText(#Keys_Mystuff_Importlocations),       45),  ImageID(#MenuBarIcon_Mystuff_Importlocations))
  Else
    MessageRequester("Main menu", "Could not create location popup menu, program error, must abort.", #PB_MessageRequester_Ok)
    Program\QuitValue = #True
  EndIf
    
  ;//**********************************************************************************************
  ;// Create the Mystuff bar popup menu
  ;//**********************************************************************************************
    
  If CreatePopupImageMenu(#PopMenuBar_Mystuff,  #PB_Menu_ModernLook)
    MenuItem(#PopMenuBar_Mystuff_Addnewstuff,       FormatMenu(#Keystext_Mystuff_Addnewstuff,           GetShortcutText(#Keys_Mystuff_Addnewstuff),           45),  ImageID(#MenuBarIcon_Mystuff_Addnewstuff))
    MenuItem(#PopMenuBar_Mystuff_Copyoldstuff,      FormatMenu(#Keystext_Mystuff_Copyoldstuff,          GetShortcutText(#Keys_Mystuff_Copyoldstuff),          45),  ImageID(#MenuBarIcon_Mystuff_Copyoldstuff))
    MenuItem(#PopMenuBar_Mystuff_Deleteoldstuff,    FormatMenu(#Keystext_Mystuff_Deleteoldstuff,        GetShortcutText(#Keys_Mystuff_Deleteoldstuff),        45),  ImageID(#MenuBarIcon_Mystuff_Deleteoldstuff))
    MenuItem(#PopMenuBar_Mystuff_Editoldstuff,      FormatMenu(#Keystext_Mystuff_Editoldstuff,          GetShortcutText(#Keys_Mystuff_Editoldstuff),          45),  ImageID(#MenuBarIcon_Mystuff_Editoldstuff))
    MenuItem(#PopMenuBar_Mystuff_Killthisstuff,     FormatMenu(#Keystext_Mystuff_Killthisstuff,         GetShortcutText(#Keys_Mystuff_Killthisstuff),         45),  ImageID(#MenuBarIcon_Mystuff_Killthisstuff))
    MenuItem(#PopMenuBar_Mystuff_Lockthisstuff,     FormatMenu(#Keystext_Mystuff_Lockthisstuff,         GetShortcutText(#Keys_Mystuff_Lockthisstuff),         45),  ImageID(#MenuBarIcon_Mystuff_Lockthisstuff))
    MenuItem(#PopMenuBar_Mystuff_Favouritestuff,    FormatMenu(#Keystext_Mystuff_Favouritestuff,        GetShortcutText(#Keys_Mystuff_Favouritestuff),        45),  ImageID(#MenuBarIcon_Mystuff_Favouritestuff))
    MenuItem(#PopMenuBar_Mystuff_Printthisstuff,    FormatMenu(#Keystext_Mystuff_Printthisstuff,        GetShortcutText(#Keys_Mystuff_Printthisstuff),        45),  ImageID(#MenuBarIcon_Mystuff_Printthisstuff))
    MenuBar()
    MenuItem(#PopMenuBar_MyStuff_Pictureofstuff,    FormatMenu(#Keystext_Mystuff_Pictureofstuff,        GetShortcutText(#Keys_Mystuff_Pictureofstuff),        45),  ImageID(#MenuBarIcon_Mystuff_Pictureofstuff))
  Else
    MessageRequester("Main menu", "Could not create location popup menu, program error, must abort.", #PB_MessageRequester_Ok)
    Program\QuitValue = #True
  EndIf
  
  ;//**********************************************************************************************
  ;// Test popup menu for the image gadget
  ;//**********************************************************************************************
  
  If CreatePopupImageMenu(#PopMenubar_Datasheet, #PB_Menu_ModernLook)
    MenuItem(#PopMenubar_Datasheet_Menu_Addpicture,      FormatMenu(#Keystext_Datasheet_Menu_Addpicture,          GetShortcutText(#Keys_Datasheet_Menu_Addpicture),          45),  ImageID(#MenuBarIcon_Mystuff_Addnewstuff))
    MenuItem(#PopMenuBar_Datasheet_Menu_Clearpicture,    FormatMenu(#Keystext_Datasheet_Menu_Clearpicture,        GetShortcutText(#Keys_Datasheet_Menu_Clearpicture),        45),  ImageID(#MenuBarIcon_Mystuff_Deleteoldstuff))
    MenuItem(#PopMenuBar_Datasheet_Menu_Deletepicture,   FormatMenu(#Keystext_Datasheet_Menu_Deletepicture,       GetShortcutText(#Keys_Datasheet_Menu_Deletepicture),       45),  ImageID(#MenuBarIcon_Mystuff_Killthisstuff))
    MenuItem(#PopMenuBar_Datasheet_Menu_Scanpicture,     FormatMenu(#Keystext_Datasheet_Menu_Scanpicture,         GetShortcutText(#Keys_Datasheet_Menu_Scanpicture),         45),  ImageID(#MenuBarIcon_Mystuff_Scanthisstuff))
  Else
    MessageRequester("Main menu", "Could not create image popup menu, program error, must abort.", #PB_MessageRequester_Ok)
    Program\QuitValue = #True
  EndIf

  ;//**********************************************************************************************
  ;// First, open the system database in case we need to consult any variables here
  ;//**********************************************************************************************
  
  OpenSystemDatabase()
  
  ;//**********************************************************************************************
  ;// One off routine to update the ItemCount field in the Location table from the Location field in the Mystuff table
  ;//**********************************************************************************************
  
  ; OneTimeLocationUpdateCount()
  
  ;//**********************************************************************************************
  ;// Now, read out the system preferences to see how we need to set the program up
  ;//**********************************************************************************************
  
  ReadOptionData()
  
  ;//**********************************************************************************************
  ;// Setup the window title bar clock and messages first
  ;//**********************************************************************************************
  
  If Option\Showtitlebarclock = #False
    Option\Showtitlebarclock = #True
  ElseIf Option\Showtitlebarclock = #True
    Option\Showtitlebarclock = #False
  EndIf

  ToggleShowClock()
  
  ;//**********************************************************************************************
  ;// Load the standard locations into the location list. Re-useable routine
  ;//**********************************************************************************************
  
  GetLocations()
  
  ;//**********************************************************************************************
  ;// Load a strikeout font to be used on the item list for deleted items
  ;//**********************************************************************************************
  
  CurrentFont.i   = GetGadgetFont(#Gadget_Mystuff_Itemlist)                                           ; Get current font
  GetObject_(CurrentFont.i, SizeOf(LOGFONT), @logf.LOGFONT)
  FontName.s      = PeekS(@logf\lfFacename[0])
  hDEviceContext  = CreateDC_(@"DISPLAY", 0, 0, 0)
  LogPixSY        = GetDeviceCaps_(hDEviceContext, #LOGPIXELSY)
  DeleteDC_(hDEviceContext)
  dFontsize.F     = - (logf\lfHeight * 72) / LogPixSY
  LoadFont(#FontStrikeoutYes, FontName.s, dFontsize.F, #PB_Font_StrikeOut)                            ; Load current font and add strikeout attribute
  LoadFont(#FontStrikeoutNo,  FontName.s, dFontsize.F)
  
  ;//**********************************************************************************************
  ;// Add the SQL search type operators to the search types combo box
  ;//**********************************************************************************************
  
  Restore BeginSearchTypes
  
  While TempString.s <> "_EndSearchTypes_"
    Read.s TempString.s
    If TempString.s <> "_EndSearchTypes_"
      AddGadgetItem(#Gadget_Mystuff_Searchtype, #AtTheEndOfTheList, TempString.s, ImageID(#Image_Combo_Sqltype))
    EndIf
  Wend
  
  TempString.s = "<>"
  
  SetGadgetState(#Gadget_Mystuff_Searchtype, #FirstItem)
  
  ;//**********************************************************************************************
  ;// Add the SQL search fields available to the search fields combo box
  ;//**********************************************************************************************

  Restore BeginSqlFields
  
  While TempString.s <> "_EndSqlFields_"
    Read.s TempString.s
    If TempString.s <> "_EndSqlFields_"
      AddGadgetItem(#Gadget_Mystuff_Searchfield, #AtTheEndOfTheList, TempString.s, ImageID(#Image_Combo_Sqlfield))
    EndIf
  Wend
  
  TempString.s = "<>"
  
  SetGadgetState(#Gadget_Mystuff_Searchfield, #FirstItem)
  
  ;//**********************************************************************************************
  ;// These are your balloon tooltips used on the main form. All headings, balloon text and icons are
  ;// re-useable variables taken from the constants file.
  ;//**********************************************************************************************
  
  If Program\BalloonFontId
    BalloonToolTip(#Window_Mystuff, #Gadget_Mystuff_Addnewstuff,    Program\BalloonFontId, $FFFFFF, #Keystext_Mystuff_Addnewstuff,    #CRLF$ + GetShortCutText(#Keys_Mystuff_Addnewstuff)    + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Mystuff_Addnewstuff,    30),  GetIconHandle(#Image_Mystuff_Addnewstuff))
    BalloonToolTip(#Window_Mystuff, #Gadget_Mystuff_Copyoldstuff,   Program\BalloonFontId, $FFFFFF, #Keystext_Mystuff_Copyoldstuff,   #CRLF$ + GetShortCutText(#Keys_Mystuff_Copyoldstuff)   + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Mystuff_Copyoldstuff,   30),  GetIconHandle(#Image_Mystuff_Copyoldstuff))
    BalloonToolTip(#Window_Mystuff, #Gadget_Mystuff_Deleteoldstuff, Program\BalloonFontId, $FFFFFF, #Keystext_Mystuff_Deleteoldstuff, #CRLF$ + GetShortCutText(#Keys_Mystuff_Deleteoldstuff) + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Mystuff_Deleteoldstuff, 30),  GetIconHandle(#Image_Mystuff_Deleteoldstuff))
    BalloonToolTip(#Window_Mystuff, #Gadget_Mystuff_Editthistuff,   Program\BalloonFontId, $FFFFFF, #Keystext_Mystuff_Editoldstuff,   #CRLF$ + GetShortCutText(#Keys_Mystuff_Editoldstuff)   + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Mystuff_Editoldstuff,   30),  GetIconHandle(#Image_Mystuff_Editthistuff))
    BalloonToolTip(#Window_Mystuff, #Gadget_Mystuff_Killthisstuff,  Program\BalloonFontId, $FFFFFF, #Keystext_Mystuff_Killthisstuff,  #CRLF$ + GetShortCutText(#Keys_Mystuff_Killthisstuff)  + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Mystuff_Killthisstuff,  30),  GetIconHandle(#Image_Mystuff_Killthisstuff))
    BalloonToolTip(#Window_Mystuff, #Gadget_Mystuff_Lockthisstuff,  Program\BalloonFontId, $FFFFFF, #Keystext_Mystuff_Lockthisstuff,  #CRLF$ + GetShortCutText(#Keys_Mystuff_Lockthisstuff)  + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Mystuff_Lockthisstuff,  30),  GetIconHandle(#Image_Mystuff_Lockthisstuff))
    BalloonToolTip(#Window_Mystuff, #Gadget_Mystuff_Favouritestuff, Program\BalloonFontId, $FFFFFF, #Keystext_Mystuff_Favouritestuff, #CRLF$ + GetShortCutText(#Keys_Mystuff_Favouritestuff) + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Mystuff_Favouritestuff, 30),  GetIconHandle(#Image_Mystuff_Favouritestuff))
    BalloonToolTip(#Window_Mystuff, #Gadget_Mystuff_Printthisstuff, Program\BalloonFontId, $FFFFFF, #Keystext_Mystuff_Printthisstuff, #CRLF$ + GetShortCutText(#Keys_Mystuff_Printthisstuff) + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Mystuff_Printthisstuff, 30),  GetIconHandle(#Image_Mystuff_Printthisstuff))
    BalloonToolTip(#Window_Mystuff, #Gadget_Mystuff_Exportmystuff,  Program\BalloonFontId, $FFFFFF, #Keystext_Mystuff_Exportmystuff,  #CRLF$ + GetShortCutText(#Keys_Mystuff_Exportmystuff)  + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Mystuff_Exportmystuff,  30),  GetIconHandle(#Image_Mystuff_Exportmystuff))
    BalloonToolTip(#Window_Mystuff, #Gadget_Mystuff_Importmystuff,  Program\BalloonFontId, $FFFFFF, #Keystext_Mystuff_Importmystuff,  #CRLF$ + GetShortCutText(#Keys_Mystuff_Importmystuff)  + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Mystuff_Importmystuff,  30),  GetIconHandle(#Image_Mystuff_Importmystuff))
    BalloonToolTip(#Window_Mystuff, #Gadget_Mystuff_Helpwithstuff,  Program\BalloonFontId, $FFFFFF, #Keystext_Mystuff_Showhelp,       #CRLF$ + GetShortCutText(#Keys_Mystuff_Showhelp)       + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Mystuff_Showhelp,       30),  GetIconHandle(#Image_Mystuff_Helpwithstuff))
    BalloonToolTip(#Window_Mystuff, #Gadget_Mystuff_Exitthisstuff,  Program\BalloonFontId, $FFFFFF, #Keystext_Mystuff_Exitmystuff,    #CRLF$ + GetShortCutText(#Keys_Mystuff_Exitmystuff)    + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Mystuff_Exitmystuff,    30),  GetIconHandle(#Image_Mystuff_Exitthisstuff))
  Else
    MessageRequester("Balloon font load error", "Could not load the ballon font so no tooltips will be loaded", #PB_MessageRequester_Ok)
  EndIf
  
  ;//**********************************************************************************************
  ;// Just testing the the tooltip structures have been filled properly
  ;//**********************************************************************************************
  
  ;   ForEach ToolTips()
  ;     Debug Str(ToolTips()\pbWindowNumber) + ": Window number"
  ;     Debug Str(ToolTips()\pbhandleTip)    + ": Tip handle"
  ;     Debug Str(ToolTips()\pbGadgetID)     + ": Gadget id"
  ;     Debug Str(ToolTips()\pbGadgetNumber) + ": Gadget number"
  ;     Debug Str(ToolTips()\pbIconHandle)   + ": Icon handle"
  ;     Debug "---------------------------------------------------"
  ;   Next
  

  ;//**********************************************************************************************
  ;// You may or may not want to enable these to get a flatter look
  ;//**********************************************************************************************
  
  RemoveBorders(#Gadget_MyStuff_Locations)   ; Listicon
  RemoveBorders(#Gadget_MyStuff_Itemlist)    ; Listicon
  
  ;//**********************************************************************************************
  ;// Load a bold and underline fonts to be used anywhere that is needed
  ;//**********************************************************************************************

  ;LoadFont(#FontUnderlineYes, FontName.s, dFontsize.F, #PB_Font_Underline)                            ; Load current font and add strikeout attribute
  ;LoadFont(#FontUnderlineNo,  FontName.s, dFontsize.F)
  ;LoadFont(#FontBoldYes,      FontName.s, dFontsize.F, #PB_Font_Underline)                            ; Load current font and add strikeout attribute
  ;LoadFont(#FontBoldNo,       FontName.s, dFontsize.F)
  
  ;//**********************************************************************************************
  ;// Turn on snapping to window borders
  ;//**********************************************************************************************
  
  If Option\Snapformtoborders = #False
    Option\Snapformtoborders = #True
  ElseIf Option\Snapformtoborders = #True
    Option\Snapformtoborders = #False
  EndIf
    
  ToggleScreenSnap()
  
  ;//**********************************************************************************************
  ;// Setup the window tool tips
  ;//**********************************************************************************************
  
  If Option\Tooltipsonoroff = #False
    Option\Tooltipsonoroff = #True
  ElseIf Option\Tooltipsonoroff = #True     ; todo
    Option\Tooltipsonoroff = #False
  EndIf
  
  ToggleToolTips()
  
  ;//**********************************************************************************************
  ;// Setup the window tool tips
  ;//**********************************************************************************************
  
  If Option\Stickwindowontop = #False
    Option\Stickwindowontop = #True
  ElseIf Option\Stickwindowontop = #True
    Option\Stickwindowontop = #False
  EndIf
  
  ToggleStickyWindow()
  
  ;//**********************************************************************************************
  ;// Setup the window tool tips
  ;//**********************************************************************************************
  
  If Option\Colourbandinlist = #False
    Option\Colourbandinlist = #True
  ElseIf Option\Colourbandinlist = #True    ; todo
    Option\Colourbandinlist = #False
  EndIf
  
  ToggleColourBand()
  
  ;//**********************************************************************************************
  ;// Setup the window save messages tips
  ;//**********************************************************************************************
  
  If Option\Messageaftersave = #False
    Option\Messageaftersave = #True
  ElseIf Option\Messageaftersave = #True    ; todo
    Option\Messageaftersave = #False
  EndIf
  
  ToggleMessageSave()
  
  ;//**********************************************************************************************
  ;// Limit the number of search box characters and set the cue banner text. These variables are set in the MyStuff_Myconstants file.
  ;//**********************************************************************************************
  
  SetSearchCue(#EmptyString, #Gadget_Mystuff_Searchstring, #Gadget_MyStuff_Searchfield)
  
  ;//**********************************************************************************************
  ;// Colours, resizing and more callback
  ;//**********************************************************************************************
  
  SetWindowCallback(@WindowCallback())
  
  ;//**********************************************************************************************
  ;// Turn on mouse event hover testing, this is NetMaestro's code.
  ;//**********************************************************************************************
  
  InitHoverEvents(#Window_Mystuff)
  
  ;//**********************************************************************************************
  ;// Add the hovering effect to the category buttons
  ;//**********************************************************************************************
  
  AddHoverGadget(GadgetID(#Gadget_Mystuff_Addnewstuff))
  AddHoverGadget(GadgetID(#Gadget_Mystuff_Copyoldstuff))
  AddHoverGadget(GadgetID(#Gadget_Mystuff_Deleteoldstuff))
  AddHoverGadget(GadgetID(#Gadget_Mystuff_Editthistuff))
  AddHoverGadget(GadgetID(#Gadget_Mystuff_Killthisstuff))
  AddHoverGadget(GadgetID(#Gadget_Mystuff_Lockthisstuff))
  AddHoverGadget(GadgetID(#Gadget_Mystuff_Favouritestuff))
  AddHoverGadget(GadgetID(#Gadget_Mystuff_Printthisstuff))
  AddHoverGadget(GadgetID(#Gadget_Mystuff_Exportmystuff))
  AddHoverGadget(GadgetID(#Gadget_Mystuff_Importmystuff))
  AddHoverGadget(GadgetID(#Gadget_Mystuff_Helpwithstuff))
  AddHoverGadget(GadgetID(#Gadget_Mystuff_Exitthisstuff))

  ;//**********************************************************************************************
  ;// Nalor & Dige's sorting stuff for ListIconGadget that I am testing for now
  ;//**********************************************************************************************
  
  Enumeration ; Type of Column Sort
    #SortAutoDetect
    #SortString
    #SortNumeric
    #SortFloat
    #SortDate
    #SortDateDDMMYYYYHHIISS
    #SortFileSize
    #SortPixel
    #SortNone
  EndEnumeration
   
  nalorLIG::Enable(#Gadget_Mystuff_Itemlist)
 
  ;nalorLIG::SetSortOrderType(#ListIcon, 0, #SortNone)
 
  nalorLIG::SetSortOrderType(#Gadget_Mystuff_Itemlist, 0, #SortString)
  nalorLIG::SetSortOrderType(#Gadget_Mystuff_Itemlist, 1, #SortString)
  nalorLIG::SetSortOrderType(#Gadget_Mystuff_Itemlist, 2, #SortString)
  nalorLIG::SetSortOrderType(#Gadget_Mystuff_Itemlist, 3, #SortString)
  nalorLIG::SetSortOrderType(#Gadget_Mystuff_Itemlist, 4, #SortString)
  nalorLIG::SetSortOrderType(#Gadget_Mystuff_Itemlist, 5, #SortString)
  nalorLIG::SetSortOrderType(#Gadget_Mystuff_Itemlist, 6, #SortString)
  nalorLIG::SetSortOrderType(#Gadget_Mystuff_Itemlist, 7, #SortString)
 
  nalorLIG::SetColumnAlignment(#Gadget_Mystuff_Itemlist, 1, 1)
  nalorLIG::SetColumnAlignment(#Gadget_Mystuff_Itemlist, 2, 1)
  nalorLIG::SetColumnAlignment(#Gadget_Mystuff_Itemlist, 3, 1)
  nalorLIG::SetColumnAlignment(#Gadget_Mystuff_Itemlist, 4, 1)
  nalorLIG::SetColumnAlignment(#Gadget_Mystuff_Itemlist, 5, 1)
  nalorLIG::SetColumnAlignment(#Gadget_Mystuff_Itemlist, 6, 2)
  nalorLIG::SetColumnAlignment(#Gadget_Mystuff_Itemlist, 7, 1)
 
  ; nalorLIG::DisableSort (#Gadget_Mystuff_Itemlist)
  
  ;//**********************************************************************************************
  ;// Setup initial welcome dialogues in the fake statusbar area
  ;//**********************************************************************************************
  
  SetInfoBarArea("Headings",  #EmptyString, "Welcome to " + #Program  + ", Have a nice day")
  SetInfoBarArea("Total",     #EmptyString, "0.00")
  SetInfoBarArea("Current",   #EmptyString, "0")
  SetInfoBarArea("Records",   #EmptyString, Str(CountGadgetItems(#Gadget_Mystuff_Itemlist)))
  
  ;//**********************************************************************************************
  ;// Set the focus to the first item in the list if any
  ;//**********************************************************************************************
  
  SetGadgetState(#Gadget_Mystuff_Locations, #FirstItem)
  
  ;//**********************************************************************************************
  ;// Fire off an event to load the items in the default location if any
  ;//**********************************************************************************************
  
  PostEvent(#PB_Event_Gadget, #Window_Mystuff, #Gadget_Mystuff_Locations, #PB_EventType_Change)

  ;//**********************************************************************************************
  ;// Main event handler loop
  ;//**********************************************************************************************

  Repeat
    EventID  =  WaitWindowEvent()
    MenuID   =  EventMenu()
    GadgetID =  EventGadget()
    WindowID =  EventWindow()

    Select EventID
        
      Case #PB_Event_CloseWindow
        Select WindowID
          Case #Window_Mystuff                              : Program\QuitValue = #True
          Case #Window_Datasheet                            : CloseMyWindow(#Window_Datasheet)
          Case #Window_Viewdocument                         : CloseWindow(#Window_Viewdocument)
          Case #Window_Aboutmystuff                         : CloseMyWindow(#Window_Aboutmystuff)
          Case #Window_Statisticsformystuff                 : CloseMyWindow(#Window_Statisticsformystuff)
          Case #Window_Pictureofstuff                       : CloseMyWindow(#Window_Pictureofstuff)
          Case #Window_Keyboardshortcuts                    : CloseMyWindow(#Window_Keyboardshortcuts)
          Case #Window_ScanDocument                         : CloseWindow(#Window_ScanDocument)
          Case #Window_Location                             : CloseMyWindow(#Window_Location)
        EndSelect

        ; Minimise main window event handler
        
      Case #PB_Event_MinimizeWindow
        Select EventWindow()
          Case #Window_Mystuff                              : HideProgramWindow()
        EndSelect
        
      Case #PB_Event_Menu
        Select MenuID
            
          ; File menu
            
          Case #MenuBar_Mystuff_Backupmystuff               : Backupmystuff()
          Case #MenuBar_Mystuff_Deleteallmystuff            : Deleteallmystuff()
          Case #MenuBar_Mystuff_Vacuummystuff               : Vacuummystuff()
          Case #MenuBar_Mystuff_Exportmystuff               : Exportmystuff()
          Case #MenuBar_Mystuff_Importmystuff               : Importmystuff()
          Case #MenuBar_Mystuff_Exitmystuff                 : Program\QuitValue = #True
            
          ; Location menu
            
          Case #MenuBar_Mystuff_Addlocation                 : Addlocation()
          Case #MenuBar_Mystuff_Copylocation                : CopyLocation()
          Case #MenuBar_Mystuff_Deletelocation              : DeleteLocation()
          Case #MenuBar_Mystuff_Editlocation                : EditLocation()
          Case #MenuBar_Mystuff_Exportlocations             : ExportLocations()
          Case #MenuBar_Mystuff_Importlocations             : ImportLocations()
            
          ; My stuff menu
            
          Case #MenuBar_Mystuff_Addnewstuff                 : AddNewStuff()
          Case #MenuBar_Mystuff_Copyoldstuff                : CopyOldStuff()
          Case #MenuBar_Mystuff_Deleteoldstuff              : DeleteOldStuff()
          Case #MenuBar_Mystuff_Editoldstuff                : EditOldStuff()
          Case #MenuBar_Mystuff_Favouritestuff              : FavouriteStuff()  
          Case #MenuBar_Mystuff_Killthisstuff               : KillThisStuff()
          Case #MenuBar_Mystuff_Lockthisstuff               : LockThisStuff()
          Case #MenuBar_Mystuff_Printthisstuff              : PrintThisStuff()
          Case #MenuBar_MyStuff_Pictureofstuff              : Pictureofstuff()
            
          ; Search menu
            
          Case #MenuBar_Mystuff_CheckReturn                 : SelectFocusGadget()
            
          ; Options menu
            
          Case #MenuBar_Mystuff_Colourbandinlist            : ToggleColourBand()
          Case #MenuBar_Mystuff_Messageaftersave            : ToggleMessageSave()
          Case #MenuBar_Mystuff_Stickwindowontop            : ToggleStickyWindow()
          Case #MenuBar_Mystuff_Showtitlebarclock           : ToggleShowClock()  
          Case #MenuBar_Mystuff_Snapformtoborders           : ToggleScreenSnap()
          Case #MenuBar_Mystuff_Tooltipsonoroff             : ToggleToolTips()
          Case #MenuBar_Mystuff_Lockmystuffwindow           : ; ToggleLockWindow()
            
          ; Setup menu
            
          Case #MenuBar_Mystuff_Setupmystuff                : ; Setupmystuff()
            
          ; Help menu
            
          Case #MenuBar_Mystuff_Aboutmystuff                : Aboutmystuff()
          Case #MenuBar_Mystuff_Keyboardshortcuts           : Keyboardshortcuts()
          Case #MenuBar_Mystuff_Showhelp                    : ; Showhelpformystuff()
          Case #MenuBar_Mystuff_Statisticsformystuff        : Statisticsformystuff()
          Case #MenuBar_Mystuff_Viewmystufflogfile          : ; Viewmystufflogfile()
            
          ; Location popup menu bar
            
          Case #PopMenuBar_Location_Addlocation             : Addlocation()
          Case #PopMenuBar_Location_Copylocation            : CopyLocation()
          Case #PopMenuBar_Location_Deletelocation          : DeleteLocation()
          Case #PopMenuBar_Location_Editlocation            : EditLocation()
          Case #PopMenuBar_Location_Exportlocations         : ExportLocations()
          Case #PopMenuBar_Location_Importlocations         : ImportLocations()
            
          ; Item names popup menu bar
            
          Case #PopMenuBar_Mystuff_Addnewstuff              : AddNewStuff()
          Case #PopMenuBar_Mystuff_Copyoldstuff             : CopyOldStuff()
          Case #PopMenuBar_Mystuff_Deleteoldstuff           : DeleteOldStuff()
          Case #PopMenuBar_Mystuff_Editoldstuff             : EditOldStuff()
          Case #PopMenuBar_Mystuff_Killthisstuff            : KillThisStuff()
          Case #PopMenuBar_Mystuff_Lockthisstuff            : LockThisStuff()
          Case #PopMenuBar_Mystuff_Favouritestuff           : FavouriteStuff()
          Case #PopMenuBar_Mystuff_Printthisstuff           : PrintThisStuff()
          Case #PopMenuBar_MyStuff_Pictureofstuff           : Pictureofstuff()

          ; Data sheet picture popup menu bar
            
          Case #PopMenubar_Datasheet_Menu_Addpicture        : AddNewPicture()
          Case #PopMenuBar_Datasheet_Menu_Clearpicture      : ClearOldPicture()
          Case #PopMenuBar_Datasheet_Menu_DeletePicture     : DeleteOldPicture()
          Case #PopMenuBar_Datasheet_Menu_ScanPicture       : ScanPicture(3, 300, 1)

          ;------------------------------------------------
          ; 
          ;------------------------------------------------
            
          ; File menu
            
          Case #Shortcut_Mystuff_Backupmystuff            : Backupmystuff()
          Case #Shortcut_Mystuff_Deleteallmystuff         : Deleteallmystuff()
          Case #Shortcut_Mystuff_Vacuummystuff            : Vacuummystuff()
          Case #Shortcut_Mystuff_Exportmystuff            : Exportmystuff()
          Case #Shortcut_Mystuff_Importmystuff            : Importmystuff()
          Case #Shortcut_Mystuff_Exitmystuff              : Program\QuitValue = #True
            
          ; Locations
            
          Case #Shortcut_Mystuff_Addlocation              : Addlocation()
          Case #Shortcut_Mystuff_Copylocation             : CopyLocation()
          Case #Shortcut_Mystuff_Deletelocation           : DeleteLocation()
          Case #Shortcut_Mystuff_Editlocation             : EditLocation()
          Case #Shortcut_Mystuff_Exportlocations          : ExportLocations()
          Case #Shortcut_Mystuff_Importlocations          : ImportLocations()
            
          ; Mystuff
            
          Case #Shortcut_Mystuff_Addnewstuff              : AddNewStuff()
          Case #Shortcut_Mystuff_Copyoldstuff             : CopyOldStuff() 
          Case #Shortcut_Mystuff_Deleteoldstuff           : DeleteOldStuff() 
          Case #Shortcut_Mystuff_Editoldstuff             : EditOldStuff()
          Case #Shortcut_Mystuff_Favouritestuff           : FavouriteStuff()  
          Case #Shortcut_Mystuff_Killthisstuff            : KillThisStuff()
          Case #Shortcut_Mystuff_Lockthisstuff            : LockThisStuff()
          Case #Shortcut_Mystuff_Printthisstuff           : PrintThisStuff()
          Case #Shortcut_MyStuff_Pictureofstuff           : Pictureofstuff()  
            
          ; Search
            
          Case #Shortcut_Mystuff_CheckReturn              : SelectFocusgadget()
            
          ; Options menu
            
          Case #Shortcut_Mystuff_Colourbandinlist         : ToggleColourBand()
          Case #Shortcut_Mystuff_Messageaftersave         : ToggleMessageSave()
          Case #Shortcut_Mystuff_Stickwindowontop         : ToggleStickyWindow()
          Case #Shortcut_Mystuff_Showtitlebarclock        : ToggleShowClock()  
          Case #Shortcut_Mystuff_Snapformtoborders        : ToggleScreenSnap()
          Case #Shortcut_Mystuff_Tooltipsonoroff          : ToggleToolTips()
          Case #Shortcut_Mystuff_Lockmystuffwindow        : ; ToggleLockWindow()
            
          ; Setup menu
            
          Case #Shortcut_Mystuff_Setupmystuff             : ; Setupmystuff()
            
          ; Help menu
            
          Case #Shortcut_Mystuff_Aboutmystuff             : Aboutmystuff()
          Case #Shortcut_Mystuff_Keyboardshortcuts         : Keyboardshortcuts()
          Case #Shortcut_Mystuff_Showhelp                 : ; Showhelpformystuff()
          Case #Shortcut_Mystuff_Statisticsformystuff     : Statisticsformystuff()
          Case #Shortcut_Mystuff_Viewmystufflogfile       : ; Viewmystufflogfile()
            
            ;------------------------------------------------
          ; 
          ;------------------------------------------------
            
          Case #ShortCut_Statisticsformystuff_escape      : CloseMyWindow(#Window_Statisticsformystuff)
            
          ;------------------------------------------------
          ; 
          ;------------------------------------------------
            
          Case #Shortcut_Aboutmystuff_escape              : CloseMyWindow(#Window_Aboutmystuff)
            
          ;------------------------------------------------
          ; 
          ;------------------------------------------------
            
          Case #Shortcut_Location_Escape                  : CloseMyWindow(#Window_Location)
          Case #Shortcut_Location_Save                    : ; SaveLocation()
          Case #Shortcut_Location_Exit                    : CloseMyWindow(#Window_Location)
            
          ;------------------------------------------------
          ; 
          ;------------------------------------------------
            
          Case #Shortcut_Datasheet_Escape                 : CloseMyWindow(#Window_Datasheet)
            
          Case #Shortcut_Datasheet_Lookupmodel            : LookupModel()
            
          Case #Shortcut_Datasheet_Savemystuff            : SaveMyStuff()
            
          Case #Shortcut_Datasheet_Menu_Addpicture        : AddNewPicture()
          Case #Shortcut_Datasheet_Menu_Clearpicture      : ClearOldPicture()
          Case #Shortcut_Datasheet_Menu_DeletePicture     : DeleteOldPicture()
          Case #Shortcut_Datasheet_Menu_ScanPicture       : ScanPicture(3, 300, 1)
            
          Case #Shortcut_Datasheet_AddPicture             : AddNewPicture()
          Case #Shortcut_Datasheet_ScanPicture            : ScanPicture(3, 300, 1)
          Case #Shortcut_Datasheet_AddDocument            : AddNewDocument()
          Case #Shortcut_Datasheet_ScanDocument           : ScanDocument()            
          Case #Shortcut_Datasheet_ViewDocument           : ViewDocument()
          Case #Shortcut_Datasheet_RelinkDocument         : RelinkDocument()  
          Case #Shortcut_Datasheet_Exitmystuff            : CloseMyWindow(#Window_Datasheet)
            
          Case #Shortcut_ViewDocument_Escape              : CloseWindow(#Window_Viewdocument)
            
          ;------------------------------------------------
          ; 
          ;------------------------------------------------
            
          Case #Shortcut_Pictureofstuff_Escape            : CloseMyWindow(#Window_Pictureofstuff)
            
          ;------------------------------------------------
          ; 
          ;------------------------------------------------
            
          Case #Shortcut_Keyboardshortcuts_Escape         : CloseMyWindow(#Window_Keyboardshortcuts)
            
          ;------------------------------------------------
          ; 
          ;------------------------------------------------
            
          Case #Shortcut_Mystuff_ImportMyDocuments        : ImportMyDocuments()
            
          ;------------------------------------------------
          ; 
          ;------------------------------------------------
            
        EndSelect
        
        ;--------------------------------------------------
        ; 
        ;--------------------------------------------------
        
      Case #PB_Event_Gadget
        Select GadgetID
          Case #Gadget_Mystuff_Locations
            Select EventType()
              Case #PB_EventType_LeftDoubleClick          : EditLocation()
              Case #PB_EventType_RightClick               : DisplayPopupMenu(#PopMenuBar_Location, WindowID(#Window_Mystuff))
              Case #PB_EventType_Change                   : GetMyStuffForLocation()
            EndSelect
            
          Case #Gadget_Mystuff_Itemlist
            Select EventType()
              Case #PB_EventType_LeftDoubleClick          : EditOldStuff()
              Case #PB_EventType_RightClick               : DisplayPopupMenu(#PopMenuBar_Mystuff, WindowID(#Window_Mystuff))                
              Case #PB_EventType_Change                   : DisplayMystuffDetails()
            EndSelect
            
            ;----------------------------------------------
            ; 
            ;----------------------------------------------
            
          Case #Gadget_Mystuff_Searchfield
            Select EventType()
              Case #PB_EventType_Change                   : ChangeSearchCue("MainForm")
            EndSelect
            
            ;----------------------------------------------
            ; 
            ;----------------------------------------------
            
          Case #Gadget_Mystuff_Searchstring               :
            
            ;----------------------------------------------
            ; 
            ;----------------------------------------------
            
          Case #Gadget_Mystuff_Addnewstuff
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Addnewstuff,       "Hovered")  : StatusBarButtonTip(#Window_Mystuff, "Addnewstuff")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Mystuff_Addnewstuff,       "Pressed")  : AddNewStuff()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Addnewstuff,       "Normal")
            EndSelect
            
          Case #Gadget_Mystuff_Copyoldstuff 
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Copyoldstuff,      "Hovered")  : StatusBarButtonTip(#Window_Mystuff, "Copyoldstuff")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Mystuff_Copyoldstuff,      "Pressed")  : CopyOldStuff()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Copyoldstuff,      "Normal")
            EndSelect
          Case #Gadget_Mystuff_Deleteoldstuff
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Deleteoldstuff,    "Hovered")  : StatusBarButtonTip(#Window_Mystuff, "Deleteoldstuff")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Mystuff_Deleteoldstuff,    "Pressed")  : DeleteOldStuff()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Deleteoldstuff,    "Normal")
            EndSelect
          Case #Gadget_Mystuff_Editthistuff
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Editthistuff,      "Hovered")  : StatusBarButtonTip(#Window_Mystuff, "Editthisstuff")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Mystuff_Editthistuff,      "Pressed")  : EditOldStuff()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Editthistuff,      "Normal")
            EndSelect
          Case #Gadget_Mystuff_Killthisstuff
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Killthisstuff,     "Hovered")  : StatusBarButtonTip(#Window_Mystuff, "Killthistuff")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Mystuff_Killthisstuff,     "Pressed")  : KillThisStuff()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Killthisstuff,     "Normal")
            EndSelect
          Case #Gadget_Mystuff_Lockthisstuff
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Lockthisstuff,     "Hovered")  : StatusBarButtonTip(#Window_Mystuff, "Lockthisstuff")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Mystuff_Lockthisstuff,     "Pressed")  : LockThisStuff()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Lockthisstuff,     "Normal")
            EndSelect
          Case #Gadget_Mystuff_Favouritestuff
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Favouritestuff,    "Hovered")  : StatusBarButtonTip(#Window_Mystuff, "Favouritestuff")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Mystuff_Favouritestuff,    "Pressed")  : FavouriteStuff()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Favouritestuff,    "Normal")
            EndSelect
          Case #Gadget_Mystuff_Printthisstuff
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Printthisstuff,    "Hovered")  : StatusBarButtonTip(#Window_Mystuff, "Printthisstuff")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Mystuff_Printthisstuff,    "Pressed")  : PrintThisStuff()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Printthisstuff,    "Normal")
            EndSelect
          Case #Gadget_Mystuff_Exportmystuff
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Exportmystuff,     "Hovered")  : StatusBarButtonTip(#Window_Mystuff, "Exportmystuff")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Mystuff_Exportmystuff,     "Pressed")  : Exportmystuff()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Exportmystuff,     "Normal")
            EndSelect
          Case #Gadget_Mystuff_Importmystuff
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Importmystuff,     "Hovered")  : StatusBarButtonTip(#Window_Mystuff, "Importmystuff")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Mystuff_Importmystuff,     "Pressed")  : Importmystuff()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Importmystuff,     "Normal")
            EndSelect
          Case #Gadget_Mystuff_Helpwithstuff
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Helpwithstuff,     "Hovered")  : StatusBarButtonTip(#Window_Mystuff, "Helpwithstuff")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Mystuff_Helpwithstuff,     "Pressed")  : ; Showhelpformystuff()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Helpwithstuff,     "Normal")
            EndSelect
          Case #Gadget_Mystuff_Exitthisstuff
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Exitthisstuff,     "Hovered")  : StatusBarButtonTip(#Window_Mystuff, "Exitthisstuff")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Mystuff_Exitthisstuff,     "Pressed")  : Program\QuitValue = #True
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Mystuff_Exitthisstuff,     "Normal")
            EndSelect
            
          ;------------------------------------------------
          ; Location bar editing
          ;------------------------------------------------
            
          Case #Gadget_Location_Save
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Location_Save,     "Hovered")  : StatusBarButtonTip(#Window_Location, "SaveLocation")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Location_Save,     "Pressed")  : SaveLocation()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Location_Save,     "Normal")
            EndSelect
          Case #Gadget_Location_Exit
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Location_Exit,     "Hovered")  : StatusBarButtonTip(#Window_Mystuff, "ExitLocation")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Location_Exit,     "Pressed")  : CloseMyWindow(#Window_Location)
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Location_Exit,     "Normal")
            EndSelect
            
          ;------------------------------------------------
          ; AddNewStuff/EditOldStuff window controls
          ;------------------------------------------------
            
          Case #Gadget_Datasheet_ItemName                 : StringFirstUpper(#Gadget_Datasheet_ItemName)
          Case #Gadget_Datasheet_Supplier                 : MixedComboCaseEx(#Gadget_Datasheet_Supplier)
          Case #Gadget_Datasheet_Manufacturer             : MixedComboCaseEx(#Gadget_Datasheet_Manufacturer)
          Case #Gadget_Datasheet_Working                  : MixedComboCaseEx(#Gadget_Datasheet_Working)
          Case #Gadget_Datasheet_WhoPaid                  : MixedComboCaseEx(#Gadget_Datasheet_WhoPaid)
          Case #Gadget_Datasheet_OwnerName                : MixedComboCaseEx(#Gadget_Datasheet_OwnerName)
          Case #Gadget_Datasheet_Location                 : MixedComboCaseEx(#Gadget_Datasheet_Location)
          Case #Gadget_Datasheet_Condition                : MixedComboCaseEx(#Gadget_Datasheet_Condition)
          Case #Gadget_Datasheet_Category                 : MixedComboCaseEx(#Gadget_Datasheet_Category)
            
          Case #Gadget_Datasheet_Cost
            Select EventType()
              Case #PB_EventType_Change                   : AllowOnly(#Gadget_Datasheet_Cost, 3)
              Case #PB_EventType_Focus                    : SetGadgetText(#Gadget_Datasheet_Cost,     ClearCurrencyFormat(GetGadgetText(#Gadget_Datasheet_Cost)))
              Case #PB_EventType_LostFocus                : SetGadgetText(#Gadget_Datasheet_Cost,     GetCurrency(GetGadgetText(#Gadget_Datasheet_Cost)))
            EndSelect
          Case #Gadget_Datasheet_Tax
            Select EventType()
              Case #PB_EventType_Change                   : AllowOnly(#Gadget_Datasheet_Tax, 3)
              Case #PB_EventType_Focus                    : SetGadgetText(#Gadget_Datasheet_Tax,      ClearCurrencyFormat(GetGadgetText(#Gadget_Datasheet_Tax)))
              Case #PB_EventType_LostFocus                : SetGadgetText(#Gadget_Datasheet_Tax,      GetCurrency(GetGadgetText(#Gadget_Datasheet_Tax)))
            EndSelect
          Case #Gadget_Datasheet_Delivery
            Select EventType()
              Case #PB_EventType_Change                   : AllowOnly(#Gadget_Datasheet_Delivery, 3)
              Case #PB_EventType_Focus                    : SetGadgetText(#Gadget_Datasheet_Delivery, ClearCurrencyFormat(GetGadgetText(#Gadget_Datasheet_Delivery)))
              Case #PB_EventType_LostFocus                : SetGadgetText(#Gadget_Datasheet_Delivery, GetCurrency(GetGadgetText(#Gadget_Datasheet_Delivery)))
            EndSelect
          Case #Gadget_Datasheet_Othercost
            Select EventType()
              Case #PB_EventType_Change                   : AllowOnly(#Gadget_Datasheet_Othercost, 3)
              Case #PB_EventType_Focus                    : SetGadgetText(#Gadget_Datasheet_Othercost, ClearCurrencyFormat(GetGadgetText(#Gadget_Datasheet_Othercost)))
              Case #PB_EventType_LostFocus                : SetGadgetText(#Gadget_Datasheet_Othercost, GetCurrency(GetGadgetText(#Gadget_Datasheet_Othercost)))
            EndSelect
          Case #Gadget_Datasheet_Resale
            Select EventType()
              Case #PB_EventType_Change                   : AllowOnly(#Gadget_Datasheet_Resale, 3)
              Case #PB_EventType_Focus                    : SetGadgetText(#Gadget_Datasheet_Resale,   ClearCurrencyFormat(GetGadgetText(#Gadget_Datasheet_Resale)))
              Case #PB_EventType_LostFocus                : SetGadgetText(#Gadget_Datasheet_Resale,   GetCurrency(GetGadgetText(#Gadget_Datasheet_Resale)))
            EndSelect
            
          Case #Gadget_Datasheet_PaidBy                   : MixedComboCaseEx(#Gadget_Datasheet_PaidBy)
          Case #Gadget_Datasheet_WarrantyPeriod           : StringFirstUpper(#Gadget_Datasheet_WarrantyPeriod)
          Case #Gadget_Datasheet_WarrantyWord             : MixedComboCaseEx(#Gadget_Datasheet_WarrantyWord)
          Case #Gadget_Datasheet_WarrantyActive           : MixedComboCaseEx(#Gadget_Datasheet_WarrantyActive)
          Case #Gadget_Datasheet_WarrantyAmount           :        AllowOnly(#Gadget_Datasheet_WarrantyAmount, 2)
          Case #Gadget_Datasheet_Insured                  : MixedComboCaseEx(#Gadget_Datasheet_Insured)
          Case #Gadget_Datasheet_InsuredAmount            :        AllowOnly(#Gadget_Datasheet_InsuredAmount, 2)
          Case #Gadget_Datasheet_InsurerName              : MixedComboCaseEx(#Gadget_Datasheet_InsurerName)
          Case #Gadget_Datasheet_Contactname              : StringFirstUpper(#Gadget_Datasheet_Contactname)
          Case #Gadget_Datasheet_ItemPicture              : DisplayPopupMenu(#PopMenubar_Datasheet, WindowID(#Window_Datasheet))
            
          ;------------------------------------------------
          ; AddNewStuff/EditOldStuff window buttons
          ;------------------------------------------------
          Case #Gadget_Datasheet_iLookupModel
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_iLookupModel,   "Hovered")  : StatusBarButtonTip(#Window_Datasheet, "LookupModel")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Datasheet_iLookupModel,   "Pressed")  : LookupModel()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_iLookupModel,   "Normal")
            EndSelect
          Case #Gadget_Datasheet_SaveMyStuff
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_SaveMyStuff,     "Hovered")  : StatusBarButtonTip(#Window_Datasheet, "SaveMyStuff")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Datasheet_SaveMyStuff,     "Pressed")  : SaveMyStuff()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_SaveMyStuff,     "Normal")
            EndSelect
          Case #Gadget_Datasheet_AddPicture
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_AddPicture,      "Hovered")  : StatusBarButtonTip(#Window_Datasheet, "AddPicture")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Datasheet_AddPicture,      "Pressed")  : AddNewPicture()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_AddPicture,      "Normal")
            EndSelect
          Case #Gadget_Datasheet_ScanPicture
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_Scanpicture,     "Hovered")  : StatusBarButtonTip(#Window_Datasheet, "ScanPicture")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Datasheet_Scanpicture,     "Pressed")  : ScanPicture(3, 300, 1)
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_Scanpicture,     "Normal")
            EndSelect
          Case #Gadget_Datasheet_AddDocument
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_Adddocument,     "Hovered")  : StatusBarButtonTip(#Window_Datasheet, "AddDocument")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Datasheet_Adddocument,     "Pressed")  : AddNewDocument()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_Adddocument,     "Normal")
            EndSelect
          Case #Gadget_Datasheet_ScanDocument
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_ScanDocument,    "Hovered")  : StatusBarButtonTip(#Window_Datasheet, "ScanDocument")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Datasheet_ScanDocument,    "Pressed")  : ScanDocument()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_ScanDocument,    "Normal")
            EndSelect
          Case #Gadget_Datasheet_ViewDocument
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_ViewDocument,    "Hovered")  : StatusBarButtonTip(#Window_Datasheet, "ViewDocument")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Datasheet_ViewDocument,    "Pressed")  : ViewDocument()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_ViewDocument,    "Normal")
            EndSelect
          Case #Gadget_Datasheet_RelinkDocument
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_RelinkDocument,  "Hovered")  : StatusBarButtonTip(#Window_Datasheet, "RelinkDocument")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Datasheet_RelinkDocument,  "Pressed")  : RelinkDocument()
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_RelinkDocument,  "Normal")
            EndSelect
          Case #Gadget_Datasheet_ExitMyStuff
            Select EventType()
              Case #HoverEvent_EnterGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_ExitMyStuff,     "Hovered")  : StatusBarButtonTip(#Window_Datasheet, "ExitMyStuff")
              Case #PB_EventType_LeftClick                : SetHoverIcons(GadgetID, #Image_Datasheet_ExitMyStuff,     "Pressed")  : CloseMyWindow(#Window_Datasheet)
              Case #HoverEvent_LeaveGadget                : SetHoverIcons(GadgetID, #Image_Datasheet_ExitMyStuff,     "Normal")
            EndSelect
            
            ;----------------------------------------------
            ; 
            ;----------------------------------------------
            
          Case #Gadget_ScanDocument_bImagesource          : TWAIN_SelectImageSource(WindowID(#Window_ScanDocument))
          Case #Gadget_ScanDocument_bScannext             : ScanNextDocumentPage()
          Case #Gadget_ScanDocument_bFinish               : SaveScannedDocumentPages()
          Case #Gadget_ScanDocument_bCancel               : CloseWindow(#Window_ScanDocument)
            
          ;------------------------------------------------
          ; 
          ;------------------------------------------------
            
          EndSelect

          ;------------------------------------------------
          ; 
          ;------------------------------------------------
        
      Case #PB_Event_SysTray                              : ShowProgramWindow()
        
      ;----------------------------------------------------
      ; 
      ;----------------------------------------------------
        
    EndSelect
    
    ;------------------------------------------------------
    ; 
    ;------------------------------------------------------
    
  Until Program\QuitValue
  
  ;--------------------------------------------------------
  ; 
  ;--------------------------------------------------------
  
  SaveOptionData()
  
  ;--------------------------------------------------------
  ; 
  ;--------------------------------------------------------
  
  WriteErrorLog("Main module", "End Of Current Run")
  
  ;--------------------------------------------------------
  ; 
  ;--------------------------------------------------------
  
  CloseWindow(#Window_Mystuff)
  
  ;--------------------------------------------------------
  ; 
  ;--------------------------------------------------------
  
EndIf

;----------------------------------------------------------
; 
;----------------------------------------------------------

End

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 205
; FirstLine = 177
; EnableAsm
; EnableUnicode
; EnableXP
; UseIcon = Images\Red Moz.ico
; Executable = My stuff.exe
; EnableCompileCount = 122
; EnableBuildCount = 3
; EnableExeConstant