﻿;==============================================================================================================================================================================
; Extended balloon tooltip with images support by using the O/S's theming engine
;==============================================================================================================================================================================

Import "Uxtheme.lib"                                                                                 ; 
  SetWindowTheme(Window.i, Body.p-unicode, Title.p-unicode)                                           ;  
EndImport                                                                                            ; 

;==============================================================================================================================================================================
; Need a unicode aware version of the API directory creator for database directory, temporary directory and maybe others
;==============================================================================================================================================================================

Import "shell32.lib"                                                                                 ; Import 32 bit shell library
  SHCreateDirectory(*hwnd, pszPath.p-unicode)                                                         ; Grab the function that you want
EndImport                                                                                            ; End function import

;==============================================================================================================================================================================
; Hide the network print button (and others) ?? RASHAD
;==============================================================================================================================================================================

#PD_ALLPAGES                        = $00000000                                                       ; 
#PD_COLLATE                         = $10                                                             ; 
#PD_DISABLEPRINTTOFILE              = $80000                                                          ; 
#PD_ENABLEPRINTHOOK                 = $1000                                                           ; 
#PD_ENABLEPRINTTEMPLATE             = $4000                                                           ; 
#PD_ENABLEPRINTTEMPLATEHANDLE       = $10000                                                          ; 
#PD_ENABLESETUPHOOK                 = $2000                                                           ; 
#PD_ENABLESETUPTEMPLATE             = $8000                                                           ; 
#PD_ENABLESETUPTEMPLATEHANDLE       = $20000                                                          ; 
#PD_HIDEPRINTTOFILE                 = $100000                                                         ; 
#PD_NONETWORKBUTTON                 = $200000                                                         ; 
#PD_NOPAGENUMS                      = $8                                                              ; 
#PD_NOSELECTION                     = $4                                                              ; 
#PD_NOWARNING                       = $80                                                             ; 
#PD_PAGENUMS                        = $2                                                              ; 
#PD_PRINTSETUP                      = $40                                                             ; 
#PD_PRINTTOFILE                     = $20                                                             ; 
#PD_RETURNDC                        = $100                                                            ; 
#PD_RETURNDEFAULT                   = $400                                                            ; 
#PD_RETURNIC                        = $200                                                            ; 
#PD_SELECTION                       = $1                                                              ; 
#PD_SHOWHELP                        = $800                                                            ; 
#PD_USEDEVMODECOPIES                = $40000                                                          ; 
#PD_USEDEVMODECOPIESANDCOLLATE      = $40000                                                          ; 

;==============================================================================================================================================================================
; Needed RTF constants
;==============================================================================================================================================================================

#FT_SEARCH                          = 1                                                               ; Searching Top to Bottom, not the whole Word and not Case sensitive
#FT_SEARCH_Bottom_to_Top            = 0                                                               ; 
#FT_WHOLEWORD                       = 2                                                               ; 
#FT_MATCHCASE                       = 4                                                               ; 

#CFM_BACKCOLOR                      = $4000000                                                        ; 
#CFE_AUTOBACKCOLOR                  = #CFM_BACKCOLOR                                                  ; 

#ENM_LINK                           = $04000000                                                       ; 

#CFM_LINK                           = $00000020                                                       ; 
#CFE_LINK                           = $0020                                                           ; 
#CFE_SUBSCRIPT                      = $00010000                                                       ; 
#CFE_SUPERSCRIPT                    = $00020000                                                       ; 
#CFM_SUBSCRIPT                      = #CFE_SUBSCRIPT | #CFE_SUPERSCRIPT                               ; 
#CFM_SUPERSCRIPT                    = #CFM_SUBSCRIPT                                                  ; 

#PFA_JUSTIFY                        = 4                                                               ; New paragraph-alignment option 2.0

#CFM_ALLCAPS                        = $80                                                             ; 
#CFE_ALLCAPS                        = #CFM_ALLCAPS                                                    ; 
#CFM_SMALLCAPS                      = $40                                                             ; 
#CFE_SMALLCAPS                      = #CFM_SMALLCAPS                                                  ; 

#ST_DEFAULT                         = 0                                                               ; 
#ST_KEEPUNDO                        = 1                                                               ; 
#ST_SELECTION                       = 2                                                               ; 

;==============================================================================================================================================================================
; Get the current position on a gadget relative to a window
;==============================================================================================================================================================================

#LVM_SUBITEMHITTEST                 = #LVM_FIRST + 57                                                 ; 

;==============================================================================================================================================================================
; Windows title bar height, used for figuring out resizing after hiding or showing the main toolbar
;==============================================================================================================================================================================

#CCHILDREN_TITLEBAR                 = 5                                                               ; 

;==============================================================================================================================================================================
; Dealing with strikeout attributes on a font in a listicongadget
;==============================================================================================================================================================================

#FontStrikeoutYes                   = 0                                                               ; 
#FontStrikeoutNo                    = 1                                                               ; 

#FontUnderlineYes                   = 0                                                               ; 
#FontUnderlineNo                    = 1                                                               ; 

#FontBoldYes                        = 0                                                               ; 
#FontBoldNo                         = 1                                                               ; 

;==============================================================================================================================================================================
; My personal constants
;==============================================================================================================================================================================

#Author                         = "Miklós G Bolváry"                                                  ; Author's name
#CopyRight                      = "MGB Technical Services 2016 "                                      ; Copyright holder
#Basename                       = "My Stuff "                                                         ; Base name for initialisation file and database
#Version                        = "v2.00."                                                            ; Program version
#Program                        = #Basename + #Version                                                ; Copyright string
#SystrayNote                    = "Hello, "+ #Program + " is hiding here"                             ; System tray note

;==============================================================================================================================================================================
; Program constants that don't need to change. Wordier to allow easier error tracking
;==============================================================================================================================================================================

#ListIconHeadingArea            = -1                                                                  ; 

#AtTheEndOfTheList              = -1                                                                  ; 
#AtTheListHeading               = -1                                                                  ; 

#NoItems                        =  0                                                                  ; 
#FirstItem                      =  0                                                                  ; 

#NoWindowId                     =  0                                                                  ; 

#NothingFound                   =  0                                                                  ; 
#NothingSelected                = -1                                                                  ; 

#NoDataFound                    =  0                                                                  ; 
#NoBlobFound                    =  0                                                                  ; 
#NoPictureHandle                =  0                                                                  ; 
#NoPictureFound                 = -1                                                                  ; 
#NoDocumentFound                = -1                                                                  ; 
#NoPictureLoaded                =  0                                                                  ; 
#NoPictureResized               =  0                                                                  ; 

#NoColumnIcon                   =  0                                                                  ; 
#NoData                         =  0                                                                  ; 
#NoCurrentLine                  = -1                                                                  ; Make sure no line can be selected accidentally
#NoRecordNumber                 = ""                                                                  ; 
#EmptyString                    = ""                                                                  ; 

#NoCurrentShortcut              = 0                                                                   ; 

#DatabaseNotOpen                =  0                                                                  ; 
#DatabaseQueryFail              =  0                                                                  ; 
#DatabaseUpdateFail             =  0                                                                  ; 
#DatabaseQueryEmpty             =  0                                                                  ; 

#DateNotActive                  =  0                                                                  ; 

#NoFileHandle                   =  0                                                                  ; 
#NotEndOfFile                   =  0                                                                  ; 
#FileIsEmpty                    =  0                                                                  ; 
#FileNotDecompressed            = -1                                                                  ; 
#NoFileDeleted                  =  0                                                                  ; 

#FileDoesNotExist               = -1                                                                  ; 
#FileIsDirectory                = -2                                                                  ; 
#FileNotCopied                  =  0                                                                  ; 

#DirectoryNotCreated            =  0                                                                  ; 

#NoPrintFileHandle              =  0                                                                  ; 
#NoImportFileHandle             =  0                                                                  ; 
#NoExportFileHandle             =  0                                                                  ; 

#NoMenuCreated                  =  0                                                                  ; 

#NoStringFound                  =  0                                                                  ; 

#NoThreadRunning                =  0                                                                  ; 

#TitleBarClockTimerEvent        = 624                                                                 ; Title bar clock timer event

#Fish                           = "<°)))o><²³  "                                                      ; Beware the fish!!

#DatasheetPictureWidth          = 137                                                                 ; 
#DatasheetPictureHeight         = 162                                                                 ; 

#MainPictureWidth               = 800                                                                 ; 
#MainPictureHeight              = 600                                                                 ; 

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

#LocationTitleColumn            = 0                                                                   ; 
#LocationIconColumn             = 1                                                                   ; 
#LocationItemsColumn            = 2                                                                   ; 
#LocationRecordColumn           = 3                                                                   ; 

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

#NameofitemColumn               =  0                                                                  ; 
#LoanedtoColumn                 =  1                                                                  ; 
#LocationColumn                 =  2                                                                  ; 
#CategoryColumn                 =  3                                                                  ; 
#CostColumn                     =  4                                                                  ; 
#DeletedColumn                  =  5                                                                  ; 
#FavouriteColumn                =  6                                                                  ; 
#LockedColumn                   =  7                                                                  ; 
#RecordColumn                   =  8                                                                  ; 

;==============================================================================================================================================================================
; RTF structure data from Freak (Timo Harter)
;==============================================================================================================================================================================

Structure CHARFORMAT2_                                                                               ; 
  cbSize.l                                                                                            ; 
  dwMask.l                                                                                            ; 
  dwEffects.l                                                                                         ; 
  yHeight.l                                                                                           ; 
  yOffset.l                                                                                           ; 
  crTextColor.l                                                                                       ; 
  bCharSet.b                                                                                          ; 
  bPitchAndFamily.b                                                                                   ; 
  szFaceName.b[#LF_FACESIZE]                                                                          ; 
  _wPad2.w                                                                                            ; 
  wWeight.w                                                                                           ; 
  sSpacing.w                                                                                          ; 
  crBackColor.l                                                                                       ; 
  lcid.l                                                                                              ; 
  dwReserved.l                                                                                        ; 
  sStyle.w                                                                                            ; 
  wKerning.w                                                                                          ; 
  bUnderlineType.b                                                                                    ; 
  bAnimation.b                                                                                        ; 
  bRevAuthor.b                                                                                        ; 
  bReserved1.b                                                                                        ; 
EndStructure                                                                                         ; 

;==============================================================================================================================================================================
; Work out windows title bar details for dynamic form resizing
;==============================================================================================================================================================================

Structure TITLEBARINFO                                                                               ; 
  cbSize.l                                                                                            ; 
  rcTitleBar.RECT                                                                                     ; 
  rgstate.l[#CCHILDREN_TITLEBAR + 1]                                                                  ; 
EndStructure                                                                                         ; 

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

Structure Optiondata                                                                                 ; 
  Showtitlebarclock.i                                                                                 ; 
  Stickwindowontop.i                                                                                  ; 
  Snapformtoborders.i                                                                                 ; 
  Tooltipsonoroff.i                                                                                   ; 
  Colourbandinlist.i                                                                                  ; 
  Messageaftersave.i                                                                                  ; 
EndStructure                                                                                         ; 

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

Structure Locationdata                                                                               ; 
  Currentline.i                                                                                       ; 
  Currentrecord.s                                                                                     ; 
  Locationid.s                                                                                        ; 
  Location.s                                                                                          ;  
  Iconname.s                                                                                          ; 
  Hasitems.s                                                                                          ; 
  OldLocation.s                                                                                       ; 
EndStructure                                                                                         ; 

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

Structure MyStuffEditData                                                                            ; 
  CurrentLine.i                                                                                       ; Current line in a list
  Currentrecord.s                                                                                     ; Current record number in a list
  Oldline.i                                                                                           ; Previos line highlighted
  Mystuffid.s                                                                                         ; Current record number selected
  Currenttitle.s                                                                                      ; Current record title selected
  Oldpicturetokeep.s                                                                                  ; The previous picture name to keep
  Newpicturetosave.s                                                                                  ; The new picture name to save
  PictureAndPath.s                                                                                    ; Original picture and path to copy
  OldDocumenttokeep.s                                                                                 ; The old document to keep
  NewDocumenttosave.s                                                                                 ; The new document to save
  DocumentAndPath.s                                                                                   ; Original document and path
EndStructure                                                                                         ; 

;==============================================================================================================================================================================
; Standard program data structure
;==============================================================================================================================================================================

Structure ProgramData                                                                                ; 
  ; Standard semaphores
  
  QuitValue.i                                                                                         ; Program quit value
  FirstTime.i                                                                                         ; Program first start
  WindowMutex.i                                                                                       ; Single window flag
  LastWindow.s                                                                                        ; The last window opened
  LastChildWindow.s                                                                                   ; The last child window opened
  TrayState.i                                                                                         ; Hide program to tray
  AlternateRow.i                                                                                      ; Alternate row colouring toggle
  
  ; Current items that were selected
  
  CurrentDate.s                                                                                       ; The current date minus the time component
  CurrentDay.s                                                                                        ; Used For tracking last updates
  
  ; Refocus on the last line used after an edit
  
  ReFocusLine.i                                                                                       ; Refocus line number after sort
  
  ; Working program directories
  
  CurrentDirectory.s                                                                                  ; Current working directory
  BackupDirectory.s                                                                                   ; System files backup directory
  PictureDirectory.s                                                                                  ; The local pictures directory
  IconsDirectory.s                                                                                    ; User choice location icons
  HelpDirectory.s                                                                                     ; The local help files directory
  DocumentDirectory.s                                                                                 ; The local Documents directory
  TemporaryDirectory.s                                                                                ; Temporary user files directory
  
  ; Database name and paths etc
  
  DatabaseDirectory.s                                                                                 ; Local database directory
  DatabaseName.s                                                                                      ; Local database name
  DatabaseHandle.i                                                                                    ; Opened database handle
  
  ; Dealing with search cues in search boxes
  
  SearchCueFont.i                                                                                     ; Searchbox cue font
  SearchNormalFont.i                                                                                  ; Searchbox normal font
  CueText.s                                                                                           ; The cue text to be passed to search windows
  
  ; Various form variables
  
  FontSize.i                                                                                          ; RTF testing stuff. Currently used font size
  BackgroundColour.i                                                                                  ; Static controls background colours
  DesktopWidth.i                                                                                      ; Current desktop width
  DesktopHeight.i                                                                                     ; Current desktop height
  
  ; Error file directives
  
  ErrorFile.s                                                                                         ; Program error log file
  ErrorHeader.i                                                                                       ; Has the error header been written yet?
  ErrorLogExists.i                                                                                    ; Has the error log been created this program run?
  
  ; Global worker thread handle
  
  WorkerThreadHandle.i                                                                                ; Worker thread handle
  
  ; Import routine variables
  
  OwnerName.s                                                                                         ; Name of the program owner, for import
  CurrentImportCount.i                                                                                ; Current import file count
  
  ; Balloon tooltip parameters
  
  BalloonFontId.i                                                                                     ; Balloon tooltip font
  BalloonWindowId.i                                                                                   ; Current balloon window
  
  ; Export and transfer flags
  
  ExportTagState.i                                                                                    ; Current export my stuff mass tag state
  
  ; 
  
  OldWindowTitle.s                                                                                    ; Old window title for changing or adding to
  
  ;
  
  TotalCost.d                                                                                         ; Total running value of item costs
  
  ; PDF stuff
  
  ConfigurationFile.s                                                                                 ; Name of configuration file for pdf save
  
  ; Compiler and build counts
  
  CompileCounters.s                                                                                   ; Compiler and build counter
EndStructure                                                                                         ; 

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

Structure MyStuffData                                                                                ; 
  Itemname.s                                                                                          ; 
  Supplier.s                                                                                          ; 
  Manufacturer.s                                                                                      ; 
  Modelnumber.s                                                                                       ; 
  Serialnumber.s                                                                                      ; 
  Barcode.s                                                                                           ; 
  Boughton.s                                                                                          ; 
  Working.s                                                                                           ; 
  Whopaid.s                                                                                           ; 
  Ownername.s                                                                                         ; 
  Location.s                                                                                          ; 
  Condition.s                                                                                         ; 
  Category.s                                                                                          ; 
  Importance.i                                                                                        ; 
  Loanedto.s                                                                                          ; 
  Comments.s                                                                                          ; 
  
  Itempicture.s                                                                                       ; 
  
  Itemdocument.s                                                                                      ; 
  
  Cost.s                                                                                              ; 
  Tax.s                                                                                               ; 
  Delivery.s                                                                                          ; 
  Othercost.s                                                                                         ; 
  Resale.s                                                                                            ; 
  Paidby.s                                                                                            ; 
  
  Warrantyperiod.s                                                                                    ; 
  Warrantyword.s                                                                                      ; 
  Warrantyactive.s                                                                                    ; 
  Warrantyextra.s                                                                                     ; 
  
  Insured.s                                                                                           ; 
  Insuredamount.s                                                                                     ; 
  Insuredon.s                                                                                         ; 
  Insurername.s                                                                                       ; 
  Policynumber.s                                                                                      ; 
  Contactnumber.s                                                                                     ; 
  Contactname.s                                                                                       ; 
  Contactdepartment.s                                                                                 ; 
  
  Deleted.s                                                                                           ; 
  Favourite.s                                                                                         ; 
  Locked.s                                                                                            ; 
  
  Mystuffid.s                                                                                         ; 
EndStructure                                                                                         ; 

;==============================================================================================================================================================================
; Error structure data
;==============================================================================================================================================================================

Structure ErrorData                                                                                  ; Error data log
  ErrorTime.s                                                                                         ; 
  ErrorModule.s                                                                                       ; 
  ErrorMessage.s                                                                                      ; 
  ExtraInfo.s                                                                                         ; 
EndStructure                                                                                         ; 

;==============================================================================================================================================================================
; Custom date routine structure
;==============================================================================================================================================================================

Structure DateStructure                                                                              ; Custom date routine
  Year.w                                                                                              ; 
  Month.w                                                                                             ; 
  DayOfWeek.w                                                                                         ; 
  Day.w                                                                                               ; 
  Hour.w                                                                                              ; 
  Minute.w                                                                                            ; 
  Second.w                                                                                            ; 
  Milliseconds.w                                                                                      ; 
EndStructure                                                                                         ; 

;==============================================================================================================================================================================
; Tooltip structure data
;==============================================================================================================================================================================

Structure ToolTipData                                                                                ; If any tooltips setup, keep track of gadgets that have them so you can remove them if needed
  pbWindowNumber.i                                                                                    ; 
  pbHandleTip.i                                                                                       ; 
  pbGadgetID.i                                                                                        ; 
  pbGadgetNumber.i                                                                                    ; 
  pbIconHandle.i                                                                                      ; 
EndStructure                                                                                         ; 

;==============================================================================================================================================================================
; Button glow effects structure
;==============================================================================================================================================================================

Structure GlowData                                                                                   ; 
  GlowColour.l                                                                                        ; 
  GlowRadius.i                                                                                        ; 
  ExtendCanvas.i                                                                                      ; 
EndStructure                                                                                         ; 

;==============================================================================================================================================================================
; Global constants, including structures
;==============================================================================================================================================================================

Global Location.LocationData                                                                          ; My stuff structure data
Global Program.ProgramData                                                                            ; All my program variables
Global MyStuff.MyStuffData                                                                            ; Category structure data
Global Mystuffedit.MyStuffEditData                                                                    ; MyStuff editor form constants
Global Glow.GlowData                                                                                  ; Icon glow outline
Global Option.OptionData                                                                              ; Global program option data
Global Balloon.TOOLINFO                                                                               ; Balloon tooltips
Global td.SYSTEMTIME                                                                                  ; This is used as interface for time and date conversions
Global WebObject.IWebbrowser2, WebObject                                                              ; For the web page printing
Global NewList ToolTips.ToolTipData()                                                                ; All tool tip handles and data here
Global NewList ErrorList.ErrorData()                                                                 ; List of error messages to be flushed to disk
Global NewList FoundDirs.s()                                                                         ; List of recursed import directories
Global PrinterDeviceContext                                                                           ; RASHAD. Global device contect for Rtf printing
Global fText.FINDTEXT, Range.CHARRANGE, TextColour.i                                                  ; RASHAD find and highlight text

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

Glow\GlowColour   = $19121E                                                                           ; 
Glow\GlowRadius   = 4                                                                                 ; 
Glow\ExtendCanvas = #False                                                                            ; 

;==============================================================================================================================================================================
; NetMaestro's screen snap code
;==============================================================================================================================================================================

Global ScreenW.i, ScreenH.i, SnapD.i = 50, AutoSnap.i = #True                                        ;

Define wa.RECT                                                                                       ; 

SystemParametersInfo_(#SPI_GETWORKAREA, 0, @wa.RECT, 0)                                               ; Client area of the desktop

ScreenW.i = wa\right                                                                                  ;

screenH.i = wa\bottom                                                                                 ;

;==============================================================================================================================================================================
; Whether the tray is hidden or not
;==============================================================================================================================================================================

Program\TrayState     = #False                                                                        ; Set initial tray hiding state so we avoing loops

;==============================================================================================================================================================================
; Srod. Colour picker module. Define a color array. This is optional and consists of 12 elements, not all of which have to be defined.
;==============================================================================================================================================================================

Global Dim Colours(11)                                                                               ; 

Define lf.LOGFONT                                                                                    ; 

; In this example we define 4 custom colors and mark the remaining 8 as undefined by setting 
; them to -1.  (The user will not be able to select these undefined colours.)

  Colours(0) = #Green                                                                                 ; 
  Colours(1) = #Blue                                                                                  ; 
  Colours(2) = #Gray                                                                                  ; 
  Colours(3) = #Red                                                                                   ; 

For i = 4 To 11                                                                                       ; 
  Colours(i) = -1                                                                                     ; 
Next                                                                                                  ; 

lf.LOGFONT                                                                                            ; 
lf\lfCharset = #DEFAULT_CHARSET                                                                       ; 

;==============================================================================================================================================================================
; Setup the search box cue fonts
;==============================================================================================================================================================================

Program\SearchCueFont         = LoadFont(#PB_Any,   "Georgia",       10, #PB_Font_Italic)             ; Empty search cue font
Program\SearchNormalFont      = LoadFont(#PB_Any,   "Comic Sans MS", 10, 0)                           ; Filled cue box font

Program\CueText.s             = Space(256)                                                            ; Set the cue text buffer

;==============================================================================================================================================================================
; Used in a callback to colour static controls that PB doesn't manage
;==============================================================================================================================================================================

Program\BackgroundColour    = CreateSolidBrush_($FFFFFF)                                              ; Static controls background colours

;==============================================================================================================================================================================
; Dare and time testing, date display on title bar
;==============================================================================================================================================================================

Program\CurrentDate         = FormatDate("%dd/%mm/%yyyy", Date())                                     ; Get the current system date without the time component

;==============================================================================================================================================================================
; Setup all directory variables and database file name
;==============================================================================================================================================================================

Program\CurrentDirectory    = GetCurrentDirectory()                                                   ; Get working directories

Program\BackupDirectory     = Program\CurrentDirectory    + "Store\Backup\"                           ; Set system files backup directory
Program\DatabaseDirectory   = Program\CurrentDirectory    + "Store\Database\"                         ; Set working database directory
Program\PictureDirectory    = Program\CurrentDirectory    + "Store\Pictures\"                         ; Set working pictures directory
Program\IconsDirectory      = Program\CurrentDirectory    + "Store\Usericons\"                        ; User choice location icons
Program\HelpDirectory       = Program\CurrentDirectory    + "Store\Helpfiles\"                        ; Set working help files directory
Program\DocumentDirectory   = Program\CurrentDirectory    + "Store\Documents\"                        ; Set working Document directory
Program\TemporaryDirectory  = Program\CurrentDirectory    + "Store\Temporary\"                        ; Temporary scans, export and more

Program\DatabaseName        = Program\DatabaseDirectory   + Trim(#Basename) +  ".sqlite"              ; Default program database name

Program\ConfigurationFile   = Program\TemporaryDirectory  + "MystuffPDFCfg.cfg"                       ; Scan quality options. Not sure I am using it

;==============================================================================================================================================================================
; Get the current width and height of the working desktop
;==============================================================================================================================================================================

Program\DesktopWidth        = DesktopWidth(0)                                                         ; Current desktop width
Program\DesktopHeight       = DesktopHeight(0)                                                        ; Current desktop height

;==============================================================================================================================================================================
; Get the current width and height of the working desktop
;==============================================================================================================================================================================

Program\FirstTime           = #False                                                                  ; 
Program\BalloonFontId       = LoadFont(#PB_Any, "Comic Sans MS", 10, #PB_Font_HighQuality | #PB_Font_Italic)

;==============================================================================================================================================================================
; Create your program directories
;==============================================================================================================================================================================

Program\CompileCounters     = Str(#PB_Editor_CompileCount) + "." + Str(#PB_Editor_BuildCount) + "a"   ; Add to program version

;==============================================================================================================================================================================
; Create your program directories
;==============================================================================================================================================================================

MakeSureDirectoryPathExists(Program\BackupDirectory)                                                  ; Create the system files backup directory
MakeSureDirectoryPathExists(Program\DatabaseDirectory)                                                ; Create the program's working directories if you can 
MakeSureDirectoryPathExists(Program\HelpDirectory)                                                    ; Create the program's help files directory if you can 
MakeSureDirectoryPathExists(Program\PictureDirectory)                                                 ; Create working pictures directory
MakeSureDirectoryPathExists(Program\IconsDirectory)                                                   ; User choice location icons
MakeSureDirectoryPathExists(Program\DocumentDirectory)                                                ; Create working Document directory
MakeSureDirectoryPathExists(Program\TemporaryDirectory)                                               ; Create application local temporary directory

;==============================================================================================================================================================================
; Initial program window quit state
;==============================================================================================================================================================================

Program\QuitValue           =  0                                                                      ; Initial program quit value

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

Program\ErrorFile           = Program\TemporaryDirectory + Trim(#Basename) + "_Error.Log"             ; Program error log file
Program\ErrorHeader         = 0                                                                       ; Error file handle to start with

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

Program\FontSize        = 10                                                                          ; Default font size for instructions before resizing

;==============================================================================================================================================================================
; Setup day and month literal names
;==============================================================================================================================================================================

Define DaysPerMonthFill.i                                                                             ; 

Global Dim NameOfDay.s(7)                                                                             ; Fill an array with the names of the days (Terry Hough I think)

  NameOfDay(0)      = "Sunday"
  NameOfDay(1)      = "Monday"
  NameOfDay(2)      = "Tuesday"
  NameOfDay(3)      = "Wednesday"
  NameOfDay(4)      = "Thursday"
  NameOfDay(5)      = "Friday"
  NameOfDay(6)      = "Saturday"

Global Dim DaysPerMonth(12)                                                                           ; Fill an array on how many days per month there are

  For DaysPerMonthFill.i = 0 To 11     
    DaysPerMonth(DaysPerMonthFill.i) = 31 
  Next

  DaysPerMonth(1)   = 28
  DaysPerMonth(3)   = 30
  DaysPerMonth(5)   = 30
  DaysPerMonth(8)   = 30
  DaysPerMonth(10)  = 30

Global Dim NameOfMonth.s(12)                                                                          ; Fill an array with the names of the months

  NameOfMonth(0)    = "January"
  NameOfMonth(1)    = "February"
  NameOfMonth(2)    = "March"
  NameOfMonth(3)    = "April"
  NameOfMonth(4)    = "May"
  NameOfMonth(5)    = "June"
  NameOfMonth(6)    = "July"
  NameOfMonth(7)    = "August"
  NameOfMonth(8)    = "September"
  NameOfMonth(9)    = "October"
  NameOfMonth(10)   = "November"
  NameOfMonth(11)   = "December"

Global Dim Years.s(19)                                                                                ; Fill an array with the years

  Years(0)          = "2002"
  Years(1)          = "2003"
  Years(2)          = "2004"
  Years(3)          = "2005"
  Years(4)          = "2006" 
  Years(5)          = "2007"
  Years(6)          = "2008"
  Years(7)          = "2009"
  Years(8)          = "2010"
  Years(9)          = "2011"
  Years(10)         = "2012"
  Years(11)         = "2013"
  Years(12)         = "2014"
  Years(13)         = "2015"
  Years(14)         = "2016"
  Years(15)         = "2017"
  Years(16)         = "2018"
  Years(17)         = "2019"
  Years(18)         = "2020"
  
;==============================================================================================================================================================================
; Shortcut key assignments for main form
;==============================================================================================================================================================================
  
;  Files
  
#Keys_Mystuff_Backupmystuff         = #PB_Shortcut_Alt      | #PB_Shortcut_B
#Keys_Mystuff_Deleteallmystuff      = #PB_Shortcut_Alt      | #PB_Shortcut_D
#Keys_Mystuff_Vacuummystuff         = #PB_Shortcut_Alt      | #PB_Shortcut_V
#Keys_Mystuff_Exportmystuff         = #PB_Shortcut_Alt      | #PB_Shortcut_E
#Keys_Mystuff_Importmystuff         = #PB_Shortcut_Alt      | #PB_Shortcut_I
#Keys_Mystuff_Exitmystuff           = #PB_Shortcut_Alt      | #PB_Shortcut_X

; Locations

#Keys_Mystuff_Addlocation           = #PB_Shortcut_Alt      | #PB_Shortcut_Shift |  #PB_Shortcut_A
#Keys_Mystuff_Copylocation          = #PB_Shortcut_Alt      | #PB_Shortcut_Shift |  #PB_Shortcut_C
#Keys_Mystuff_Deletelocation        = #PB_Shortcut_Alt      | #PB_Shortcut_Shift |  #PB_Shortcut_D
#Keys_Mystuff_Editlocation          = #PB_Shortcut_Alt      | #PB_Shortcut_Shift |  #PB_Shortcut_E
#Keys_Mystuff_Exportlocations       = #PB_Shortcut_Alt      | #PB_Shortcut_Shift |  #PB_Shortcut_X
#Keys_Mystuff_Importlocations       = #PB_Shortcut_Alt      | #PB_Shortcut_Shift |  #PB_Shortcut_I

; My stuff

#Keys_Mystuff_Addnewstuff           = #PB_Shortcut_Control  | #PB_Shortcut_Alt   | #PB_Shortcut_A
#Keys_Mystuff_Copyoldstuff          = #PB_Shortcut_Control  | #PB_Shortcut_Alt   | #PB_Shortcut_C
#Keys_Mystuff_Deleteoldstuff        = #PB_Shortcut_Control  | #PB_Shortcut_Alt   | #PB_Shortcut_D
#Keys_Mystuff_Editoldstuff          = #PB_Shortcut_Control  | #PB_Shortcut_Alt   | #PB_Shortcut_E
#Keys_Mystuff_Killthisstuff         = #PB_Shortcut_Control  | #PB_Shortcut_Alt   | #PB_Shortcut_K
#Keys_Mystuff_Lockthisstuff         = #PB_Shortcut_Control  | #PB_Shortcut_Alt   | #PB_Shortcut_L
#Keys_Mystuff_Favouritestuff        = #PB_Shortcut_Control  | #PB_Shortcut_Alt   | #PB_Shortcut_F
#Keys_Mystuff_Printthisstuff        = #PB_Shortcut_Control  | #PB_Shortcut_Alt   | #PB_Shortcut_P
#Keys_Mystuff_Pictureofstuff        = #PB_Shortcut_Control  | #PB_Shortcut_Alt   | #PB_Shortcut_V

; Search

#Keys_Mystuff_CheckReturn           = #PB_Shortcut_Return

; Options

#Keys_Mystuff_Colourbandinlist      = #PB_Shortcut_F2
#Keys_Mystuff_Lockmystuffwindow     = #PB_Shortcut_F3
#Keys_Mystuff_Messageaftersave      = #PB_Shortcut_F4
#Keys_Mystuff_Stickwindowontop      = #PB_Shortcut_F5
#Keys_Mystuff_Showtitlebarclock     = #PB_Shortcut_F6
#Keys_Mystuff_Snapformtoborders     = #PB_Shortcut_F7
#Keys_Mystuff_Tooltipsonoroff       = #PB_Shortcut_F8
#Keys_Mystuff_Setupmystuff          = #PB_Shortcut_F9

; Help

#Keys_Mystuff_Aboutmystuff          = #PB_Shortcut_F10
#Keys_Mystuff_Keyboardshortcuts     = #PB_Shortcut_F11
#Keys_Mystuff_Showhelp              = #PB_Shortcut_F1

; Miscellaneous

#Keys_Mystuff_Statisticsformystuff  = #PB_Shortcut_Alt      | #PB_Shortcut_Shift | #PB_Shortcut_S 
#Keys_Mystuff_Viewmystufflogfile    = #PB_Shortcut_Alt      | #PB_Shortcut_Shift | #PB_Shortcut_V

#Keys_Statisticsformystuff_Escape   = #PB_Shortcut_Escape
#Keys_Aboutmystuff_Escape           = #PB_Shortcut_Escape

;--------------------------------------------------------------------------------------------------
; Location bar
;--------------------------------------------------------------------------------------------------

#Keys_Location_Escape               = #PB_Shortcut_Escape
#Keys_Location_Save                 = #PB_Shortcut_Alt      | #PB_Shortcut_S
#Keys_Location_Exit                 = #PB_Shortcut_Alt      | #PB_Shortcut_X

;--------------------------------------------------------------------------------------------------
; Data sheet
;--------------------------------------------------------------------------------------------------

#Keys_Datasheet_Escape              = #PB_Shortcut_Escape

#Keys_Datasheet_Lookupmodel         = #PB_Shortcut_Alt      | #PB_Shortcut_L
  
#Keys_Datasheet_Menu_Addpicture     = #PB_Shortcut_Alt      | #PB_Shortcut_A
#Keys_Datasheet_Menu_Clearpicture   = #PB_Shortcut_Alt      | #PB_Shortcut_C
#Keys_Datasheet_Menu_Deletepicture  = #PB_Shortcut_Alt      | #PB_Shortcut_D
#Keys_Datasheet_Menu_ScanPicture    = #PB_Shortcut_Control  | #PB_Shortcut_S

#Keys_Datasheet_Savemystuff         = #PB_Shortcut_Alt      | #PB_Shortcut_S
#Keys_Datasheet_Addpicture          = #PB_Shortcut_Alt      | #PB_Shortcut_Shift | #PB_Shortcut_C
#Keys_Datasheet_Scanpicture         = #PB_Shortcut_Alt      | #PB_Shortcut_Shift | #PB_Shortcut_P
#Keys_Datasheet_Scandocument        = #PB_Shortcut_Alt      | #PB_Shortcut_Shift | #PB_Shortcut_D
#Keys_Datasheet_Adddocument         = #PB_Shortcut_Alt      | #PB_Shortcut_Shift | #PB_Shortcut_A
#Keys_Datasheet_Viewdocument        = #PB_Shortcut_Alt      | #PB_Shortcut_Shift | #PB_Shortcut_L
#Keys_Datasheet_Relinkdocument      = #PB_Shortcut_Alt      | #PB_Shortcut_Shift | #PB_Shortcut_R
#Keys_Datasheet_Exitmystuff         = #PB_Shortcut_Alt      | #PB_Shortcut_X

#Keys_ViewDocument_Escape           = #PB_Shortcut_Escape

;--------------------------------------------------------------------------------------------------
; Shortcut key assignments for the picture viewer
;--------------------------------------------------------------------------------------------------

#Keys_Pictureofstuff_Escape         = #PB_Shortcut_Escape

;--------------------------------------------------------------------------------------------------
; Shortcut key assignments for the keyboard shortcuts list
;--------------------------------------------------------------------------------------------------

#Keys_Keyboardshortcuts_Escape      = #PB_Shortcut_Escape

;--------------------------------------------------------------------------------------------------
; Shortcut key assignments for various hidden administrative functions
;--------------------------------------------------------------------------------------------------

#Keys_Mystuff_ImportMyDocuments     = #PB_Shortcut_Control  | #PB_Shortcut_Alt | #PB_Shortcut_Shift | #PB_Shortcut_I

;==============================================================================================================================================================================
; Shortcut keys menu text
;==============================================================================================================================================================================

; "Files"

#Keystext_Mystuff_Backupmystuff          = "Backup my stuff to storage"
#Keystext_Mystuff_Deleteallmystuff       = "Delete all my stuff from the database"
#Keystext_Mystuff_Vacuummystuff          = "Vacuum my stuff of wasted space"
#Keystext_Mystuff_Exportmystuff          = "Export my stuff to XML files"
#Keystext_Mystuff_Importmystuff          = "Import my stuff from XML files"
#Keystext_Mystuff_Exitmystuff            = "Exit my stuff immediately"

; "Locations"

#Keystext_Mystuff_Addlocation            = "Add a new location to the list"
#Keystext_Mystuff_Copylocation           = "Copy the current location to clipboard"
#Keystext_Mystuff_Deletelocation         = "Delete the current location from the list"
#Keystext_Mystuff_Editlocation           = "Edit the current location"
#Keystext_Mystuff_Exportlocations        = "Export locations to disk"
#Keystext_Mystuff_Importlocations        = "Import locations from disk"

; "My stuff"

#Keystext_Mystuff_Addnewstuff            = "Add new stuff to the database"
#Keystext_Mystuff_Copyoldstuff           = "Copy old stuff to clipboard"
#Keystext_Mystuff_Deleteoldstuff         = "Delete the selected old stuff"
#Keystext_Mystuff_Editoldstuff           = "Edit the selected old stuff"
#Keystext_Mystuff_Killthisstuff          = "Kill the selected stuff"
#Keystext_Mystuff_Lockthisstuff          = "Lock the selected stuff"
#Keystext_Mystuff_Favouritestuff         = "Mark this stuff as favourite"
#Keystext_Mystuff_Printthisstuff         = "Print the selected stuff"
#Keystext_Mystuff_Pictureofstuff         = "View larger picture for stuff"

; "Search"

#Keystext_Mystuff_CheckReturn            = "Select which gadget fires on return"

; "Options"

#Keystext_Mystuff_Colourbandinlist       = "Show colour banding in list"
#Keystext_Mystuff_Lockmystuffwindow      = "Lock my stuff window"
#Keystext_Mystuff_Messageaftersave       = "Show messages after saving"
#Keystext_Mystuff_Stickwindowontop       = "Stick mystuff window on top"
#Keystext_Mystuff_Showtitlebarclock      = "Show a clock in the titlebar"
#Keystext_Mystuff_Snapformtoborders      = "Snap mystuff window to borders"
#Keystext_Mystuff_Tooltipsonoroff        = "Turn tooltips on or off"
#Keystext_Mystuff_Setupmystuff           = "Setup mystuff options"

; "Help"

#Keystext_Mystuff_Aboutmystuff           = "About the mystuff program"
#Keystext_Mystuff_Keyboardshortcuts      = "List keyboard shortcuts"
#Keystext_Mystuff_Showhelp               = "Show help for mystuff"

; "Miscellaneous"

#Keystext_Mystuff_Statisticsformystuff   = "Statistics for my stuff"
#Keystext_Mystuff_Viewmystufflogfile     = "View my stuff log file"

;--------------------------------------------------------------------------------------------------
; Location bar
;--------------------------------------------------------------------------------------------------

#Keystext_Location_Escape                = "Close the location editor"
#Keystext_Location_Save                  = "Save the location"
#Keystext_Location_Exit                  = "Exit location editor"

;--------------------------------------------------------------------------------------------------
; Key text for the data sheet
;--------------------------------------------------------------------------------------------------

; Picture viewer

#Keystext_Datasheet_Lookupmodel          = "Look up model number and manufacturer"

#Keystext_Datasheet_Menu_Addpicture      = "Add a new picture to this stuff"
#Keystext_Datasheet_Menu_Clearpicture    = "Clear the existing picture"
#Keystext_Datasheet_Menu_Deletepicture   = "Delete the old picture"
#Keystext_Datasheet_Menu_ScanPicture     = "Aquire a picture from a scanner"

#Keystext_Datasheet_Savemystuff          = "Save this current stuff"
#Keystext_Datasheet_AddPicture           = "Load picture from disk"
#Keystext_Datasheet_Scanpicture          = "Aquire a picture from a scanner"
#Keystext_Datasheet_ScanDocument         = "Aquire a document from a scanner"
#Keystext_Datasheet_AddDocument          = "Add a document from storage"
#Keystext_Datasheet_ViewDocument         = "View the attached document"
#Keystext_Datasheet_RelinkDocument       = "Relink a missing Document"
#Keystext_Datasheet_ExitMyStuff          = "Exit the data sheet"

;--------------------------------------------------------------------------------------------------
; Key text for hidden administrative functions
;--------------------------------------------------------------------------------------------------

#Keystext_Mystuff_ImportMyDocuments      = "Import properly formatted documents"

;==============================================================================================================================================================================
; Shortcut keys menu text
;==============================================================================================================================================================================

; "Files"

#Longkeystext_Mystuff_Backupmystuff          = "Backup my stuff to storage such as hard disk or other storage"
#Longkeystext_Mystuff_Deleteallmystuff       = "Delete all my stuff from the database, everything!"
#Longkeystext_Mystuff_Vacuummystuff          = "Vacuum my stuff of any wasted space due to record deletions"
#Longkeystext_Mystuff_Exportmystuff          = "Export my stuff to standard XML files on disk or other storage"
#Longkeystext_Mystuff_Importmystuff          = "Import my stuff from standard XML files from disk or other storage"
#Longkeystext_Mystuff_Exitmystuff            = "Exit the mystuff program immediately without fanfare"

; "Locations"

#Longkeystext_Mystuff_Addlocation            = "Add a new location to the list for your stuff"
#Longkeystext_Mystuff_Copylocation           = "Copy the currently selected location to the windows clipboard"
#Longkeystext_Mystuff_Deletelocation         = "Delete the currently location from the list"
#Longkeystext_Mystuff_Editlocation           = "Edit the currently selected location"
#Longkeystext_Mystuff_Exportlocations        = "Export all locations in the list to disk or other storage"
#Longkeystext_Mystuff_Importlocations        = "Import locations from disk or other storage"

; "My stuff"

#Longkeystext_Mystuff_Addnewstuff            = "Add some new fresh stuff to the Mystuff database"
#Longkeystext_Mystuff_Copyoldstuff           = "Copy the highlighted old stuff to the Windows clipboard"
#Longkeystext_Mystuff_Deleteoldstuff         = "Mark the selected old stuff to be deleted later"
#Longkeystext_Mystuff_Editoldstuff           = "Edit the selected old stuff to change the information"
#Longkeystext_Mystuff_Killthisstuff          = "Kill the selected stuff permanently with no reprieve"
#Longkeystext_Mystuff_Lockthisstuff          = "Lock the selected stuff to prevent kiddie tampering"
#Longkeystext_Mystuff_Favouritestuff         = "Mark the selected stuff as one of your all-time favourites"
#Longkeystext_Mystuff_Printthisstuff         = "Print the selected stuff to any printer insalled in your system"
#Longkeystext_Mystuff_Pictureofstuff         = "View a larger version of the attached picture for stuff"

; "Search"

#Longkeystext_Mystuff_CheckReturn            = "Select which gadget fires on return"

; "Options"

#Longkeystext_Mystuff_Colourbandinlist       = "Show colour banding in list"
#Longkeystext_Mystuff_Lockmystuffwindow      = "Lock my stuff window"
#Longkeystext_Mystuff_Messageaftersave       = "Show messages after saving"
#Longkeystext_Mystuff_Stickwindowontop       = "Stick mystuff window on top"
#Longkeystext_Mystuff_Showtitlebarclock      = "Show a clock in the titlebar"
#Longkeystext_Mystuff_Snapformtoborders      = "Snap mystuff window to borders"
#Longkeystext_Mystuff_Tooltipsonoroff        = "Turn tooltips on or off"
#Longkeystext_Mystuff_Setupmystuff           = "Setup mystuff options"

; "Help"

#Longkeystext_Mystuff_Aboutmystuff           = "About the mystuff program"
#Longkeystext_Mystuff_Keyboardshortcuts      = "List keyboard shortcuts"
#Longkeystext_Mystuff_Showhelp               = "Show help for mystuff"

; "Miscellaneous"

#Longkeystext_Mystuff_Statisticsformystuff   = "Statistics for my stuff"
#Longkeystext_Mystuff_Viewmystufflogfile     = "View my stuff log file"

;--------------------------------------------------------------------------------------------------
; Location bar
;--------------------------------------------------------------------------------------------------

#Longkeystext_Location_Escape                = "Close the location editor without warning"
#Longkeystext_Location_Save                  = "Save the new or edited location to disk or other storage"
#Longkeystext_Location_Exit                  = "Exit location editor without making any changes"

;--------------------------------------------------------------------------------------------------
; Key text for the data sheet
;--------------------------------------------------------------------------------------------------

; Picture viewer

#Longkeystext_Datasheet_Lookupmodel          = "Look up model number and manufacturer"

#Longkeystext_Datasheet_Menu_Addpicture      = "Add a new picture to this stuff"
#Longkeystext_Datasheet_Menu_Clearpicture    = "Clear the existing picture"
#Longkeystext_Datasheet_Menu_Deletepicture   = "Delete the old picture"
#Longkeystext_Datasheet_Menu_ScanPicture     = "Aquire a picture from a scanner"

#Longkeystext_Datasheet_Savemystuff          = "Save the new or edited stuff to disk or other storage"
#Longkeystext_Datasheet_AddPicture           = "Load and a attach a picture from disk or other storage"
#Longkeystext_Datasheet_Scanpicture          = "Aquire a picture from a scanner to attach to this stuff"
#Longkeystext_Datasheet_ScanDocument         = "Aquire a document from a scanner to attach to this stuff"
#Longkeystext_Datasheet_AddDocument          = "Add a document from from disk or other storage"
#Longkeystext_Datasheet_ViewDocument         = "View the attached document in a little window of its own"
#Longkeystext_Datasheet_RelinkDocument       = "Re-attach a missing document to the current stuff"
#Longkeystext_Datasheet_ExitMyStuff          = "Exit the data form editing environment"

;--------------------------------------------------------------------------------------------------
; Key text for hidden administrative functions
;--------------------------------------------------------------------------------------------------

#Longkeystext_Mystuff_ImportMyDocuments      = "Import properly formatted documents"

;==============================================================================================================================================================================
; All menu and keyboard shortcuts
;==============================================================================================================================================================================
  
Enumeration #GadgetIndex                                                                             ; 
  
  ; System tray icon
  
  #Systray_Mystuff_Tray                                                                               ; 
  
  ;  Files
  
  #Shortcut_Mystuff_Backupmystuff                                                                     ; 
  #Shortcut_Mystuff_Deleteallmystuff                                                                  ; 
  #Shortcut_Mystuff_Vacuummystuff                                                                     ; 
  #Shortcut_Mystuff_Exportmystuff                                                                     ; 
  #Shortcut_Mystuff_Importmystuff                                                                     ; 
  #Shortcut_Mystuff_Exitmystuff                                                                       ; 
  
  ;  Locations
  
  #Shortcut_Mystuff_Addlocation                                                                       ; 
  #Shortcut_Mystuff_Copylocation                                                                      ; 
  #Shortcut_Mystuff_Deletelocation                                                                    ; 
  #Shortcut_Mystuff_Editlocation                                                                      ; 
  #Shortcut_Mystuff_Exportlocations                                                                   ; 
  #Shortcut_Mystuff_Importlocations                                                                   ; 
  
  ;  My stuff
  
  #Shortcut_Mystuff_Addnewstuff                                                                       ; 
  #Shortcut_Mystuff_Copyoldstuff                                                                      ; 
  #Shortcut_Mystuff_Deleteoldstuff                                                                    ; 
  #Shortcut_Mystuff_Editoldstuff                                                                      ; 
  #Shortcut_Mystuff_Killthisstuff                                                                     ; 
  #Shortcut_Mystuff_Lockthisstuff                                                                     ; 
  #Shortcut_Mystuff_Favouritestuff                                                                    ; 
  #Shortcut_Mystuff_Printthisstuff                                                                    ; 
  #Shortcut_Mystuff_Pictureofstuff                                                                    ; 
  
  ;  Search
  
  #Shortcut_Mystuff_CheckReturn                                                                       ; 
  
  ;  Options
  
  #Shortcut_Mystuff_Colourbandinlist                                                                  ; 
  #Shortcut_Mystuff_Lockmystuffwindow                                                                 ; 
  #Shortcut_Mystuff_Messageaftersave                                                                  ; 
  #Shortcut_Mystuff_Stickwindowontop                                                                  ; 
  #Shortcut_Mystuff_Showtitlebarclock                                                                 ; 
  #Shortcut_Mystuff_Snapformtoborders                                                                 ; 
  #Shortcut_Mystuff_Tooltipsonoroff                                                                   ; 
  #Shortcut_Mystuff_Setupmystuff                                                                      ; 
  
  ;  Help
  
  #Shortcut_Mystuff_Aboutmystuff                                                                      ; 
  #Shortcut_Mystuff_Keyboardshortcuts                                                                 ; 
  #Shortcut_Mystuff_Showhelp                                                                          ; 
  
  ;  Miscellaneous
  
  #Shortcut_Mystuff_Statisticsformystuff                                                              ; 
  #Shortcut_Mystuff_Viewmystufflogfile                                                                ; 
  
  #ShortCut_Statisticsformystuff_escape                                                               ; 
  
  #Shortcut_Aboutmystuff_escape                                                                       ; 
  
  ;------------------------------------------------------------------------------------------------
  ; Location bar
  ;------------------------------------------------------------------------------------------------
  
  #Shortcut_Location_Escape                                                                           ; 
  #Shortcut_Location_Save                                                                             ; 
  #Shortcut_Location_Exit                                                                             ; 
  
  ;------------------------------------------------------------------------------------------------
  ; Data sheet
  ;------------------------------------------------------------------------------------------------
  
  #Shortcut_Datasheet_escape                                                                          ; 
  
  #Shortcut_Datasheet_Lookupmodel                                                                     ; 
  
  #Shortcut_Datasheet_Menu_Addpicture                                                                 ; 
  #Shortcut_Datasheet_Menu_Clearpicture                                                               ; 
  #Shortcut_Datasheet_Menu_Deletepicture                                                              ; 
  #Shortcut_Datasheet_Menu_Scanpicture                                                                ; 
  
  #Shortcut_Datasheet_Savemystuff                                                                     ; 
  #Shortcut_Datasheet_AddPicture                                                                      ; 
  #Shortcut_Datasheet_Scanpicture                                                                     ; 
  #Shortcut_Datasheet_ScanDocument                                                                    ; 
  #Shortcut_Datasheet_AddDocument                                                                     ; 
  #Shortcut_Datasheet_ViewDocument                                                                    ; 
  #Shortcut_Datasheet_RelinkDocument                                                                  ; 
  #Shortcut_Datasheet_ExitMyStuff                                                                     ; 
  
  #Shortcut_ViewDocument_Escape                                                                       ; 
  
  ;------------------------------------------------------------------------------------------------
  ; Picture viewer
  ;------------------------------------------------------------------------------------------------
  
  #Shortcut_Pictureofstuff_Escape                                                                     ; 
  
  ;------------------------------------------------------------------------------------------------
  ; Keyboard shortcuts viewer
  ;------------------------------------------------------------------------------------------------
  
  #Shortcut_Keyboardshortcuts_Escape                                                                  ; 
  
  ;------------------------------------------------------------------------------------------------
  ; Hidden administrative functions
  ;------------------------------------------------------------------------------------------------
  
  #Shortcut_Mystuff_ImportMyDocuments                                                                 ; 
  
  ;------------------------------------------------------------------------------------------------
  ;  Locations popup menu
  ;------------------------------------------------------------------------------------------------
  
  #PopMenuBar_Location
  #PopMenuBar_Location_Addlocation                                                                    ; 
  #PopMenuBar_Location_Copylocation                                                                   ; 
  #PopMenuBar_Location_Deletelocation                                                                 ; 
  #PopMenuBar_Location_Editlocation                                                                   ; 
  #PopMenuBar_Location_Exportlocations                                                                ; 
  #PopMenuBar_Location_Importlocations                                                                ; 
  
  ;------------------------------------------------------------------------------------------------
  ;  My stuff popup menu
  ;------------------------------------------------------------------------------------------------
  
  #PopMenuBar_Mystuff
  #PopMenuBar_Mystuff_Addnewstuff                                                                     ; 
  #PopMenuBar_Mystuff_Copyoldstuff                                                                    ; 
  #PopMenuBar_Mystuff_Deleteoldstuff                                                                  ; 
  #PopMenuBar_Mystuff_Editoldstuff                                                                    ; 
  #PopMenuBar_Mystuff_Killthisstuff                                                                   ; 
  #PopMenuBar_Mystuff_Lockthisstuff                                                                   ; 
  #PopMenuBar_Mystuff_Favouritestuff                                                                  ; 
  #PopMenuBar_Mystuff_Printthisstuff                                                                  ; 
  #PopMenubar_Mystuff_Pictureofstuff                                                                  ; 
  
  ;------------------------------------------------------------------------------------------------
  ; Data sheet picture popup
  ;------------------------------------------------------------------------------------------------
  
  #PopMenuBar_Datasheet                                                                               ; 
  #PopMenubar_Datasheet_Menu_Addpicture                                                               ; 
  #PopMenuBar_Datasheet_Menu_Clearpicture                                                             ; 
  #PopMenuBar_Datasheet_Menu_Deletepicture                                                            ; 
  #PopMenuBar_Datasheet_Menu_Scanpicture                                                              ; 
EndEnumeration
  
;==============================================================================================================================================================================
; Any image enumerations
;==============================================================================================================================================================================

Enumeration #ImageIndex                                                                              ; 
  ; Program icon
  #Image_Program_Mystuff                                                                              ; 
  
  ; Standard item name icon
  #Image_List_Title                                                                                   ; 
  
  ; Standard locationbar icons
  #Image_Location_Allmystuff                                                                          ; 
  #Image_Location_Notitlenames                                                                        ;  
  #Image_Location_Nolocations                                                                         ; 
  #Image_Location_Deletedstuff                                                                        ; 
  #Image_Location_Favouritestuff                                                                      ; 
  #Image_Location_Lockedstuff                                                                         ; 
  #Image_Location_Loanedstuff                                                                         ; 
  #Image_Location_Normalstuff                                                                         ; 
  
  ; Combobox icons
  #Image_Combo_Sqltype                                                                                ; 
  #Image_Combo_Sqlfield                                                                               ; 
  #Image_Combo_Sqllocation                                                                            ; 
  
  ; Miscellaneous menu bar icons for the keyboard shortcuts list
  #MenuBarIcon_Mystuff_Blank                                                                          ; 
  #MenuBarIcon_Mystuff_Clearmystuff                                                                   ; 
  #MenuBarIcon_Mystuff_Savemystuff                                                                    ; 
  #MenuBarIcon_Mystuff_Scanthisstuff                                                                  ; 
  
  ; Datasheet combobox icons
  #Image_Datasheet_Unknown                                                                            ; 
  #Image_Datasheet_Banktransfer                                                                       ; 
  #Image_Datasheet_Cash                                                                               ; 
  #Image_Datasheet_Cheque                                                                             ; 
  #Image_Datasheet_Eftpos                                                                             ; 
  #Image_Datasheet_Mastercard                                                                         ; 
  #Image_Datasheet_Paypal                                                                             ; 
  #Image_Datasheet_Visa                                                                               ; 
EndEnumeration  

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

CatchImage(#Image_Program_Mystuff,              ?_Image_Program_Mystuff)                              ; 

CatchImage(#Image_List_Title,                   ?_Image_List_Title)                                   ; 
  
CatchImage(#Image_Location_Allmystuff,          ?_Image_Location_Allmystuff)                          ; 
CatchImage(#Image_Location_Notitlenames,        ?_Image_Location_Notitlenames)                        ;  
CatchImage(#Image_Location_Nolocations,         ?_Image_Location_Nolocations)                         ;
CatchImage(#Image_Location_Deletedstuff,        ?_Image_Location_Deletedstuff)                        ;
CatchImage(#Image_Location_Favouritestuff,      ?_Image_Location_Favouritestuff)                      ;
CatchImage(#Image_Location_Lockedstuff,         ?_Image_Location_Lockedstuff)                         ;
CatchImage(#Image_Location_Loanedstuff,         ?_Image_Location_Loanedstuff)                         ;
CatchImage(#Image_Location_Normalstuff,         ?_Image_Location_Normalstuff)                         ;

CatchImage(#Image_Combo_Sqltype,                ?_Image_Combo_Sqltype)                                ; 
CatchImage(#Image_Combo_Sqlfield,               ?_Image_Combo_Sqlfield)                               ; 
CatchImage(#Image_Combo_Sqllocation,            ?_Image_Combo_Sqllocation)                            ; 

CatchImage(#MenuBarIcon_Mystuff_Blank,          ?_Image_Menubaricon_Blank)                            ; 
CatchImage(#MenuBarIcon_Mystuff_Clearmystuff,   ?_Image_Menubaricon_Clear)                            ; 
CatchImage(#MenuBarIcon_Mystuff_Savemystuff,    ?_Image_Menubaricon_Save)                             ; 
CatchImage(#MenuBarIcon_Mystuff_Scanthisstuff,  ?_Image_Menubaricon_Scan)                             ; 

CatchImage(#Image_Datasheet_Unknown,            ?_Image_Datasheet_Unknown)                            ; 
CatchImage(#Image_Datasheet_Banktransfer,       ?_Image_Datasheet_Banktransfer)                       ; 
CatchImage(#Image_Datasheet_Cash,               ?_Image_Datasheet_Cash)                               ; 
CatchImage(#Image_Datasheet_Cheque,             ?_Image_Datasheet_Cheque)                             ; 
CatchImage(#Image_Datasheet_Eftpos,             ?_Image_Datasheet_Eftpos)                             ; 
CatchImage(#Image_Datasheet_Mastercard,         ?_Image_Datasheet_Mastercard)                         ; 
CatchImage(#Image_Datasheet_Paypal,             ?_Image_Datasheet_Paypal)                             ; 
CatchImage(#Image_Datasheet_Visa,               ?_Image_Datasheet_Visa)                               ; 

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

DataSection
  
  ;----------------------------------------------
  ; About readme file
  ;----------------------------------------------

  _MGB_AboutMystuff:                              : IncludeBinary "Help\AboutMystuff.rtf"            ; 
  
  _Image_Program_Mystuff:                         : IncludeBinary "Images\_16x16\Mystuff.ico"        ; 
  
  _Image_List_Title:                              : IncludeBinary "Images\_16x16\Mystuff.ico"        ; 

  ; All location icons
  
  _Image_Location_Allmystuff:                     : IncludeBinary "Images\_16x16\All.ico"            ; 
  _Image_Location_Notitlenames:                   : IncludeBinary "Images\_16x16\Empty.ico"          ; 
  _Image_Location_Nolocations:                    : IncludeBinary "Images\_16x16\Category.ico"       ; 
  _Image_Location_Deletedstuff:                   : IncludeBinary "Images\_16x16\Deleted.ico"        ; 
  _Image_Location_Favouritestuff:                 : IncludeBinary "Images\_16x16\Favourite.ico"      ; 
  _Image_Location_Lockedstuff:                    : IncludeBinary "Images\_16x16\Locked.ico"         ; 
  _Image_Location_Loanedstuff:                    : IncludeBinary "Images\_16x16\Loan.ico"           ; 
  _Image_Location_Normalstuff:                    : IncludeBinary "Images\_16x16\Homepage.ico"       ;
  
  _Image_Combo_Sqltype:                           : IncludeBinary "Images\_16x16\Sql.ico"            ; 
  _Image_Combo_Sqlfield:                          : IncludeBinary "Images\_16x16\Field.ico"          ; 
  _Image_Combo_Sqllocation:                       : IncludeBinary "Images\_16x16\Home.ico"           ; 

  _Image_Menubaricon_Blank:                       : IncludeBinary "Images\_16x16\Empty.ico"          ; 
  _Image_Menubaricon_Clear:                       : IncludeBinary "Images\_16x16\Clear.ico"          ; 
  _Image_Menubaricon_Save:                        : IncludeBinary "Images\_16x16\Save.ico"           ; 
  _Image_Menubaricon_Scan:                        : IncludeBinary "Images\_16x16\Scan.ico"           ; 
  
  _Image_Datasheet_Unknown:                       : IncludeBinary "Images\_16x16\Unknown.ico"        ; 
  _Image_Datasheet_Banktransfer:                  : IncludeBinary "Images\_16x16\Banktransfer.ico"   ; 
  _Image_Datasheet_Cash:                          : IncludeBinary "Images\_16x16\Cash.ico"           ; 
  _Image_Datasheet_Cheque:                        : IncludeBinary "Images\_16x16\Cheque.ico"         ; 
  _Image_Datasheet_Eftpos:                        : IncludeBinary "Images\_16x16\Eftpos.ico"         ; 
  _Image_Datasheet_Mastercard:                    : IncludeBinary "Images\_16x16\Mastercard.ico"     ; 
  _Image_Datasheet_Paypal:                        : IncludeBinary "Images\_16x16\Paypal.ico"         ; 
  _Image_Datasheet_Visa:                          : IncludeBinary "Images\_16x16\Visa.ico"           ; 
  
  BeginSearchTypes:
  
  Data.s  "Sounds like"                                                                               ; 
  Data.s  "Equal to"                                                                                  ; 
  Data.s  "Does not equal"                                                                            ; 
  Data.s  "Greater than"                                                                              ; 
  Data.s  "Greater than or equal to"                                                                  ; 
  Data.s  "Less than"                                                                                 ; 
  Data.s  "Less than or equal to"                                                                     ; 
  Data.s  "Starts with"                                                                               ; 
  Data.s  "Ends with"                                                                                 ; 
  Data.s  "_EndSearchTypes_"                                                                          ; 
  
  BeginPaymentTypes:
  
  Data.s  "Unknown"                                                                                   ; 
  Data.s  "Bank transfer"                                                                             ; 
  Data.s  "Cash"                                                                                      ; 
  Data.s  "Cheque"                                                                                    ; 
  Data.s  "Eftpos"                                                                                    ; 
  Data.s  "Mastercard"                                                                                ; 
  Data.s  "Paypal"                                                                                    ; 
  Data.s  "Visa"                                                                                      ; 
  Data.s  "_EndPaymentTypes_"                                                                         ; 
  
  BeginSqlFields:
  
  Data.s "All fields"                                                                                 ; 
  Data.s "Itemname"                                                                                   ; 
  Data.s "Supplier"                                                                                   ; 
  Data.s "Manufacturer"                                                                               ; 
  Data.s "Modelnumber"                                                                                ; 
  Data.s "Serialnumber"                                                                               ; 
  Data.s "Barcode"                                                                                    ; 
  Data.s "Boughton"                                                                                   ; 
  Data.s "Working"                                                                                    ; 
  Data.s "Whopaid"                                                                                    ; 
  Data.s "Ownername"                                                                                  ; 
  Data.s "Location"                                                                                   ; 
  Data.s "Condition"                                                                                  ; 
  Data.s "Importance"                                                                                 ; 
  Data.s "Loanedto"                                                                                   ; 
  Data.s "Category"                                                                                   ; 
  Data.s "Comments"                                                                                   ; 
  Data.s "Itempicture"                                                                                ; 
  Data.s "Cost"                                                                                       ; 
  Data.s "Tax"                                                                                        ; 
  Data.s "Delivery"                                                                                   ; 
  Data.s "Othercost"                                                                                  ; 
  Data.s "Resale"                                                                                     ; 
  Data.s "Paidby"                                                                                     ; 
  Data.s "Warrantyperiod"                                                                             ; 
  Data.s "Warrantyword"                                                                               ; 
  Data.s "Warrantyactive"                                                                             ; 
  Data.s "Warrantyextra"                                                                              ; 
  Data.s "Insured"                                                                                    ; 
  Data.s "Insuredamount"                                                                              ; 
  Data.s "Insuredon"                                                                                  ; 
  Data.s "Insurername"                                                                                ; 
  Data.s "Policynumber"                                                                               ; 
  Data.s "Contactnumber"                                                                              ; 
  Data.s "Contactname"                                                                                ; 
  Data.s "Contactdepartment"                                                                          ; 
  Data.s "Deleted"                                                                                    ; 
  Data.s "Favourite"                                                                                  ; 
  Data.s "Locked"                                                                                     ; 
  Data.s "Mystuffid"                                                                                  ; 
  Data.s "_EndSqlFields_"                                                                             ; 
  
  BeginSqlLocations:

  Data.s "All my stuff"                                                                               ; 
  Data.s "No titles"                                                                                  ; 
  Data.s "No locations"                                                                               ; 
  Data.s "Deleted"                                                                                    ; 
  Data.s "Favourite"                                                                                  ; 
  Data.s "Locked"                                                                                     ; 
  Data.s "_EndSqlLocations_"                                                                          ; 

EndDataSection

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 192
; FirstLine = 186
; EnableAsm
; EnableUnicode
; EnableXP