﻿;==============================================================================================================================================================================
; Set and display button toolbar/menu text in the statusbar
;==============================================================================================================================================================================

Procedure StatusBarButtonTip(WindowNumber.i, ButtonItem.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select WindowNumber.i
      
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
      
    Case #Window_Mystuff
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Select ButtonItem.s
          
        ;------------------------------------------------------------------------------------------
        ; Main form buttons
        ;------------------------------------------------------------------------------------------
          
        Case "Addnewstuff"      : Message.s = #Keystext_MyStuff_Addnewstuff       + ", ShortCut:  "  + GetShortCutText(#Keys_MyStuff_Addnewstuff)
          
        Case "Copyoldstuff"     : Message.s = #Keystext_MyStuff_Copyoldstuff      + ", ShortCut:  "  + GetShortCutText(#Keys_MyStuff_Copyoldstuff)
          
        Case "Deleteoldstuff"   : Message.s = #Keystext_MyStuff_Deleteoldstuff    + ", ShortCut:  "  + GetShortCutText(#Keys_MyStuff_Deleteoldstuff)
          
        Case "Editthisstuff"    : Message.s = #Keystext_Mystuff_Editoldstuff      + ", ShortCut:  "  + GetShortCutText(#Keys_Mystuff_Editoldstuff)
          
        Case "Killthistuff"     : Message.s = #Keystext_MyStuff_Killthisstuff     + ", ShortCut:  "  + GetShortCutText(#Keys_Mystuff_Killthisstuff)
          
        Case "Lockthisstuff"    : Message.s = #Keystext_MyStuff_Lockthisstuff     + ", ShortCut:  "  + GetShortCutText(#Keys_MyStuff_Lockthisstuff)
          
        Case "Favouritestuff"   : Message.s = #Keystext_MyStuff_Favouritestuff    + ", ShortCut:  "  + GetShortCutText(#Keys_MyStuff_Favouritestuff)
          
        Case "Printthisstuff"   : Message.s = #Keystext_MyStuff_Printthisstuff    + ", ShortCut:  "  + GetShortCutText(#Keys_MyStuff_Printthisstuff)
          
        Case "Exportmystuff"    : Message.s = #Keystext_MyStuff_Exportmystuff     + ", ShortCut:  "  + GetShortCutText(#Keys_MyStuff_Exportmystuff)
          
        Case "Importmystuff"    : Message.s = #Keystext_MyStuff_Importmystuff     + ", ShortCut:  "  + GetShortCutText(#Keys_MyStuff_Importmystuff)
          
        Case "Helpwithstuff"    : Message.s = #Keystext_Mystuff_Showhelp          + ", ShortCut:  "  + GetShortCutText(#Keys_Mystuff_Showhelp)
          
        Case "Exitthisstuff"    : Message.s = #Keystext_Mystuff_Exitmystuff       + ", ShortCut:  "  + GetShortCutText(#Keys_Mystuff_Exitmystuff)
          
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings", "Button", Message.s, #PB_Compiler_Procedure)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case #Window_Location
      
      Select ButtonItem.s
          
        Case "SaveLocation"     : Message.s = #Keystext_Location_Save             + ", ShortCut:  "  + GetShortCutText(#Keys_Location_Save)
        
        Case "ExitLocation"     : Message.s = #Keystext_Location_Exit             + ", ShortCut:  "  + GetShortCutText(#Keys_Location_Exit)
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings", "Button", Message.s, #PB_Compiler_Procedure)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case #Window_Datasheet
      
      ;--------------------------------------------------------------------------------------------
      ; Data sheet buttons
      ;--------------------------------------------------------------------------------------------
      
      Select ButtonItem.s
          
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
          
        Case "LookupModel"      : Message.s = #Keystext_Datasheet_Lookupmodel     + ", ShortCut:  "  + GetShortCutText(#Keys_Datasheet_Lookupmodel)
          
        Case "SaveMyStuff"      : Message.s = #Keystext_Datasheet_Savemystuff     + ", ShortCut:  "  + GetShortCutText(#Keys_Datasheet_Savemystuff)
          
        Case "AddPicture"       : Message.s = #Keystext_Datasheet_AddPicture      + ", ShortCut:  "  + GetShortCutText(#Keys_Datasheet_AddPicture)
          
        Case "ScanPicture"      : Message.s = #Keystext_Datasheet_ScanPicture     + ", ShortCut:  "  + GetShortCutText(#Keys_Datasheet_ScanPicture)
          
        Case "AddDocument"      : Message.s = #Keystext_Datasheet_AddDocument     + ", ShortCut:  "  + GetShortCutText(#Keys_Datasheet_AddDocument)
         
        Case "ScanDocument"     : Message.s = #Keystext_Datasheet_ScanDocument    + ", ShortCut:  "  + GetShortCutText(#Keys_Datasheet_ScanDocument)
          
        Case "ViewDocument"     : Message.s = #Keystext_Datasheet_ViewDocument    + ", ShortCut:  "  + GetShortCutText(#Keys_Datasheet_ViewDocument)
          
        Case "RelinkDocument"   : Message.s = #Keystext_Datasheet_RelinkDocument  + ", ShortCut:  "  + GetShortCutText(#Keys_Datasheet_RelinkDocument)
          
        Case "ExitMyStuff"      : Message.s = #Keystext_Datasheet_ExitMyStuff     + ", ShortCut:  "  + GetShortCutText(#Keys_Datasheet_ExitMyStuff)
          
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_Datasheet_sStatusbar, Message.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP
; HideErrorLog