;================================================================================================================================================================================
; Get the ID of the last inserted record
;================================================================================================================================================================================

Procedure.s DatabaseLastInsertRowId()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s = "SELECT last_insert_rowid()"
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, QueryString.s) <> #DatabaseQueryFail
  
    If FirstDatabaseRow(Program\DatabaseHandle)
  
      RecordId.s = GetDatabaseString(Program\DatabaseHandle, 0)
  
    EndIf
  
    FinishDatabaseQuery(Program\DatabaseHandle)
   
  Else
    
    RecordId.s = #EmptyString
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn RecordId.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableAsm
; EnableXP