﻿;==========================================================================================================================================================
; One off routine to update the ItemCount field in the Location table from the Location field in the Mystuff table
;==========================================================================================================================================================

Procedure OneTimeLocationUpdateCount()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  NewList LocationName.s()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, "SELECT Location FROM Locations") <> #DatabaseQueryFail
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
      
      AddElement(LocationName.s())
      
      LocationName.s()  = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ForEach LocationName.s()
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      DatabaseQuery.s = "SELECT COUNT(Location) "
      
      DatabaseQuery.s + "AS totalrecs FROM Mystuff "
      
      DatabaseQuery.s + "WHERE Location = '" + RepQuote(LocationName.s()) + "'"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
          
          ItemInCategoryCount.s = GetDatabaseString(Program\DatabaseHandle,  0)
          
        Wend
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        FinishDatabaseQuery(Program\DatabaseHandle)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        DatabaseUpdate.s  = "UPDATE Locations "
        
        DatabaseUpdate.s  + "SET Itemcount = '"   + ItemInCategoryCount.s       + "' "
        
        DatabaseUpdate.s  + "WHERE Location = '"  + RepQuote(LocationName.s())  + "'"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s)
          
          ; Update the Location item count
          
        Else
          
          Debug "The database update failed: " + DatabaseError()
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        Debug "The database query failed: " + DatabaseError()
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Next  LocationName.s()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    Debug "The database query failed: " + DatabaseError()
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
    
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 130
; FirstLine = 94
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP