﻿;==========================================================================================================================================================
; Vacuum wasted space in the database from killed entries
;==========================================================================================================================================================

Procedure Vacuummystuff()
  
  ;------------------------------------------------------------------------------------------------
  ; Ask the user if they want to clear the deleted entries first!!
  ;------------------------------------------------------------------------------------------------
  
  If MessageRequester("Vacuum database", "Clear all the records marked deleted permanently?", #PB_MessageRequester_YesNo | #MB_ICONINFORMATION) = #PB_MessageRequester_Yes
    
    ;----------------------------------------------------------------------------------------------
    ; Vacuum the database of all deleted entries permanently
    ;----------------------------------------------------------------------------------------------
    
    If DatabaseUpdate(Program\DatabaseHandle, "DELETE FROM Mystuff WHERE Deleted = 1")
      
      SetInfoBarArea("Headings", "Info", "Successfully removed all the marked deleted records from the database.", #PB_Compiler_Procedure)
      
      If DatabaseUpdate(Program\DatabaseHandle, "VACUUM")
        
        SetInfoBarArea("Headings", "Info", "Successfully vacuumed wasted space from the database.", #PB_Compiler_Procedure)
        
      Else
        
        SetInfoBarArea("Headings", "Error", "Could not successfully vacuum wasted space from the database:  " + DatabaseError(), #PB_Compiler_Procedure)
        
      EndIf
      
    Else
      
      SetInfoBarArea("Headings", "Error", "Could not successfully remove deleted recipes from the database: " + DatabaseError(), #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Info", "Nothing to do, the user aborted the vacuum process.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 42
; FirstLine = 15
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP