﻿;================================================================================================================================================================================
; AND51's correct file size calculation code
;================================================================================================================================================================================

Procedure.s ByteCalc(Byte.q, NbDecimals.i = 2)

  ;------------------------------------------------------------------------------------------------
  ; Yes Matilda, units of memory are in 1024 bytes!
  ;------------------------------------------------------------------------------------------------

  Protected Unit.b = Round(Log(Byte.q) / Log(1024), 0)

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------

  ProcedureReturn StrD(Byte.q / Pow(1024, Unit.b), NbDecimals.i * (Unit.b & 1)) + " " + StringField("Byte,KB,MB,GB,TB,PB,EB", Unit.b + 1, ",")

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------

EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 7
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP