﻿;==========================================================================================================================================================
; Clean a directory and all of its files no matter what attribute they have
;==========================================================================================================================================================

Procedure CleanDirectory(Directory.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  DirectoryId.i = ExamineDirectory(#PB_Any, Directory.s, "*.*")  ; Delete previous temporary files
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DirectoryId.i
    
    Repeat
      
      TypeOfFile.i  = NextDirectoryEntry(DirectoryId.i) 
      
      FileName.s    = DirectoryEntryName(DirectoryId.i)
      
      If TypeOfFile.i = #True
        
        SetFileAttributes_(Directory.s + DirectoryEntryName(DirectoryId.i), #FILE_ATTRIBUTE_NORMAL)
        
        DeleteFile(Directory.s + DirectoryEntryName(DirectoryId.i), #PB_FileSystem_Force)
        
      EndIf 
      
    Until TypeOfFile.i = #False
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure
; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 28
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP