﻿;==============================================================================================================================================================================
; Update the Location itemcount field each time we add, change or delete locations
;==============================================================================================================================================================================

Procedure UpdateLocationItemCount(LocationName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  LocationName.s  = RepQuote(LocationName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  DatabaseQuery.s = "SELECT COUNT(Location) "
  
  DatabaseQuery.s + "AS totalrecs FROM Mystuff "
  
  DatabaseQuery.s + "WHERE Location = '"  + LocationName.s + "'"
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
      
      LocationCount.s = GetDatabaseString(Program\DatabaseHandle,  0)
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    DatabaseUpdate.s  = "UPDATE Locations "
    
    DatabaseUpdate.s  + "SET Itemcount = '"   + LocationCount.s   + "' "
    
    DatabaseUpdate.s  + "WHERE Location = '"  + LocationName.s    + "'"
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      LocationListCount.i = CountGadgetItems(#Gadget_Mystuff_Locations)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If LocationListCount.i <> #NoItems
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        For FindLocationInList.i = 0 To LocationListCount.i -1
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          LocationInList.s  = GetGadgetItemText(#Gadget_Mystuff_Locations, FindLocationInList.i, #LocationTitleColumn)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If FindString(LocationInList.s, "(", 1) <> #NothingFound
            
            LocationInList.s = Trim(StringField(LocationInList.s, 1, "("))
            
            If LocationInList.s = LocationName.s
              
              SetGadgetItemText(#Gadget_Mystuff_Locations, FindLocationInList.i, LocationInList.s  + " (" + LocationCount.s + ")", #LocationTitleColumn)
              
              SetGadgetItemText(#Gadget_Mystuff_Locations, FindLocationInList.i, LocationCount.s, #LocationItemsColumn)
              
            EndIf
            
          Else
            
            If LocationInList.s = LocationName.s
              
              SetGadgetItemText(#Gadget_Mystuff_Locations, FindLocationInList.i, LocationInList.s  + " (" + LocationCount.s + ")", #LocationTitleColumn)
              
              SetGadgetItemText(#Gadget_Mystuff_Locations, FindLocationInList.i, LocationCount.s, #LocationItemsColumn)
              
            EndIf
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Next FindLocationInList.i
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Warn", "Could not update the Location itemcount.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "Could not get a count of the categories for the Location string.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 150
; FirstLine = 26
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP