﻿;==========================================================================================================================================================
; Delete the existing picture from the display, name field and local storage
;==========================================================================================================================================================

Procedure DeleteOldPicture()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Mystuff\Mystuffid  <>  #EmptyString
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If FileSize(Program\PictureDirectory  + Mystuff\ItemPicture)  <> #NoPictureFound
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DeleteFile(Program\PictureDirectory  + Mystuff\ItemPicture, #PB_FileSystem_Force)  <> #NoFileDeleted
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        ResizeImage(#Image_Datasheet_ItemPicture, #DatasheetPictureWidth, #DatasheetPictureHeight)
        
        SetGadgetState(#Gadget_Datasheet_ItemPicture, ImageID(#Image_Datasheet_ItemPicture))
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetGadgetText(#Gadget_Datasheet_Picturename, #EmptyString)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        DatabaseUpdate.s  = "UPDATE Mystuff "
        
        DatabaseUpdate.s  + "SET "
        
        DatabaseUpdate.s  + "ItemPicture = '"         + #EmptyString      + "' "
        
        DatabaseUpdate.s  + "WHERE Mystuffid  = '"  + Mystuff\Mystuffid + "'"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
          
          SetInfoBarArea("Headings", "Info", "The Picture information has also been deleted from Mystuff for this Picture.", #PB_Compiler_Procedure)
          
        Else
          
          SetInfoBarArea("Headings", "Error", "The Picture information has not been deleted from Mystuff for this Picture:  " + DatabaseError(), #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Error", "Could not delete the existing Picture in the local storage area.", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    
    Else
      
      SetInfoBarArea("Headings", "Error", "The Picture for this record doesn't seem to exist in the local storage area.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------

  Else
    
    SetInfoBarArea("Headings", "Infor", "This is a new record so there is no picture to delete.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 80
; FirstLine = 56
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP