﻿;==========================================================================================================================================================
; Show the current record on the status bar area
;==========================================================================================================================================================

Procedure DisplayMystuffDetails()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_Mystuff_Itemlist)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i  <> #NoCurrentLine
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CurrentTitle.s    = GetGadgetItemText(#Gadget_Mystuff_Itemlist, CurrentLine.i, #NameofitemColumn)
    
    CurrentRecord.s   = GetGadgetItemText(#Gadget_Mystuff_Itemlist, CurrentLine.i, #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If CurrentRecord.s  <> #EmptyString
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      DatabaseQuery.s = "SELECT Itempicture, Itemdocument "
      
      DatabaseQuery.s + "FROM Mystuff "
      
      DatabaseQuery.s + "WHERE Mystuffid = '" + CurrentRecord.s + "'"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
        
        While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
          
          CurrentPicture.s  = KillQuote(GetDatabaseString(Program\DatabaseHandle, 0))
          
          CurrentDocument.s = KillQuote(GetDatabaseString(Program\DatabaseHandle, 1))
          
        Wend
      
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        FinishDatabaseQuery(Program\DatabaseHandle)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If CurrentPicture.s <> #EmptyString
          
          If FileSize(Program\PictureDirectory + CurrentPicture.s) = #FileDoesNotExist
            
            DocumentHeading.s = "Picture: Missing!!"
            
          Else
            
          PictureHeading.s = "Picture:  Yes"

          EndIf
          
        Else
          
          PictureHeading.s = "Picture:  None"
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If CurrentDocument.s <> #EmptyString
          
          If FileSize(Program\DocumentDirectory + CurrentDocument.s) = #FileDoesNotExist
            
            DocumentHeading.s = "Document:  Missing!!"
            
          Else
            
            DocumentHeading.s = "Document:  Yes"
            
          EndIf
        
        Else
          
          DocumentHeading.s = "Document:  None"
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetInfoBarArea("Headings", "Info",    "Title: ["  + CurrentTitle.s + "], "  + PictureHeading.s  + ", "  + DocumentHeading.s, #PB_Compiler_Procedure)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        Clearselections(#Gadget_Mystuff_Messages)
        
        SearchAndColour(#Gadget_Mystuff_Messages, RGB(0, 0, 128),     "Picture: ")
        
        SearchAndColour(#Gadget_Mystuff_Messages, RGB(0, 0, 128),     "Document: ")
        
        SearchAndColour(#Gadget_Mystuff_Messages, RGB(0, 128, 0),     "Yes")
        
        SearchAndColour(#Gadget_Mystuff_Messages, RGB(128, 128, 128), "None")
        
        SearchAndColour(#Gadget_Mystuff_Messages, RGB(255, 0, 0),     "Missing!!")
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetInfoBarArea("Current",             #EmptyString, CurrentRecord.s, #PB_Compiler_Procedure)
      
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Error", "Database query failed or was empty: " + DatabaseError(), #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error", "No record number found on that line.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Info", "No current line selected, nothing to show.", #PB_Compiler_Procedure)
    
  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 169
; FirstLine = 133
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP