﻿;==============================================================================================================================================================================
; Mark this stuff as a favourite
;==============================================================================================================================================================================

Procedure FavouriteStuff()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected CurrentLine.i, CurrentLocation.s, FavouriteState.s, LockedState.s,  DeletedState.s
  
  Protected CurrentRecord.s
  
  ;------------------------------------------------------------------------------------------------
  ; Get the number of the currently highlighted line
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i     = GetGadgetState(#Gadget_Mystuff_Itemlist)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentLocation.s = GetGadgetText(#Gadget_Mystuff_Locations)
  
  ;------------------------------------------------------------------------------------------------
  ; Only continue if a line was selected
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; Get the current toggle states
    ;----------------------------------------------------------------------------------------------
    
    FavouriteState.s = GetGadgetItemText(#Gadget_Mystuff_Itemlist, CurrentLine.i, #FavouriteColumn)
    
    LockedState.s    = GetGadgetItemText(#Gadget_Mystuff_Itemlist, CurrentLine.i, #LockedColumn)
    
    DeletedState.s   = GetGadgetItemText(#Gadget_Mystuff_Itemlist, CurrentLine.i, #DeletedColumn)
    
    CurrentRecord.s  = GetGadgetItemText(#Gadget_Mystuff_Itemlist, CurrentLine.i, #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If LockedState.s <> "1"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DeletedState <> "1"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If  FavouriteState.s = "0"
          
          FavouriteState.s = "1"
          
        ElseIf  FavouriteState.s = "1"
          
          FavouriteState.s = "0"
          
        EndIf        
        
        ;------------------------------------------------------------------------------------------
        ; Proceed if we got a record number
        ;------------------------------------------------------------------------------------------
        
        If CurrentRecord.s  <> #EmptyString
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          DatabaseQuery.s = "UPDATE Mystuff "
          
          DatabaseQuery.s + "SET Favourite = "    + Val(FavouriteState.s)  + " "
          
          DatabaseQuery.s + "WHERE Mystuffid = '"  +    CurrentRecord.s   + "'"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseUpdateFail
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            SetInfoBarArea("Headings", "Info", "Record " + CurrentRecord.s + " has been updated", #PB_Compiler_Procedure)
            
            ;--------------------------------------------------------------------------------------
            ; Set the correct icon in the ListIcongadget for normal or favourite stuff
            ;--------------------------------------------------------------------------------------
            
            If LockedState.s = "1"
              
              SetGadgetItemImage(#Gadget_Mystuff_Itemlist, CurrentLine.i, ImageID(#Image_Location_Lockedstuff))
              
            ElseIf  LockedState.s <> "1"
              
              If DeletedState.s = "1"
                
                SetGadgetItemData(#Gadget_Mystuff_Itemlist, CurrentLine.i, Val(DeletedState.s))
                
                SetGadgetItemImage(#Gadget_Mystuff_Itemlist, CurrentLine.i, ImageID(#Image_Location_Deletedstuff))
                
                RedrawWindow_(GadgetID(#Gadget_Mystuff_Itemlist), 0, 0, #RDW_INVALIDATE | #RDW_ERASE)
                
              ElseIf DeletedState.s <> "1"
                
                If FavouriteState.s = "1"
                  
                  SetGadgetItemImage(#Gadget_Mystuff_Itemlist, CurrentLine.i, ImageID(#Image_Location_Favouritestuff))
                  
                ElseIf FavouriteState.s <> "1"
                  
                  SetGadgetItemImage(#Gadget_Mystuff_Itemlist, CurrentLine.i, ImageID(#Image_Location_Normalstuff))
                  
                EndIf
                
              EndIf
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            SetGadgetItemText(#Gadget_Mystuff_Itemlist, CurrentLine.i, FavouriteState.s, #FavouriteColumn)
            
            ;--------------------------------------------------------------------------------------
            ; Remove the item from the current view if it doesn't match the shown category
            ;--------------------------------------------------------------------------------------
            
            If CurrentLocation.s <> "Favourite stuff" And FavouriteState.s = "1"
              
              If CurrentLocation.s  <> "All my stuff" 
                
                RemoveGadgetItem(#Gadget_Mystuff_Itemlist, CurrentLine.i)
              
              EndIf
            
            ElseIf  CurrentLocation.s = "Favourite stuff" And FavouriteState.s = "0"
            
              RemoveGadgetItem(#Gadget_Mystuff_Itemlist, CurrentLine.i)
            
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Error", "The database update query failed. " + DatabaseError(), #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Warn", "There was no record number found on the current line.", #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Warn", "Cannot mark a deleted stuff as a favourite, unlock it first.", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Warn", "Cannot mark a locked stuff as a favourite, unlock it first.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "There was no current line selected.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure
  
; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 172
; FirstLine = 169
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP