﻿;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Procedure SaveScannedDocumentPages()
  
  ;------------------------------------------------------------------------------------------------  
  ; Finalise and save pdf file
  ;------------------------------------------------------------------------------------------------  
  
  MyStuffEdit\DocumentAndPath.s = SaveFileRequester("Save PDF file", Program\TemporaryDirectory,  "PDF (*.pdf)|*.pdf",  0)

  ;------------------------------------------------------------------------------------------------  
  ; Check that the extension is correct
  ;------------------------------------------------------------------------------------------------  
  
  If LCase(GetExtensionPart(MyStuffEdit\DocumentAndPath.s))  <> "pdf"

    MyStuffEdit\DocumentAndPath.s  + ".pdf"

  EndIf
  
  ;------------------------------------------------------------------------------------------------  
  ; 
  ;------------------------------------------------------------------------------------------------  

  If MyStuffEdit\DocumentAndPath.s <> #EmptyString

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetText(#Gadget_ScanDocument_lTargetdocument, GetFilePart(MyStuffEdit\DocumentAndPath.s))
    
    SetGadgetText(#Gadget_Datasheet_Documentname,       GetFilePart(MyStuffEdit\DocumentAndPath.s))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If MyStuffEdit\DocumentAndPath.s
      
      pdf_Save(MyStuffEdit\DocumentAndPath.s)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Not AquireDocument(GetGadgetState(#Gadget_ScanDocument_Imagetype) + 1, lQuality, #True)
      
      MessageRequester("Scan2PDF",  "Could not reset PDF Engine, please restart application.")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetText(#Gadget_ScanDocument_bScannext, "Scan Next Page")
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    DisableGadget(#Gadget_ScanDocument_bFinish, #True)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Info",  "Nothing to save, user cancelled the process.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------  
  ; 
  ;------------------------------------------------------------------------------------------------  

EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 40
; FirstLine = 29
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP