﻿;==========================================================================================================================================================
; Scan an attachment into the current record
;==========================================================================================================================================================

Procedure ScanDocument()
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If Window_ScanDocument()  <> #NoWindowId
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    WindowTitleString.s = GetWindowTitle(#Window_Datasheet)
    
    RecordNumber.s      = StringField(WindowTitleString.s, 2, ": ")
    
    RecordNumber.s      = RemoveString(RecordNumber.s, "?", #PB_String_NoCase, 1)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    SetWindowTitle(#Window_ScanDocument, "Scan a new document for record: " + RecordNumber.s)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    AddGadgetItem(#Gadget_ScanDocument_Imagetype,     #AtTheEndOfTheList, "Black & White")
    
    AddGadgetItem(#Gadget_ScanDocument_Imagetype,     #AtTheEndOfTheList, "GrayScale")
    
    AddGadgetItem(#Gadget_ScanDocument_Imagetype,     #AtTheEndOfTheList, "Colour (Photo)")
    
    SetGadgetState(#Gadget_ScanDocument_Imagetype,    ReadPreferenceInteger("Colour Index", 2))
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    AddGadgetItem(#Gadget_ScanDocument_Imagequality,  #AtTheEndOfTheList, "  75 dpi")
    
    AddGadgetItem(#Gadget_ScanDocument_Imagequality,  #AtTheEndOfTheList, " 100 dpi")
    
    AddGadgetItem(#Gadget_ScanDocument_Imagequality,  #AtTheEndOfTheList, " 150 dpi")
    
    AddGadgetItem(#Gadget_ScanDocument_Imagequality,  #AtTheEndOfTheList, " 300 dpi")
    
    AddGadgetItem(#Gadget_ScanDocument_Imagequality,  #AtTheEndOfTheList, " 600 dpi")
    
    AddGadgetItem(#Gadget_ScanDocument_Imagequality,  #AtTheEndOfTheList, "1200 dpi")
    
    SetGadgetState(#Gadget_ScanDocument_Imagequality, ReadPreferenceInteger("Quality Index",  3))
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetText(#Gadget_ScanDocument_lTargetdocument, #EmptyString)
    
    ;----------------------------------------------------------------------------------------------
    ; Disable finish button until we actually have a page to save
    ;----------------------------------------------------------------------------------------------
    
    DisableGadget(#Gadget_ScanDocument_bFinish, #True)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

  Else
    
    SetInfoBarArea("Headings",  "Error",  "Could not open the ScanDocument window", #PB_Compiler_Procedure)
    
  EndIf

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 76
; FirstLine = 39
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP