﻿;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Procedure ScanNextDocumentPage()
  
  ;------------------------------------------------------------------------------------------------  
  ; Get dpi for page here. Colour depth is in order of index + 1
  ;------------------------------------------------------------------------------------------------  
  
  Select  GetGadgetState(#Gadget_ScanDocument_Imagequality)
      
    Case 0  :           lQuality =   75
      
    Case 1  :           lQuality =  100
      
    Case 2  :           lQuality =  150
      
    Case 3  :           lQuality =  300
      
    Case 4  :           lQuality =  600
      
    Case 5  :           lQuality = 1200
      
    Default :           lQuality =   75
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------  
  ; 
  ;------------------------------------------------------------------------------------------------  
  
  DisableGadget(#Gadget_ScanDocument_bScannext, #True)
  
  DisableGadget(#Gadget_ScanDocument_bFinish,   #True)
  
  ;------------------------------------------------------------------------------------------------  
  ; 
  ;------------------------------------------------------------------------------------------------  
  
  If AquireDocument(GetGadgetState(#Gadget_ScanDocument_Imagetype) + 1, lQuality, 0)
    
    ; We have at least one page to save so enable the finish button
    
    DisableGadget(#Gadget_ScanDocument_bFinish, #False)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------  
  ; 
  ;------------------------------------------------------------------------------------------------  
  
  DisableGadget(#Gadget_ScanDocument_bScannext, #False)
  
  ;------------------------------------------------------------------------------------------------  
  ; 
  ;------------------------------------------------------------------------------------------------  
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 52
; FirstLine = 15
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP