﻿;==========================================================================================================================================================
; View the attached document on top of the data sheet
;==========================================================================================================================================================

Procedure ViewDocument()
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If MyStuffEdit\DocumentAndPath.s  =  #EmptyString                                               ; Use the existing document and path in local storage
    
    DocumentName.s  = Program\DocumentDirectory + GetGadgetText(#Gadget_Datasheet_Documentname)
    
  ElseIf  MyStuffEdit\DocumentAndPath.s  <>  #EmptyString                                         ; Use the newly scanned document and path
    
    DocumentName.s = MyStuffEdit\DocumentAndPath.s
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If GetFilePart(DocumentName.s)  <> #EmptyString
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    If Window_ViewDocument()  <> #NoWindowId
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
      AddKeyboardShortcut(#Window_ViewDocument, #Keys_ViewDocument_Escape, #Shortcut_ViewDocument_Escape)
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_Viewdocument_Document,  DocumentName.s)
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
  
    Else
      
      SetInfoBarArea("Headings",  "Error",  "Could not open the document viewer", #PB_Compiler_Procedure)
      
    EndIf
  
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Info",  "There is no local or scanned document to view", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 36
; FirstLine = 21
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP