;================================================================================================================================================================================
; 
;================================================================================================================================================================================

Procedure Editor_Save(Gadget.i, FileName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If FileName.s <> #EmptyString
    
    If LCase(GetExtensionPart(FileName.s)) <> "rtf"
      
      FileName.s + ".rtf"
      
    EndIf
      
    RtfFile.i = CreateFile(#PB_Any, FileName.s)
  
    If RtfFile.i
  
      stream.EDITSTREAM
  
      stream\dwCookie    = 1
  
      stream\pfnCallback = @Editor_StreamCallback()
  
      SendMessage_(GadgetID(Gadget.i), #EM_STREAMOUT, #SF_RTF, @stream)
     
      CloseFile(RtfFile.i)
  
    Else
      
      Debug "Error, Could not create output file."
      
    EndIf
    
  Else
    
    Debug "Error, No filename specified by user."
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure 
; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 40
; Folding = -
; EnableAsm
; EnableXP