﻿;================================================================================================================================================================================
; 
;================================================================================================================================================================================

Procedure PrintEditorGadgetText(WindowHandle, hInst, RtfEditorGadget, LM, RM, TM, BM)
 
  pd.PRINTDLG
 
  pd\lStructSize          = SizeOf(PRINTDLG)
  
  pd\hwndOwner            = WindowHandle
  
  pd\hDevMode             = 0
  
  pd\hDevNames            = 0
  
  pd\nFromPage            = 0
  
  pd\nToPage              = 0
  
  pd\nMinPage             = 0
  
  pd\nMaxPage             = 0
  
  pd\nCopies              = 0
  
  pd\hInstance            = hInst
  
  pd\Flags                = #PD_HIDEPRINTTOFILE | #PD_NONETWORKBUTTON | #PD_RETURNDC | #PD_PRINTSETUP
  
  pd\lpfnSetupHook        = 0
  
  pd\lpSetupTemplateName  = 0
  
  pd\lpfnPrintHook        = 0
  
  pd\lpPrintTemplateName  = 0
   
  If PrintDlg_(pd)
    
    PrinterDeviceContext = pd\hDC
    
  Else
    
    PrinterDeviceContext = DefaultPrinter()
    
  EndIf
 
  If PrinterDeviceContext
    
    cxPhysOffset  = GetDeviceCaps_(PrinterDeviceContext, #PHYSICALOFFSETX)
    
    cyPhysOffset  = GetDeviceCaps_(PrinterDeviceContext, #PHYSICALOFFSETY)
   
    cxPhys        = GetDeviceCaps_(PrinterDeviceContext, #PHYSICALWIDTH)
    
    cyPhys        = GetDeviceCaps_(PrinterDeviceContext, #PHYSICALHEIGHT)
    
    SendMessage_(RtfEditorGadget, #EM_SETTARGETDEVICE, PrinterDeviceContext, cxPhys  * 20)

    fr.FORMATRANGE
    
    fr\hdc            = PrinterDeviceContext
    
    fr\hdcTarget      = PrinterDeviceContext
   
    fr\chrg\cpMin     = 0
    
    fr\chrg\cpMax     = -1

    fr\rcPage\left    = 0
    
    fr\rcPage\top     = 0
    
    fr\rcpage\right   = 0
    
    fr\rcPage\bottom  = 0
   
    fr\rc\left        = LM  * 20
    
    fr\rc\top         = TM  * 20
    
    fr\rc\right       = cxPhys * 1440 / GetDeviceCaps_(PrinterDeviceContext, #LOGPIXELSX)- RM * 20
    
    fr\rc\Bottom      = cyPhys * 1440 / GetDeviceCaps_(PrinterDeviceContext, #LOGPIXELSY)- BM * 20
   
    StartEditorGadgetPrint("Help File Printing")
    
    StartPage_(PrinterDeviceContext)
   
    iTextOut = 0
    
    iTextAmt = SendMessage_(RtfEditorGadget, #WM_GETTEXTLENGTH, 0, 0)
    
    While iTextOut  < iTextAmt
      
      iTextOut = SendMessage_(RtfEditorGadget, #EM_FORMATRANGE, 1, fr)
      
      If iTextOut < iTextAmt
        
        EndPage_(PrinterDeviceContext)
        
        StartPage_(PrinterDeviceContext)
        
        fr\chrg\cpMin = iTextOut
        
        fr\chrg\cpMax = -1
        
        iTextAmt      = iTextAmt - iTextOut
        
        iTextOut      = 0
        
      EndIf
      
    Wend
    
    SendMessage_(RtfEditorGadget, #EM_FORMATRANGE, 0, 0)
    
    EndPage_(PrinterDeviceContext)
    
    EndDoc_(PrinterDeviceContext)
    
    DeleteDC_(PrinterDeviceContext)
    
  EndIf  
  
EndProcedure

; typedef struct _formatrange {
;   HDC       hdc;
;   HDC       hdcTarget;
;   RECT      rc;
;   RECT      rcPage;
;   CHARRANGE chrg;
; } FORMATRANGE;
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 58
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP