;==========================================================================================================================================================
; Show the program window now
;==========================================================================================================================================================

Procedure ShowProgramWindow()

  ;------------------------------------------------------------------------------------------------
  ; Set tray semaphore to show that we don't need it
  ;------------------------------------------------------------------------------------------------
  
  Program\TrayState = #False

  ;------------------------------------------------------------------------------------------------
  ; Remove the tray ico, not needed any more
  ;------------------------------------------------------------------------------------------------

  RemoveSysTrayIcon(#Systray_Mystuff_Tray)

  ;------------------------------------------------------------------------------------------------
  ; Unhide the window now
  ;------------------------------------------------------------------------------------------------

  HideWindow(#Window_Mystuff, #False)

  ;------------------------------------------------------------------------------------------------
  ; Unhiding doesn't show the window sadly
  ;------------------------------------------------------------------------------------------------

  SetWindowState(#Window_Mystuff, #PB_Window_Normal)

  ;------------------------------------------------------------------------------------------------
  ; Un-hiding the window brings it to the front
  ;------------------------------------------------------------------------------------------------

  SetActiveWindow(#Window_Mystuff)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 16
; Folding = -
; EnableXP