;==============================================================================================================================================================================
; Turn time updating on in the title bar
;==============================================================================================================================================================================

Procedure ToggleShowClock()

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If Option\Showtitlebarclock = #True
  
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

    Option\Showtitlebarclock = #False
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

    KillTimer_(WindowID(#Window_MyStuff), #TitleBarClockTimerEvent)

    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

    SetDate(#Window_MyStuff)

    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

    Message.s = "Showing a real time clock in the program titlebar has been turned off."

    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

  ElseIf Option\Showtitlebarclock = #False
  
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

    Option\Showtitlebarclock = #True

    ;----------------------------------------------------------------------------------------------
    ; Create the permanent timer
    ;----------------------------------------------------------------------------------------------

    SetTimer_(WindowID(#Window_MyStuff), #TitleBarClockTimerEvent, 1000, @TitleBarClock())    ; 1000 = 1 second

    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

    Message.s = "Showing a real time clock in the program titlebar has been turned on."

    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

  EndIf

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  SetMenuItemState(#Window_MyStuff,  #MenuBar_MyStuff_Showtitlebarclock, Option\Showtitlebarclock)

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  SetInfoBarArea("Headings", "Info", Message.s, #PB_Compiler_Procedure)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------

EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 58
; FirstLine = 47
; Folding = -
; EnableXP