﻿;==============================================================================================================================================================================
; Turn sticking on top of other windows on or off
;==============================================================================================================================================================================

Procedure ToggleStickyWindow()

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If Option\Stickwindowontop = #True
  
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

    Option\Stickwindowontop = #False
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    StickyWindow(#Window_MyStuff, #False)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    Message.s = "Sticking on top of other forms has now been turned off." 
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

  ElseIf Option\Stickwindowontop = #False
  
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

    Option\Stickwindowontop = #True
    
    ;----------------------------------------------------------------------------------------------
    ; Load the StickyWindow for the main window
    ;----------------------------------------------------------------------------------------------
  
    StickyWindow(#Window_MyStuff, #True)

    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

    Message.s = "Sticking on top of other forms has now been turned on."
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

  EndIf

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------

  SetMenuItemState(#MenuBar_MyStuff,  #MenuBar_MyStuff_Stickwindowontop,  Option\Stickwindowontop)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  SetInfoBarArea("Headings", "Info", Message.s, #PB_Compiler_Procedure)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 70
; FirstLine = 36
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP